"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OperatorConfiguration = void 0;
const IoK8sApimachineryPkgApisMetaV1ObjectMeta_1 = require("@kubernetes-models/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta");
const base_1 = require("@kubernetes-models/base");
const validate_1 = require("@kubernetes-models/validate");
const schemaId = "acid.zalan.do.v1.OperatorConfiguration";
const schema = {
    "type": "object",
    "properties": {
        "kind": {
            "type": "string",
            "enum": [
                "OperatorConfiguration"
            ]
        },
        "apiVersion": {
            "type": "string",
            "enum": [
                "acid.zalan.do/v1"
            ]
        },
        "configuration": {
            "type": "object",
            "properties": {
                "crd_categories": {
                    "type": "array",
                    "nullable": true,
                    "items": {
                        "type": "string"
                    }
                },
                "docker_image": {
                    "type": "string",
                    "default": "registry.opensource.zalan.do/acid/spilo-14:2.1-p6",
                    "nullable": true
                },
                "enable_crd_registration": {
                    "type": "boolean",
                    "default": true,
                    "nullable": true
                },
                "enable_crd_validation": {
                    "type": "boolean",
                    "default": true,
                    "nullable": true
                },
                "enable_lazy_spilo_upgrade": {
                    "type": "boolean",
                    "default": false,
                    "nullable": true
                },
                "enable_pgversion_env_var": {
                    "type": "boolean",
                    "default": true,
                    "nullable": true
                },
                "enable_shm_volume": {
                    "type": "boolean",
                    "default": true,
                    "nullable": true
                },
                "enable_spilo_wal_path_compat": {
                    "type": "boolean",
                    "default": false,
                    "nullable": true
                },
                "etcd_host": {
                    "type": "string",
                    "default": "",
                    "nullable": true
                },
                "kubernetes_use_configmaps": {
                    "type": "boolean",
                    "default": false,
                    "nullable": true
                },
                "max_instances": {
                    "type": "integer",
                    "default": -1,
                    "minimum": -1,
                    "nullable": true
                },
                "min_instances": {
                    "type": "integer",
                    "default": -1,
                    "minimum": -1,
                    "nullable": true
                },
                "resync_period": {
                    "type": "string",
                    "default": "30m",
                    "nullable": true
                },
                "repair_period": {
                    "type": "string",
                    "default": "5m",
                    "nullable": true
                },
                "set_memory_request_to_limit": {
                    "type": "boolean",
                    "default": false,
                    "nullable": true
                },
                "sidecar_docker_images": {
                    "type": "object",
                    "additionalProperties": {
                        "type": "string"
                    },
                    "properties": {},
                    "nullable": true
                },
                "sidecars": {
                    "type": "array",
                    "nullable": true,
                    "items": {
                        "type": "object",
                        "properties": {}
                    }
                },
                "workers": {
                    "type": "integer",
                    "default": 8,
                    "minimum": 1,
                    "nullable": true
                },
                "users": {
                    "type": "object",
                    "properties": {
                        "additional_owner_roles": {
                            "type": "array",
                            "nullable": true,
                            "items": {
                                "type": "string"
                            }
                        },
                        "enable_password_rotation": {
                            "type": "boolean",
                            "default": false,
                            "nullable": true
                        },
                        "password_rotation_interval": {
                            "type": "integer",
                            "default": 90,
                            "nullable": true
                        },
                        "password_rotation_user_retention": {
                            "type": "integer",
                            "default": 180,
                            "nullable": true
                        },
                        "replication_username": {
                            "type": "string",
                            "default": "standby",
                            "nullable": true
                        },
                        "super_username": {
                            "type": "string",
                            "default": "postgres",
                            "nullable": true
                        }
                    },
                    "nullable": true
                },
                "major_version_upgrade": {
                    "type": "object",
                    "properties": {
                        "major_version_upgrade_mode": {
                            "type": "string",
                            "default": "off",
                            "nullable": true
                        },
                        "major_version_upgrade_team_allow_list": {
                            "type": "array",
                            "items": {
                                "type": "string"
                            },
                            "nullable": true
                        },
                        "minimal_major_version": {
                            "type": "string",
                            "default": "9.6",
                            "nullable": true
                        },
                        "target_major_version": {
                            "type": "string",
                            "default": "14",
                            "nullable": true
                        }
                    },
                    "nullable": true
                },
                "kubernetes": {
                    "type": "object",
                    "properties": {
                        "additional_pod_capabilities": {
                            "type": "array",
                            "items": {
                                "type": "string"
                            },
                            "nullable": true
                        },
                        "cluster_domain": {
                            "type": "string",
                            "default": "cluster.local",
                            "nullable": true
                        },
                        "cluster_labels": {
                            "type": "object",
                            "additionalProperties": {
                                "type": "string"
                            },
                            "default": {
                                "application": "spilo"
                            },
                            "properties": {},
                            "nullable": true
                        },
                        "cluster_name_label": {
                            "type": "string",
                            "default": "cluster-name",
                            "nullable": true
                        },
                        "custom_pod_annotations": {
                            "type": "object",
                            "additionalProperties": {
                                "type": "string"
                            },
                            "properties": {},
                            "nullable": true
                        },
                        "delete_annotation_date_key": {
                            "type": "string",
                            "nullable": true
                        },
                        "delete_annotation_name_key": {
                            "type": "string",
                            "nullable": true
                        },
                        "downscaler_annotations": {
                            "type": "array",
                            "items": {
                                "type": "string"
                            },
                            "nullable": true
                        },
                        "enable_cross_namespace_secret": {
                            "type": "boolean",
                            "default": false,
                            "nullable": true
                        },
                        "enable_init_containers": {
                            "type": "boolean",
                            "default": true,
                            "nullable": true
                        },
                        "enable_pod_antiaffinity": {
                            "type": "boolean",
                            "default": false,
                            "nullable": true
                        },
                        "enable_pod_disruption_budget": {
                            "type": "boolean",
                            "default": true,
                            "nullable": true
                        },
                        "enable_sidecars": {
                            "type": "boolean",
                            "default": true,
                            "nullable": true
                        },
                        "ignored_annotations": {
                            "type": "array",
                            "items": {
                                "type": "string"
                            },
                            "nullable": true
                        },
                        "infrastructure_roles_secret_name": {
                            "type": "string",
                            "nullable": true
                        },
                        "infrastructure_roles_secrets": {
                            "type": "array",
                            "nullable": true,
                            "items": {
                                "type": "object",
                                "required": [
                                    "secretname",
                                    "userkey",
                                    "passwordkey"
                                ],
                                "properties": {
                                    "secretname": {
                                        "type": "string"
                                    },
                                    "userkey": {
                                        "type": "string"
                                    },
                                    "passwordkey": {
                                        "type": "string"
                                    },
                                    "rolekey": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "defaultuservalue": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "defaultrolevalue": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "details": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "template": {
                                        "type": "boolean",
                                        "nullable": true
                                    }
                                }
                            }
                        },
                        "inherited_annotations": {
                            "type": "array",
                            "items": {
                                "type": "string"
                            },
                            "nullable": true
                        },
                        "inherited_labels": {
                            "type": "array",
                            "items": {
                                "type": "string"
                            },
                            "nullable": true
                        },
                        "master_pod_move_timeout": {
                            "type": "string",
                            "default": "20m",
                            "nullable": true
                        },
                        "node_readiness_label": {
                            "type": "object",
                            "additionalProperties": {
                                "type": "string"
                            },
                            "properties": {},
                            "nullable": true
                        },
                        "node_readiness_label_merge": {
                            "type": "string",
                            "enum": [
                                "AND",
                                "OR"
                            ],
                            "nullable": true
                        },
                        "oauth_token_secret_name": {
                            "type": "string",
                            "default": "postgresql-operator",
                            "nullable": true
                        },
                        "pdb_name_format": {
                            "type": "string",
                            "default": "postgres-{cluster}-pdb",
                            "nullable": true
                        },
                        "pod_antiaffinity_topology_key": {
                            "type": "string",
                            "default": "kubernetes.io/hostname",
                            "nullable": true
                        },
                        "pod_environment_configmap": {
                            "type": "string",
                            "nullable": true
                        },
                        "pod_environment_secret": {
                            "type": "string",
                            "nullable": true
                        },
                        "pod_management_policy": {
                            "type": "string",
                            "enum": [
                                "ordered_ready",
                                "parallel"
                            ],
                            "default": "ordered_ready",
                            "nullable": true
                        },
                        "pod_priority_class_name": {
                            "type": "string",
                            "nullable": true
                        },
                        "pod_role_label": {
                            "type": "string",
                            "default": "spilo-role",
                            "nullable": true
                        },
                        "pod_service_account_definition": {
                            "type": "string",
                            "default": "",
                            "nullable": true
                        },
                        "pod_service_account_name": {
                            "type": "string",
                            "default": "postgres-pod",
                            "nullable": true
                        },
                        "pod_service_account_role_binding_definition": {
                            "type": "string",
                            "default": "",
                            "nullable": true
                        },
                        "pod_terminate_grace_period": {
                            "type": "string",
                            "default": "5m",
                            "nullable": true
                        },
                        "secret_name_template": {
                            "type": "string",
                            "default": "{username}.{cluster}.credentials.{tprkind}.{tprgroup}",
                            "nullable": true
                        },
                        "spilo_allow_privilege_escalation": {
                            "type": "boolean",
                            "default": true,
                            "nullable": true
                        },
                        "spilo_runasuser": {
                            "type": "integer",
                            "nullable": true
                        },
                        "spilo_runasgroup": {
                            "type": "integer",
                            "nullable": true
                        },
                        "spilo_fsgroup": {
                            "type": "integer",
                            "nullable": true
                        },
                        "spilo_privileged": {
                            "type": "boolean",
                            "default": false,
                            "nullable": true
                        },
                        "storage_resize_mode": {
                            "type": "string",
                            "enum": [
                                "ebs",
                                "pvc",
                                "off"
                            ],
                            "default": "pvc",
                            "nullable": true
                        },
                        "toleration": {
                            "type": "object",
                            "additionalProperties": {
                                "type": "string"
                            },
                            "properties": {},
                            "nullable": true
                        },
                        "watched_namespace": {
                            "type": "string",
                            "nullable": true
                        }
                    },
                    "nullable": true
                },
                "postgres_pod_resources": {
                    "type": "object",
                    "properties": {
                        "default_cpu_limit": {
                            "type": "string",
                            "default": "1",
                            "pattern": "^(\\d+m|\\d+(\\.\\d{1,3})?)$",
                            "nullable": true
                        },
                        "default_cpu_request": {
                            "type": "string",
                            "default": "100m",
                            "pattern": "^(\\d+m|\\d+(\\.\\d{1,3})?)$",
                            "nullable": true
                        },
                        "default_memory_limit": {
                            "type": "string",
                            "default": "500Mi",
                            "pattern": "^(\\d+(e\\d+)?|\\d+(\\.\\d+)?(e\\d+)?[EPTGMK]i?)$",
                            "nullable": true
                        },
                        "default_memory_request": {
                            "type": "string",
                            "default": "100Mi",
                            "pattern": "^(\\d+(e\\d+)?|\\d+(\\.\\d+)?(e\\d+)?[EPTGMK]i?)$",
                            "nullable": true
                        },
                        "min_cpu_limit": {
                            "type": "string",
                            "default": "250m",
                            "pattern": "^(\\d+m|\\d+(\\.\\d{1,3})?)$",
                            "nullable": true
                        },
                        "min_memory_limit": {
                            "type": "string",
                            "default": "250Mi",
                            "pattern": "^(\\d+(e\\d+)?|\\d+(\\.\\d+)?(e\\d+)?[EPTGMK]i?)$",
                            "nullable": true
                        }
                    },
                    "nullable": true
                },
                "timeouts": {
                    "type": "object",
                    "properties": {
                        "patroni_api_check_interval": {
                            "type": "string",
                            "default": "1s",
                            "nullable": true
                        },
                        "patroni_api_check_timeout": {
                            "type": "string",
                            "default": "5s",
                            "nullable": true
                        },
                        "pod_label_wait_timeout": {
                            "type": "string",
                            "default": "10m",
                            "nullable": true
                        },
                        "pod_deletion_wait_timeout": {
                            "type": "string",
                            "default": "10m",
                            "nullable": true
                        },
                        "ready_wait_interval": {
                            "type": "string",
                            "default": "4s",
                            "nullable": true
                        },
                        "ready_wait_timeout": {
                            "type": "string",
                            "default": "30s",
                            "nullable": true
                        },
                        "resource_check_interval": {
                            "type": "string",
                            "default": "3s",
                            "nullable": true
                        },
                        "resource_check_timeout": {
                            "type": "string",
                            "default": "10m",
                            "nullable": true
                        }
                    },
                    "nullable": true
                },
                "load_balancer": {
                    "type": "object",
                    "properties": {
                        "custom_service_annotations": {
                            "type": "object",
                            "additionalProperties": {
                                "type": "string"
                            },
                            "properties": {},
                            "nullable": true
                        },
                        "db_hosted_zone": {
                            "type": "string",
                            "default": "db.example.com",
                            "nullable": true
                        },
                        "enable_master_load_balancer": {
                            "type": "boolean",
                            "default": true,
                            "nullable": true
                        },
                        "enable_master_pooler_load_balancer": {
                            "type": "boolean",
                            "default": false,
                            "nullable": true
                        },
                        "enable_replica_load_balancer": {
                            "type": "boolean",
                            "default": false,
                            "nullable": true
                        },
                        "enable_replica_pooler_load_balancer": {
                            "type": "boolean",
                            "default": false,
                            "nullable": true
                        },
                        "external_traffic_policy": {
                            "type": "string",
                            "enum": [
                                "Cluster",
                                "Local"
                            ],
                            "default": "Cluster",
                            "nullable": true
                        },
                        "master_dns_name_format": {
                            "type": "string",
                            "default": "{cluster}.{team}.{hostedzone}",
                            "nullable": true
                        },
                        "replica_dns_name_format": {
                            "type": "string",
                            "default": "{cluster}-repl.{team}.{hostedzone}",
                            "nullable": true
                        }
                    },
                    "nullable": true
                },
                "aws_or_gcp": {
                    "type": "object",
                    "properties": {
                        "additional_secret_mount": {
                            "type": "string",
                            "nullable": true
                        },
                        "additional_secret_mount_path": {
                            "type": "string",
                            "default": "/meta/credentials",
                            "nullable": true
                        },
                        "aws_region": {
                            "type": "string",
                            "default": "eu-central-1",
                            "nullable": true
                        },
                        "enable_ebs_gp3_migration": {
                            "type": "boolean",
                            "default": false,
                            "nullable": true
                        },
                        "enable_ebs_gp3_migration_max_size": {
                            "type": "integer",
                            "default": 1000,
                            "nullable": true
                        },
                        "gcp_credentials": {
                            "type": "string",
                            "nullable": true
                        },
                        "kube_iam_role": {
                            "type": "string",
                            "nullable": true
                        },
                        "log_s3_bucket": {
                            "type": "string",
                            "nullable": true
                        },
                        "wal_az_storage_account": {
                            "type": "string",
                            "nullable": true
                        },
                        "wal_gs_bucket": {
                            "type": "string",
                            "nullable": true
                        },
                        "wal_s3_bucket": {
                            "type": "string",
                            "nullable": true
                        }
                    },
                    "nullable": true
                },
                "logical_backup": {
                    "type": "object",
                    "properties": {
                        "logical_backup_docker_image": {
                            "type": "string",
                            "default": "registry.opensource.zalan.do/acid/logical-backup:v1.8.2",
                            "nullable": true
                        },
                        "logical_backup_google_application_credentials": {
                            "type": "string",
                            "nullable": true
                        },
                        "logical_backup_job_prefix": {
                            "type": "string",
                            "default": "logical-backup-",
                            "nullable": true
                        },
                        "logical_backup_provider": {
                            "type": "string",
                            "default": "s3",
                            "nullable": true
                        },
                        "logical_backup_s3_access_key_id": {
                            "type": "string",
                            "nullable": true
                        },
                        "logical_backup_s3_bucket": {
                            "type": "string",
                            "nullable": true
                        },
                        "logical_backup_s3_endpoint": {
                            "type": "string",
                            "nullable": true
                        },
                        "logical_backup_s3_region": {
                            "type": "string",
                            "nullable": true
                        },
                        "logical_backup_s3_secret_access_key": {
                            "type": "string",
                            "nullable": true
                        },
                        "logical_backup_s3_sse": {
                            "type": "string",
                            "nullable": true
                        },
                        "logical_backup_s3_retention_time": {
                            "type": "string",
                            "nullable": true
                        },
                        "logical_backup_schedule": {
                            "type": "string",
                            "default": "30 00 * * *",
                            "pattern": "^(\\d+|\\*)(\\/\\d+)?(\\s+(\\d+|\\*)(\\/\\d+)?){4}$",
                            "nullable": true
                        }
                    },
                    "nullable": true
                },
                "debug": {
                    "type": "object",
                    "properties": {
                        "debug_logging": {
                            "type": "boolean",
                            "default": true,
                            "nullable": true
                        },
                        "enable_database_access": {
                            "type": "boolean",
                            "default": true,
                            "nullable": true
                        }
                    },
                    "nullable": true
                },
                "teams_api": {
                    "type": "object",
                    "properties": {
                        "enable_admin_role_for_users": {
                            "type": "boolean",
                            "default": true,
                            "nullable": true
                        },
                        "enable_postgres_team_crd": {
                            "type": "boolean",
                            "default": true,
                            "nullable": true
                        },
                        "enable_postgres_team_crd_superusers": {
                            "type": "boolean",
                            "default": false,
                            "nullable": true
                        },
                        "enable_team_member_deprecation": {
                            "type": "boolean",
                            "default": false,
                            "nullable": true
                        },
                        "enable_team_superuser": {
                            "type": "boolean",
                            "default": false,
                            "nullable": true
                        },
                        "enable_teams_api": {
                            "type": "boolean",
                            "default": true,
                            "nullable": true
                        },
                        "pam_configuration": {
                            "type": "string",
                            "default": "https://info.example.com/oauth2/tokeninfo?access_token= uid realm=/employees",
                            "nullable": true
                        },
                        "pam_role_name": {
                            "type": "string",
                            "default": "zalandos",
                            "nullable": true
                        },
                        "postgres_superuser_teams": {
                            "type": "array",
                            "items": {
                                "type": "string"
                            },
                            "nullable": true
                        },
                        "protected_role_names": {
                            "type": "array",
                            "items": {
                                "type": "string"
                            },
                            "default": [
                                "admin",
                                "cron_admin"
                            ],
                            "nullable": true
                        },
                        "role_deletion_suffix": {
                            "type": "string",
                            "default": "_deleted",
                            "nullable": true
                        },
                        "team_admin_role": {
                            "type": "string",
                            "default": "admin",
                            "nullable": true
                        },
                        "team_api_role_configuration": {
                            "type": "object",
                            "additionalProperties": {
                                "type": "string"
                            },
                            "default": {
                                "log_statement": "all"
                            },
                            "properties": {},
                            "nullable": true
                        },
                        "teams_api_url": {
                            "type": "string",
                            "default": "https://teams.example.com/api/",
                            "nullable": true
                        }
                    },
                    "nullable": true
                },
                "logging_rest_api": {
                    "type": "object",
                    "properties": {
                        "api_port": {
                            "type": "integer",
                            "default": 8080,
                            "nullable": true
                        },
                        "cluster_history_entries": {
                            "type": "integer",
                            "default": 1000,
                            "nullable": true
                        },
                        "ring_log_lines": {
                            "type": "integer",
                            "default": 100,
                            "nullable": true
                        }
                    },
                    "nullable": true
                },
                "scalyr": {
                    "type": "object",
                    "properties": {
                        "scalyr_api_key": {
                            "type": "string",
                            "nullable": true
                        },
                        "scalyr_cpu_limit": {
                            "type": "string",
                            "default": "1",
                            "pattern": "^(\\d+m|\\d+(\\.\\d{1,3})?)$",
                            "nullable": true
                        },
                        "scalyr_cpu_request": {
                            "type": "string",
                            "default": "100m",
                            "pattern": "^(\\d+m|\\d+(\\.\\d{1,3})?)$",
                            "nullable": true
                        },
                        "scalyr_image": {
                            "type": "string",
                            "nullable": true
                        },
                        "scalyr_memory_limit": {
                            "type": "string",
                            "default": "500Mi",
                            "pattern": "^(\\d+(e\\d+)?|\\d+(\\.\\d+)?(e\\d+)?[EPTGMK]i?)$",
                            "nullable": true
                        },
                        "scalyr_memory_request": {
                            "type": "string",
                            "default": "50Mi",
                            "pattern": "^(\\d+(e\\d+)?|\\d+(\\.\\d+)?(e\\d+)?[EPTGMK]i?)$",
                            "nullable": true
                        },
                        "scalyr_server_url": {
                            "type": "string",
                            "default": "https://upload.eu.scalyr.com",
                            "nullable": true
                        }
                    },
                    "nullable": true
                },
                "connection_pooler": {
                    "type": "object",
                    "properties": {
                        "connection_pooler_schema": {
                            "type": "string",
                            "default": "pooler",
                            "nullable": true
                        },
                        "connection_pooler_user": {
                            "type": "string",
                            "default": "pooler",
                            "nullable": true
                        },
                        "connection_pooler_image": {
                            "type": "string",
                            "default": "registry.opensource.zalan.do/acid/pgbouncer:master-22",
                            "nullable": true
                        },
                        "connection_pooler_max_db_connections": {
                            "type": "integer",
                            "default": 60,
                            "nullable": true
                        },
                        "connection_pooler_mode": {
                            "type": "string",
                            "enum": [
                                "session",
                                "transaction"
                            ],
                            "default": "transaction",
                            "nullable": true
                        },
                        "connection_pooler_number_of_instances": {
                            "type": "integer",
                            "default": 2,
                            "minimum": 1,
                            "nullable": true
                        },
                        "connection_pooler_default_cpu_limit": {
                            "type": "string",
                            "default": "1",
                            "pattern": "^(\\d+m|\\d+(\\.\\d{1,3})?)$",
                            "nullable": true
                        },
                        "connection_pooler_default_cpu_request": {
                            "type": "string",
                            "default": "500m",
                            "pattern": "^(\\d+m|\\d+(\\.\\d{1,3})?)$",
                            "nullable": true
                        },
                        "connection_pooler_default_memory_limit": {
                            "type": "string",
                            "default": "100Mi",
                            "pattern": "^(\\d+(e\\d+)?|\\d+(\\.\\d+)?(e\\d+)?[EPTGMK]i?)$",
                            "nullable": true
                        },
                        "connection_pooler_default_memory_request": {
                            "type": "string",
                            "default": "100Mi",
                            "pattern": "^(\\d+(e\\d+)?|\\d+(\\.\\d+)?(e\\d+)?[EPTGMK]i?)$",
                            "nullable": true
                        }
                    },
                    "nullable": true
                }
            }
        },
        "status": {
            "type": "object",
            "additionalProperties": {
                "type": "string"
            },
            "properties": {},
            "nullable": true
        },
        "metadata": {
            "oneOf": [
                {
                    "$ref": "io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta#"
                },
                {
                    "type": "null"
                }
            ]
        }
    },
    "required": [
        "kind",
        "apiVersion",
        "configuration"
    ]
};
class OperatorConfiguration extends base_1.Model {
    constructor(data) {
        super({
            apiVersion: OperatorConfiguration.apiVersion,
            kind: OperatorConfiguration.kind,
            ...data
        });
    }
}
exports.OperatorConfiguration = OperatorConfiguration;
OperatorConfiguration.apiVersion = "acid.zalan.do/v1";
OperatorConfiguration.kind = "OperatorConfiguration";
OperatorConfiguration.is = (0, base_1.createTypeMetaGuard)(OperatorConfiguration);
(0, base_1.setSchema)(OperatorConfiguration, schemaId, () => {
    (0, IoK8sApimachineryPkgApisMetaV1ObjectMeta_1.addSchema)();
    (0, validate_1.register)(schemaId, schema);
});
