"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PostgresTeam = void 0;
const IoK8sApimachineryPkgApisMetaV1ObjectMeta_1 = require("@kubernetes-models/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta");
const base_1 = require("@kubernetes-models/base");
const validate_1 = require("@kubernetes-models/validate");
const schemaId = "acid.zalan.do.v1.PostgresTeam";
const schema = {
    "type": "object",
    "properties": {
        "kind": {
            "type": "string",
            "enum": [
                "PostgresTeam"
            ]
        },
        "apiVersion": {
            "type": "string",
            "enum": [
                "acid.zalan.do/v1"
            ]
        },
        "spec": {
            "type": "object",
            "properties": {
                "additionalSuperuserTeams": {
                    "type": "object",
                    "additionalProperties": {
                        "type": "array",
                        "nullable": true,
                        "items": {
                            "type": "string"
                        }
                    },
                    "properties": {},
                    "nullable": true
                },
                "additionalTeams": {
                    "type": "object",
                    "additionalProperties": {
                        "type": "array",
                        "nullable": true,
                        "items": {
                            "type": "string"
                        }
                    },
                    "properties": {},
                    "nullable": true
                },
                "additionalMembers": {
                    "type": "object",
                    "additionalProperties": {
                        "type": "array",
                        "nullable": true,
                        "items": {
                            "type": "string"
                        }
                    },
                    "properties": {},
                    "nullable": true
                }
            }
        },
        "metadata": {
            "oneOf": [
                {
                    "$ref": "io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta#"
                },
                {
                    "type": "null"
                }
            ]
        }
    },
    "required": [
        "kind",
        "apiVersion",
        "spec"
    ]
};
class PostgresTeam extends base_1.Model {
    constructor(data) {
        super({
            apiVersion: PostgresTeam.apiVersion,
            kind: PostgresTeam.kind,
            ...data
        });
    }
}
exports.PostgresTeam = PostgresTeam;
PostgresTeam.apiVersion = "acid.zalan.do/v1";
PostgresTeam.kind = "PostgresTeam";
PostgresTeam.is = (0, base_1.createTypeMetaGuard)(PostgresTeam);
(0, base_1.setSchema)(PostgresTeam, schemaId, () => {
    (0, IoK8sApimachineryPkgApisMetaV1ObjectMeta_1.addSchema)();
    (0, validate_1.register)(schemaId, schema);
});
