import { addSchema } from "@kubernetes-models/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta";
import { Model, setSchema, createTypeMetaGuard } from "@kubernetes-models/base";
import { register } from "@kubernetes-models/validate";
const schemaId = "acid.zalan.do.v1.PostgresTeam";
const schema = {
    "type": "object",
    "properties": {
        "kind": {
            "type": "string",
            "enum": [
                "PostgresTeam"
            ]
        },
        "apiVersion": {
            "type": "string",
            "enum": [
                "acid.zalan.do/v1"
            ]
        },
        "spec": {
            "type": "object",
            "properties": {
                "additionalSuperuserTeams": {
                    "type": "object",
                    "additionalProperties": {
                        "type": "array",
                        "nullable": true,
                        "items": {
                            "type": "string"
                        }
                    },
                    "properties": {},
                    "nullable": true
                },
                "additionalTeams": {
                    "type": "object",
                    "additionalProperties": {
                        "type": "array",
                        "nullable": true,
                        "items": {
                            "type": "string"
                        }
                    },
                    "properties": {},
                    "nullable": true
                },
                "additionalMembers": {
                    "type": "object",
                    "additionalProperties": {
                        "type": "array",
                        "nullable": true,
                        "items": {
                            "type": "string"
                        }
                    },
                    "properties": {},
                    "nullable": true
                }
            }
        },
        "metadata": {
            "oneOf": [
                {
                    "$ref": "io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta#"
                },
                {
                    "type": "null"
                }
            ]
        }
    },
    "required": [
        "kind",
        "apiVersion",
        "spec"
    ]
};
export class PostgresTeam extends Model {
    constructor(data) {
        super({
            apiVersion: PostgresTeam.apiVersion,
            kind: PostgresTeam.kind,
            ...data
        });
    }
}
PostgresTeam.apiVersion = "acid.zalan.do/v1";
PostgresTeam.kind = "PostgresTeam";
PostgresTeam.is = createTypeMetaGuard(PostgresTeam);
setSchema(PostgresTeam, schemaId, () => {
    addSchema();
    register(schemaId, schema);
});
