"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.postgresql = void 0;
const IoK8sApimachineryPkgApisMetaV1ObjectMeta_1 = require("@kubernetes-models/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta");
const base_1 = require("@kubernetes-models/base");
const validate_1 = require("@kubernetes-models/validate");
const schemaId = "acid.zalan.do.v1.postgresql";
const schema = {
    "type": "object",
    "properties": {
        "kind": {
            "type": "string",
            "enum": [
                "postgresql"
            ]
        },
        "apiVersion": {
            "type": "string",
            "enum": [
                "acid.zalan.do/v1"
            ]
        },
        "spec": {
            "type": "object",
            "required": [
                "numberOfInstances",
                "teamId",
                "postgresql",
                "volume"
            ],
            "properties": {
                "additionalVolumes": {
                    "type": "array",
                    "items": {
                        "type": "object",
                        "required": [
                            "name",
                            "mountPath",
                            "volumeSource"
                        ],
                        "properties": {
                            "name": {
                                "type": "string"
                            },
                            "mountPath": {
                                "type": "string"
                            },
                            "targetContainers": {
                                "type": "array",
                                "nullable": true,
                                "items": {
                                    "type": "string"
                                }
                            },
                            "volumeSource": {
                                "type": "object",
                                "properties": {}
                            },
                            "subPath": {
                                "type": "string",
                                "nullable": true
                            }
                        }
                    },
                    "nullable": true
                },
                "allowedSourceRanges": {
                    "type": "array",
                    "nullable": true,
                    "items": {
                        "type": "string",
                        "pattern": "^(\\d|[1-9]\\d|1\\d\\d|2[0-4]\\d|25[0-5])\\.(\\d|[1-9]\\d|1\\d\\d|2[0-4]\\d|25[0-5])\\.(\\d|[1-9]\\d|1\\d\\d|2[0-4]\\d|25[0-5])\\.(\\d|[1-9]\\d|1\\d\\d|2[0-4]\\d|25[0-5])\\/(\\d|[1-2]\\d|3[0-2])$"
                    }
                },
                "clone": {
                    "type": "object",
                    "required": [
                        "cluster"
                    ],
                    "properties": {
                        "cluster": {
                            "type": "string"
                        },
                        "s3_endpoint": {
                            "type": "string",
                            "nullable": true
                        },
                        "s3_access_key_id": {
                            "type": "string",
                            "nullable": true
                        },
                        "s3_secret_access_key": {
                            "type": "string",
                            "nullable": true
                        },
                        "s3_force_path_style": {
                            "type": "boolean",
                            "nullable": true
                        },
                        "s3_wal_path": {
                            "type": "string",
                            "nullable": true
                        },
                        "timestamp": {
                            "type": "string",
                            "pattern": "^([0-9]+)-(0[1-9]|1[012])-(0[1-9]|[12][0-9]|3[01])[Tt]([01][0-9]|2[0-3]):([0-5][0-9]):([0-5][0-9]|60)(\\.[0-9]+)?(([+-]([01][0-9]|2[0-3]):[0-5][0-9]))$",
                            "nullable": true
                        },
                        "uid": {
                            "format": "uuid",
                            "type": "string",
                            "nullable": true
                        }
                    },
                    "nullable": true
                },
                "connectionPooler": {
                    "type": "object",
                    "properties": {
                        "dockerImage": {
                            "type": "string",
                            "nullable": true
                        },
                        "maxDBConnections": {
                            "type": "integer",
                            "nullable": true
                        },
                        "mode": {
                            "type": "string",
                            "enum": [
                                "session",
                                "transaction"
                            ],
                            "nullable": true
                        },
                        "numberOfInstances": {
                            "type": "integer",
                            "minimum": 1,
                            "nullable": true
                        },
                        "resources": {
                            "type": "object",
                            "properties": {
                                "limits": {
                                    "type": "object",
                                    "properties": {
                                        "cpu": {
                                            "type": "string",
                                            "pattern": "^(\\d+m|\\d+(\\.\\d{1,3})?)$",
                                            "nullable": true
                                        },
                                        "memory": {
                                            "type": "string",
                                            "pattern": "^(\\d+(e\\d+)?|\\d+(\\.\\d+)?(e\\d+)?[EPTGMK]i?)$",
                                            "nullable": true
                                        }
                                    },
                                    "nullable": true
                                },
                                "requests": {
                                    "type": "object",
                                    "properties": {
                                        "cpu": {
                                            "type": "string",
                                            "pattern": "^(\\d+m|\\d+(\\.\\d{1,3})?)$",
                                            "nullable": true
                                        },
                                        "memory": {
                                            "type": "string",
                                            "pattern": "^(\\d+(e\\d+)?|\\d+(\\.\\d+)?(e\\d+)?[EPTGMK]i?)$",
                                            "nullable": true
                                        }
                                    },
                                    "nullable": true
                                }
                            },
                            "nullable": true
                        },
                        "schema": {
                            "type": "string",
                            "nullable": true
                        },
                        "user": {
                            "type": "string",
                            "nullable": true
                        }
                    },
                    "nullable": true
                },
                "databases": {
                    "type": "object",
                    "additionalProperties": {
                        "type": "string"
                    },
                    "properties": {},
                    "nullable": true
                },
                "dockerImage": {
                    "type": "string",
                    "nullable": true
                },
                "enableConnectionPooler": {
                    "type": "boolean",
                    "nullable": true
                },
                "enableReplicaConnectionPooler": {
                    "type": "boolean",
                    "nullable": true
                },
                "enableLogicalBackup": {
                    "type": "boolean",
                    "nullable": true
                },
                "enableMasterLoadBalancer": {
                    "type": "boolean",
                    "nullable": true
                },
                "enableMasterPoolerLoadBalancer": {
                    "type": "boolean",
                    "nullable": true
                },
                "enableReplicaLoadBalancer": {
                    "type": "boolean",
                    "nullable": true
                },
                "enableReplicaPoolerLoadBalancer": {
                    "type": "boolean",
                    "nullable": true
                },
                "enableShmVolume": {
                    "type": "boolean",
                    "nullable": true
                },
                "env": {
                    "type": "array",
                    "nullable": true,
                    "items": {
                        "type": "object",
                        "properties": {}
                    }
                },
                "init_containers": {
                    "type": "array",
                    "nullable": true,
                    "items": {
                        "type": "object",
                        "properties": {}
                    }
                },
                "initContainers": {
                    "type": "array",
                    "nullable": true,
                    "items": {
                        "type": "object",
                        "properties": {}
                    }
                },
                "logicalBackupSchedule": {
                    "type": "string",
                    "pattern": "^(\\d+|\\*)(\\/\\d+)?(\\s+(\\d+|\\*)(\\/\\d+)?){4}$",
                    "nullable": true
                },
                "maintenanceWindows": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    },
                    "nullable": true
                },
                "nodeAffinity": {
                    "type": "object",
                    "properties": {
                        "preferredDuringSchedulingIgnoredDuringExecution": {
                            "type": "array",
                            "items": {
                                "type": "object",
                                "required": [
                                    "preference",
                                    "weight"
                                ],
                                "properties": {
                                    "preference": {
                                        "type": "object",
                                        "properties": {
                                            "matchExpressions": {
                                                "type": "array",
                                                "items": {
                                                    "type": "object",
                                                    "required": [
                                                        "key",
                                                        "operator"
                                                    ],
                                                    "properties": {
                                                        "key": {
                                                            "type": "string"
                                                        },
                                                        "operator": {
                                                            "type": "string"
                                                        },
                                                        "values": {
                                                            "type": "array",
                                                            "items": {
                                                                "type": "string"
                                                            },
                                                            "nullable": true
                                                        }
                                                    }
                                                },
                                                "nullable": true
                                            },
                                            "matchFields": {
                                                "type": "array",
                                                "items": {
                                                    "type": "object",
                                                    "required": [
                                                        "key",
                                                        "operator"
                                                    ],
                                                    "properties": {
                                                        "key": {
                                                            "type": "string"
                                                        },
                                                        "operator": {
                                                            "type": "string"
                                                        },
                                                        "values": {
                                                            "type": "array",
                                                            "items": {
                                                                "type": "string"
                                                            },
                                                            "nullable": true
                                                        }
                                                    }
                                                },
                                                "nullable": true
                                            }
                                        }
                                    },
                                    "weight": {
                                        "format": "int32",
                                        "type": "integer"
                                    }
                                }
                            },
                            "nullable": true
                        },
                        "requiredDuringSchedulingIgnoredDuringExecution": {
                            "type": "object",
                            "required": [
                                "nodeSelectorTerms"
                            ],
                            "properties": {
                                "nodeSelectorTerms": {
                                    "type": "array",
                                    "items": {
                                        "type": "object",
                                        "properties": {
                                            "matchExpressions": {
                                                "type": "array",
                                                "items": {
                                                    "type": "object",
                                                    "required": [
                                                        "key",
                                                        "operator"
                                                    ],
                                                    "properties": {
                                                        "key": {
                                                            "type": "string"
                                                        },
                                                        "operator": {
                                                            "type": "string"
                                                        },
                                                        "values": {
                                                            "type": "array",
                                                            "items": {
                                                                "type": "string"
                                                            },
                                                            "nullable": true
                                                        }
                                                    }
                                                },
                                                "nullable": true
                                            },
                                            "matchFields": {
                                                "type": "array",
                                                "items": {
                                                    "type": "object",
                                                    "required": [
                                                        "key",
                                                        "operator"
                                                    ],
                                                    "properties": {
                                                        "key": {
                                                            "type": "string"
                                                        },
                                                        "operator": {
                                                            "type": "string"
                                                        },
                                                        "values": {
                                                            "type": "array",
                                                            "items": {
                                                                "type": "string"
                                                            },
                                                            "nullable": true
                                                        }
                                                    }
                                                },
                                                "nullable": true
                                            }
                                        }
                                    }
                                }
                            },
                            "nullable": true
                        }
                    },
                    "nullable": true
                },
                "numberOfInstances": {
                    "type": "integer",
                    "minimum": 0
                },
                "patroni": {
                    "type": "object",
                    "properties": {
                        "initdb": {
                            "type": "object",
                            "additionalProperties": {
                                "type": "string"
                            },
                            "properties": {},
                            "nullable": true
                        },
                        "loop_wait": {
                            "type": "integer",
                            "nullable": true
                        },
                        "maximum_lag_on_failover": {
                            "type": "integer",
                            "nullable": true
                        },
                        "pg_hba": {
                            "type": "array",
                            "items": {
                                "type": "string"
                            },
                            "nullable": true
                        },
                        "retry_timeout": {
                            "type": "integer",
                            "nullable": true
                        },
                        "slots": {
                            "type": "object",
                            "additionalProperties": {
                                "type": "object",
                                "additionalProperties": {
                                    "type": "string"
                                },
                                "properties": {}
                            },
                            "properties": {},
                            "nullable": true
                        },
                        "synchronous_mode": {
                            "type": "boolean",
                            "nullable": true
                        },
                        "synchronous_mode_strict": {
                            "type": "boolean",
                            "nullable": true
                        },
                        "synchronous_node_count": {
                            "type": "integer",
                            "nullable": true
                        },
                        "ttl": {
                            "type": "integer",
                            "nullable": true
                        }
                    },
                    "nullable": true
                },
                "podAnnotations": {
                    "type": "object",
                    "additionalProperties": {
                        "type": "string"
                    },
                    "properties": {},
                    "nullable": true
                },
                "pod_priority_class_name": {
                    "type": "string",
                    "nullable": true
                },
                "podPriorityClassName": {
                    "type": "string",
                    "nullable": true
                },
                "postgresql": {
                    "type": "object",
                    "required": [
                        "version"
                    ],
                    "properties": {
                        "version": {
                            "type": "string",
                            "enum": [
                                "9.5",
                                "9.6",
                                "10",
                                "11",
                                "12",
                                "13",
                                "14"
                            ]
                        },
                        "parameters": {
                            "type": "object",
                            "additionalProperties": {
                                "type": "string"
                            },
                            "properties": {},
                            "nullable": true
                        }
                    }
                },
                "preparedDatabases": {
                    "type": "object",
                    "additionalProperties": {
                        "type": "object",
                        "properties": {
                            "defaultUsers": {
                                "type": "boolean",
                                "nullable": true
                            },
                            "extensions": {
                                "type": "object",
                                "additionalProperties": {
                                    "type": "string"
                                },
                                "properties": {},
                                "nullable": true
                            },
                            "schemas": {
                                "type": "object",
                                "additionalProperties": {
                                    "type": "object",
                                    "properties": {
                                        "defaultUsers": {
                                            "type": "boolean",
                                            "nullable": true
                                        },
                                        "defaultRoles": {
                                            "type": "boolean",
                                            "nullable": true
                                        }
                                    }
                                },
                                "properties": {},
                                "nullable": true
                            },
                            "secretNamespace": {
                                "type": "string",
                                "nullable": true
                            }
                        }
                    },
                    "properties": {},
                    "nullable": true
                },
                "replicaLoadBalancer": {
                    "type": "boolean",
                    "nullable": true
                },
                "resources": {
                    "type": "object",
                    "properties": {
                        "limits": {
                            "type": "object",
                            "properties": {
                                "cpu": {
                                    "type": "string",
                                    "pattern": "^(\\d+m|\\d+(\\.\\d{1,3})?)$",
                                    "nullable": true
                                },
                                "memory": {
                                    "type": "string",
                                    "pattern": "^(\\d+(e\\d+)?|\\d+(\\.\\d+)?(e\\d+)?[EPTGMK]i?)$",
                                    "nullable": true
                                }
                            },
                            "nullable": true
                        },
                        "requests": {
                            "type": "object",
                            "properties": {
                                "cpu": {
                                    "type": "string",
                                    "pattern": "^(\\d+m|\\d+(\\.\\d{1,3})?)$",
                                    "nullable": true
                                },
                                "memory": {
                                    "type": "string",
                                    "pattern": "^(\\d+(e\\d+)?|\\d+(\\.\\d+)?(e\\d+)?[EPTGMK]i?)$",
                                    "nullable": true
                                }
                            },
                            "nullable": true
                        }
                    },
                    "nullable": true
                },
                "schedulerName": {
                    "type": "string",
                    "nullable": true
                },
                "serviceAnnotations": {
                    "type": "object",
                    "additionalProperties": {
                        "type": "string"
                    },
                    "properties": {},
                    "nullable": true
                },
                "sidecars": {
                    "type": "array",
                    "nullable": true,
                    "items": {
                        "type": "object",
                        "properties": {}
                    }
                },
                "spiloRunAsUser": {
                    "type": "integer",
                    "nullable": true
                },
                "spiloRunAsGroup": {
                    "type": "integer",
                    "nullable": true
                },
                "spiloFSGroup": {
                    "type": "integer",
                    "nullable": true
                },
                "standby": {
                    "type": "object",
                    "properties": {
                        "s3_wal_path": {
                            "type": "string",
                            "nullable": true
                        },
                        "gs_wal_path": {
                            "type": "string",
                            "nullable": true
                        },
                        "standby_host": {
                            "type": "string",
                            "nullable": true
                        },
                        "standby_port": {
                            "type": "string",
                            "nullable": true
                        }
                    },
                    "oneOf": [
                        {
                            "required": [
                                "s3_wal_path"
                            ]
                        },
                        {
                            "required": [
                                "gs_wal_path"
                            ]
                        },
                        {
                            "required": [
                                "standby_host"
                            ]
                        }
                    ],
                    "nullable": true
                },
                "streams": {
                    "type": "array",
                    "items": {
                        "type": "object",
                        "required": [
                            "applicationId",
                            "database",
                            "tables"
                        ],
                        "properties": {
                            "applicationId": {
                                "type": "string"
                            },
                            "batchSize": {
                                "type": "integer",
                                "nullable": true
                            },
                            "database": {
                                "type": "string"
                            },
                            "filter": {
                                "type": "object",
                                "additionalProperties": {
                                    "type": "string"
                                },
                                "properties": {},
                                "nullable": true
                            },
                            "tables": {
                                "type": "object",
                                "additionalProperties": {
                                    "type": "object",
                                    "required": [
                                        "eventType"
                                    ],
                                    "properties": {
                                        "eventType": {
                                            "type": "string"
                                        },
                                        "idColumn": {
                                            "type": "string",
                                            "nullable": true
                                        },
                                        "payloadColumn": {
                                            "type": "string",
                                            "nullable": true
                                        }
                                    }
                                },
                                "properties": {}
                            }
                        }
                    },
                    "nullable": true
                },
                "teamId": {
                    "type": "string"
                },
                "tls": {
                    "type": "object",
                    "required": [
                        "secretName"
                    ],
                    "properties": {
                        "secretName": {
                            "type": "string"
                        },
                        "certificateFile": {
                            "type": "string",
                            "nullable": true
                        },
                        "privateKeyFile": {
                            "type": "string",
                            "nullable": true
                        },
                        "caFile": {
                            "type": "string",
                            "nullable": true
                        },
                        "caSecretName": {
                            "type": "string",
                            "nullable": true
                        }
                    },
                    "nullable": true
                },
                "tolerations": {
                    "type": "array",
                    "items": {
                        "type": "object",
                        "properties": {
                            "key": {
                                "type": "string",
                                "nullable": true
                            },
                            "operator": {
                                "type": "string",
                                "enum": [
                                    "Equal",
                                    "Exists"
                                ],
                                "nullable": true
                            },
                            "value": {
                                "type": "string",
                                "nullable": true
                            },
                            "effect": {
                                "type": "string",
                                "enum": [
                                    "NoExecute",
                                    "NoSchedule",
                                    "PreferNoSchedule"
                                ],
                                "nullable": true
                            },
                            "tolerationSeconds": {
                                "type": "integer",
                                "nullable": true
                            }
                        }
                    },
                    "nullable": true
                },
                "useLoadBalancer": {
                    "type": "boolean",
                    "nullable": true
                },
                "users": {
                    "type": "object",
                    "additionalProperties": {
                        "type": "array",
                        "nullable": true,
                        "items": {
                            "type": "string",
                            "enum": [
                                "bypassrls",
                                "BYPASSRLS",
                                "nobypassrls",
                                "NOBYPASSRLS",
                                "createdb",
                                "CREATEDB",
                                "nocreatedb",
                                "NOCREATEDB",
                                "createrole",
                                "CREATEROLE",
                                "nocreaterole",
                                "NOCREATEROLE",
                                "inherit",
                                "INHERIT",
                                "noinherit",
                                "NOINHERIT",
                                "login",
                                "LOGIN",
                                "nologin",
                                "NOLOGIN",
                                "replication",
                                "REPLICATION",
                                "noreplication",
                                "NOREPLICATION",
                                "superuser",
                                "SUPERUSER",
                                "nosuperuser",
                                "NOSUPERUSER"
                            ]
                        }
                    },
                    "properties": {},
                    "nullable": true
                },
                "usersWithInPlaceSecretRotation": {
                    "type": "array",
                    "nullable": true,
                    "items": {
                        "type": "string"
                    }
                },
                "usersWithSecretRotation": {
                    "type": "array",
                    "nullable": true,
                    "items": {
                        "type": "string"
                    }
                },
                "volume": {
                    "type": "object",
                    "required": [
                        "size"
                    ],
                    "properties": {
                        "iops": {
                            "type": "integer",
                            "nullable": true
                        },
                        "selector": {
                            "type": "object",
                            "properties": {
                                "matchExpressions": {
                                    "type": "array",
                                    "items": {
                                        "type": "object",
                                        "required": [
                                            "key",
                                            "operator"
                                        ],
                                        "properties": {
                                            "key": {
                                                "type": "string"
                                            },
                                            "operator": {
                                                "type": "string",
                                                "enum": [
                                                    "DoesNotExists",
                                                    "Exists",
                                                    "In",
                                                    "NotIn"
                                                ]
                                            },
                                            "values": {
                                                "type": "array",
                                                "items": {
                                                    "type": "string"
                                                },
                                                "nullable": true
                                            }
                                        }
                                    },
                                    "nullable": true
                                },
                                "matchLabels": {
                                    "type": "object",
                                    "properties": {},
                                    "nullable": true
                                }
                            },
                            "nullable": true
                        },
                        "size": {
                            "type": "string",
                            "pattern": "^(\\d+(e\\d+)?|\\d+(\\.\\d+)?(e\\d+)?[EPTGMK]i?)$"
                        },
                        "storageClass": {
                            "type": "string",
                            "nullable": true
                        },
                        "subPath": {
                            "type": "string",
                            "nullable": true
                        },
                        "throughput": {
                            "type": "integer",
                            "nullable": true
                        }
                    }
                }
            }
        },
        "status": {
            "type": "object",
            "additionalProperties": {
                "type": "string"
            },
            "properties": {},
            "nullable": true
        },
        "metadata": {
            "oneOf": [
                {
                    "$ref": "io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta#"
                },
                {
                    "type": "null"
                }
            ]
        }
    },
    "required": [
        "kind",
        "apiVersion",
        "spec"
    ]
};
class postgresql extends base_1.Model {
    constructor(data) {
        super({
            apiVersion: postgresql.apiVersion,
            kind: postgresql.kind,
            ...data
        });
    }
}
exports.postgresql = postgresql;
postgresql.apiVersion = "acid.zalan.do/v1";
postgresql.kind = "postgresql";
postgresql.is = (0, base_1.createTypeMetaGuard)(postgresql);
(0, base_1.setSchema)(postgresql, schemaId, () => {
    (0, IoK8sApimachineryPkgApisMetaV1ObjectMeta_1.addSchema)();
    (0, validate_1.register)(schemaId, schema);
});
