"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PGUpgrade = void 0;
const IoK8sApimachineryPkgApisMetaV1ObjectMeta_1 = require("@kubernetes-models/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta");
const base_1 = require("@kubernetes-models/base");
const validate_1 = require("@kubernetes-models/validate");
const schemaId = "postgres-operator.crunchydata.com.v1beta1.PGUpgrade";
const schema = {
    "type": "object",
    "properties": {
        "apiVersion": {
            "type": "string",
            "enum": [
                "postgres-operator.crunchydata.com/v1beta1"
            ]
        },
        "kind": {
            "type": "string",
            "enum": [
                "PGUpgrade"
            ]
        },
        "metadata": {
            "oneOf": [
                {
                    "$ref": "io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta#"
                },
                {
                    "type": "null"
                }
            ]
        },
        "spec": {
            "properties": {
                "affinity": {
                    "properties": {
                        "nodeAffinity": {
                            "properties": {
                                "preferredDuringSchedulingIgnoredDuringExecution": {
                                    "items": {
                                        "properties": {
                                            "preference": {
                                                "properties": {
                                                    "matchExpressions": {
                                                        "items": {
                                                            "properties": {
                                                                "key": {
                                                                    "type": "string"
                                                                },
                                                                "operator": {
                                                                    "type": "string"
                                                                },
                                                                "values": {
                                                                    "items": {
                                                                        "type": "string"
                                                                    },
                                                                    "type": "array",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "required": [
                                                                "key",
                                                                "operator"
                                                            ],
                                                            "type": "object"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    },
                                                    "matchFields": {
                                                        "items": {
                                                            "properties": {
                                                                "key": {
                                                                    "type": "string"
                                                                },
                                                                "operator": {
                                                                    "type": "string"
                                                                },
                                                                "values": {
                                                                    "items": {
                                                                        "type": "string"
                                                                    },
                                                                    "type": "array",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "required": [
                                                                "key",
                                                                "operator"
                                                            ],
                                                            "type": "object"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object"
                                            },
                                            "weight": {
                                                "format": "int32",
                                                "type": "integer"
                                            }
                                        },
                                        "required": [
                                            "preference",
                                            "weight"
                                        ],
                                        "type": "object"
                                    },
                                    "type": "array",
                                    "nullable": true
                                },
                                "requiredDuringSchedulingIgnoredDuringExecution": {
                                    "properties": {
                                        "nodeSelectorTerms": {
                                            "items": {
                                                "properties": {
                                                    "matchExpressions": {
                                                        "items": {
                                                            "properties": {
                                                                "key": {
                                                                    "type": "string"
                                                                },
                                                                "operator": {
                                                                    "type": "string"
                                                                },
                                                                "values": {
                                                                    "items": {
                                                                        "type": "string"
                                                                    },
                                                                    "type": "array",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "required": [
                                                                "key",
                                                                "operator"
                                                            ],
                                                            "type": "object"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    },
                                                    "matchFields": {
                                                        "items": {
                                                            "properties": {
                                                                "key": {
                                                                    "type": "string"
                                                                },
                                                                "operator": {
                                                                    "type": "string"
                                                                },
                                                                "values": {
                                                                    "items": {
                                                                        "type": "string"
                                                                    },
                                                                    "type": "array",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "required": [
                                                                "key",
                                                                "operator"
                                                            ],
                                                            "type": "object"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object"
                                            },
                                            "type": "array"
                                        }
                                    },
                                    "required": [
                                        "nodeSelectorTerms"
                                    ],
                                    "type": "object",
                                    "nullable": true
                                }
                            },
                            "type": "object",
                            "nullable": true
                        },
                        "podAffinity": {
                            "properties": {
                                "preferredDuringSchedulingIgnoredDuringExecution": {
                                    "items": {
                                        "properties": {
                                            "podAffinityTerm": {
                                                "properties": {
                                                    "labelSelector": {
                                                        "properties": {
                                                            "matchExpressions": {
                                                                "items": {
                                                                    "properties": {
                                                                        "key": {
                                                                            "type": "string"
                                                                        },
                                                                        "operator": {
                                                                            "type": "string"
                                                                        },
                                                                        "values": {
                                                                            "items": {
                                                                                "type": "string"
                                                                            },
                                                                            "type": "array",
                                                                            "nullable": true
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "key",
                                                                        "operator"
                                                                    ],
                                                                    "type": "object"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            },
                                                            "matchLabels": {
                                                                "additionalProperties": {
                                                                    "type": "string"
                                                                },
                                                                "type": "object",
                                                                "properties": {},
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "namespaces": {
                                                        "items": {
                                                            "type": "string"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    },
                                                    "topologyKey": {
                                                        "type": "string"
                                                    }
                                                },
                                                "required": [
                                                    "topologyKey"
                                                ],
                                                "type": "object"
                                            },
                                            "weight": {
                                                "format": "int32",
                                                "type": "integer"
                                            }
                                        },
                                        "required": [
                                            "podAffinityTerm",
                                            "weight"
                                        ],
                                        "type": "object"
                                    },
                                    "type": "array",
                                    "nullable": true
                                },
                                "requiredDuringSchedulingIgnoredDuringExecution": {
                                    "items": {
                                        "properties": {
                                            "labelSelector": {
                                                "properties": {
                                                    "matchExpressions": {
                                                        "items": {
                                                            "properties": {
                                                                "key": {
                                                                    "type": "string"
                                                                },
                                                                "operator": {
                                                                    "type": "string"
                                                                },
                                                                "values": {
                                                                    "items": {
                                                                        "type": "string"
                                                                    },
                                                                    "type": "array",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "required": [
                                                                "key",
                                                                "operator"
                                                            ],
                                                            "type": "object"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    },
                                                    "matchLabels": {
                                                        "additionalProperties": {
                                                            "type": "string"
                                                        },
                                                        "type": "object",
                                                        "properties": {},
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "namespaces": {
                                                "items": {
                                                    "type": "string"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            },
                                            "topologyKey": {
                                                "type": "string"
                                            }
                                        },
                                        "required": [
                                            "topologyKey"
                                        ],
                                        "type": "object"
                                    },
                                    "type": "array",
                                    "nullable": true
                                }
                            },
                            "type": "object",
                            "nullable": true
                        },
                        "podAntiAffinity": {
                            "properties": {
                                "preferredDuringSchedulingIgnoredDuringExecution": {
                                    "items": {
                                        "properties": {
                                            "podAffinityTerm": {
                                                "properties": {
                                                    "labelSelector": {
                                                        "properties": {
                                                            "matchExpressions": {
                                                                "items": {
                                                                    "properties": {
                                                                        "key": {
                                                                            "type": "string"
                                                                        },
                                                                        "operator": {
                                                                            "type": "string"
                                                                        },
                                                                        "values": {
                                                                            "items": {
                                                                                "type": "string"
                                                                            },
                                                                            "type": "array",
                                                                            "nullable": true
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "key",
                                                                        "operator"
                                                                    ],
                                                                    "type": "object"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            },
                                                            "matchLabels": {
                                                                "additionalProperties": {
                                                                    "type": "string"
                                                                },
                                                                "type": "object",
                                                                "properties": {},
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "namespaces": {
                                                        "items": {
                                                            "type": "string"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    },
                                                    "topologyKey": {
                                                        "type": "string"
                                                    }
                                                },
                                                "required": [
                                                    "topologyKey"
                                                ],
                                                "type": "object"
                                            },
                                            "weight": {
                                                "format": "int32",
                                                "type": "integer"
                                            }
                                        },
                                        "required": [
                                            "podAffinityTerm",
                                            "weight"
                                        ],
                                        "type": "object"
                                    },
                                    "type": "array",
                                    "nullable": true
                                },
                                "requiredDuringSchedulingIgnoredDuringExecution": {
                                    "items": {
                                        "properties": {
                                            "labelSelector": {
                                                "properties": {
                                                    "matchExpressions": {
                                                        "items": {
                                                            "properties": {
                                                                "key": {
                                                                    "type": "string"
                                                                },
                                                                "operator": {
                                                                    "type": "string"
                                                                },
                                                                "values": {
                                                                    "items": {
                                                                        "type": "string"
                                                                    },
                                                                    "type": "array",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "required": [
                                                                "key",
                                                                "operator"
                                                            ],
                                                            "type": "object"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    },
                                                    "matchLabels": {
                                                        "additionalProperties": {
                                                            "type": "string"
                                                        },
                                                        "type": "object",
                                                        "properties": {},
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "namespaces": {
                                                "items": {
                                                    "type": "string"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            },
                                            "topologyKey": {
                                                "type": "string"
                                            }
                                        },
                                        "required": [
                                            "topologyKey"
                                        ],
                                        "type": "object"
                                    },
                                    "type": "array",
                                    "nullable": true
                                }
                            },
                            "type": "object",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "fromPostgresVersion": {
                    "type": "integer",
                    "minimum": 10,
                    "maximum": 14
                },
                "image": {
                    "type": "string",
                    "nullable": true
                },
                "imagePullPolicy": {
                    "enum": [
                        "Always",
                        "Never",
                        "IfNotPresent"
                    ],
                    "type": "string",
                    "nullable": true
                },
                "imagePullSecrets": {
                    "items": {
                        "properties": {
                            "name": {
                                "type": "string",
                                "nullable": true
                            }
                        },
                        "type": "object"
                    },
                    "type": "array",
                    "nullable": true
                },
                "metadata": {
                    "properties": {
                        "annotations": {
                            "additionalProperties": {
                                "type": "string"
                            },
                            "type": "object",
                            "properties": {},
                            "nullable": true
                        },
                        "labels": {
                            "additionalProperties": {
                                "type": "string"
                            },
                            "type": "object",
                            "properties": {},
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "postgresClusterName": {
                    "minLength": 1,
                    "type": "string"
                },
                "priorityClassName": {
                    "type": "string",
                    "nullable": true
                },
                "resources": {
                    "properties": {
                        "limits": {
                            "additionalProperties": {
                                "anyOf": [
                                    {
                                        "type": "integer"
                                    },
                                    {
                                        "type": "string"
                                    }
                                ],
                                "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                            },
                            "type": "object",
                            "properties": {},
                            "nullable": true
                        },
                        "requests": {
                            "additionalProperties": {
                                "anyOf": [
                                    {
                                        "type": "integer"
                                    },
                                    {
                                        "type": "string"
                                    }
                                ],
                                "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                            },
                            "type": "object",
                            "properties": {},
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "toPostgresImage": {
                    "type": "string",
                    "nullable": true
                },
                "toPostgresVersion": {
                    "type": "integer",
                    "minimum": 10,
                    "maximum": 14
                },
                "tolerations": {
                    "items": {
                        "properties": {
                            "effect": {
                                "type": "string",
                                "nullable": true
                            },
                            "key": {
                                "type": "string",
                                "nullable": true
                            },
                            "operator": {
                                "type": "string",
                                "nullable": true
                            },
                            "tolerationSeconds": {
                                "format": "int64",
                                "type": "integer",
                                "nullable": true
                            },
                            "value": {
                                "type": "string",
                                "nullable": true
                            }
                        },
                        "type": "object"
                    },
                    "type": "array",
                    "nullable": true
                }
            },
            "required": [
                "fromPostgresVersion",
                "postgresClusterName",
                "toPostgresVersion"
            ],
            "type": "object",
            "nullable": true
        },
        "status": {
            "properties": {
                "conditions": {
                    "items": {
                        "properties": {
                            "lastTransitionTime": {
                                "format": "date-time",
                                "type": "string"
                            },
                            "message": {
                                "maxLength": 32768,
                                "type": "string"
                            },
                            "observedGeneration": {
                                "format": "int64",
                                "type": "integer",
                                "minimum": 0,
                                "nullable": true
                            },
                            "reason": {
                                "maxLength": 1024,
                                "minLength": 1,
                                "type": "string",
                                "pattern": "^[A-Za-z]([A-Za-z0-9_,:]*[A-Za-z0-9_])?$"
                            },
                            "status": {
                                "enum": [
                                    "True",
                                    "False",
                                    "Unknown"
                                ],
                                "type": "string"
                            },
                            "type": {
                                "maxLength": 316,
                                "type": "string",
                                "pattern": "^([a-z0-9]([-a-z0-9]*[a-z0-9])?(\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*\\/)?(([A-Za-z0-9][-A-Za-z0-9_.]*)?[A-Za-z0-9])$"
                            }
                        },
                        "required": [
                            "lastTransitionTime",
                            "message",
                            "reason",
                            "status",
                            "type"
                        ],
                        "type": "object"
                    },
                    "type": "array",
                    "nullable": true
                },
                "observedGeneration": {
                    "format": "int64",
                    "type": "integer",
                    "minimum": 0,
                    "nullable": true
                }
            },
            "type": "object",
            "nullable": true
        }
    },
    "required": [
        "apiVersion",
        "kind"
    ]
};
/**
 * PGUpgrade is the Schema for the pgupgrades API
 */
class PGUpgrade extends base_1.Model {
    constructor(data) {
        super({
            apiVersion: PGUpgrade.apiVersion,
            kind: PGUpgrade.kind,
            ...data
        });
    }
}
exports.PGUpgrade = PGUpgrade;
PGUpgrade.apiVersion = "postgres-operator.crunchydata.com/v1beta1";
PGUpgrade.kind = "PGUpgrade";
PGUpgrade.is = (0, base_1.createTypeMetaGuard)(PGUpgrade);
(0, base_1.setSchema)(PGUpgrade, schemaId, () => {
    (0, IoK8sApimachineryPkgApisMetaV1ObjectMeta_1.addSchema)();
    (0, validate_1.register)(schemaId, schema);
});
