"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PostgresCluster = void 0;
const IoK8sApimachineryPkgApisMetaV1ObjectMeta_1 = require("@kubernetes-models/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta");
const base_1 = require("@kubernetes-models/base");
const validate_1 = require("@kubernetes-models/validate");
const schemaId = "postgres-operator.crunchydata.com.v1beta1.PostgresCluster";
const schema = {
    "type": "object",
    "properties": {
        "apiVersion": {
            "type": "string",
            "enum": [
                "postgres-operator.crunchydata.com/v1beta1"
            ]
        },
        "kind": {
            "type": "string",
            "enum": [
                "PostgresCluster"
            ]
        },
        "metadata": {
            "oneOf": [
                {
                    "$ref": "io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta#"
                },
                {
                    "type": "null"
                }
            ]
        },
        "spec": {
            "properties": {
                "backups": {
                    "properties": {
                        "pgbackrest": {
                            "properties": {
                                "configuration": {
                                    "items": {
                                        "properties": {
                                            "configMap": {
                                                "properties": {
                                                    "items": {
                                                        "items": {
                                                            "properties": {
                                                                "key": {
                                                                    "type": "string"
                                                                },
                                                                "mode": {
                                                                    "format": "int32",
                                                                    "type": "integer",
                                                                    "nullable": true
                                                                },
                                                                "path": {
                                                                    "type": "string"
                                                                }
                                                            },
                                                            "required": [
                                                                "key",
                                                                "path"
                                                            ],
                                                            "type": "object"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    },
                                                    "name": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "optional": {
                                                        "type": "boolean",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "downwardAPI": {
                                                "properties": {
                                                    "items": {
                                                        "items": {
                                                            "properties": {
                                                                "fieldRef": {
                                                                    "properties": {
                                                                        "apiVersion": {
                                                                            "type": "string",
                                                                            "nullable": true
                                                                        },
                                                                        "fieldPath": {
                                                                            "type": "string"
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "fieldPath"
                                                                    ],
                                                                    "type": "object",
                                                                    "nullable": true
                                                                },
                                                                "mode": {
                                                                    "format": "int32",
                                                                    "type": "integer",
                                                                    "nullable": true
                                                                },
                                                                "path": {
                                                                    "type": "string"
                                                                },
                                                                "resourceFieldRef": {
                                                                    "properties": {
                                                                        "containerName": {
                                                                            "type": "string",
                                                                            "nullable": true
                                                                        },
                                                                        "divisor": {
                                                                            "oneOf": [
                                                                                {
                                                                                    "anyOf": [
                                                                                        {
                                                                                            "type": "integer"
                                                                                        },
                                                                                        {
                                                                                            "type": "string"
                                                                                        }
                                                                                    ],
                                                                                    "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                                                },
                                                                                {
                                                                                    "type": "null"
                                                                                }
                                                                            ]
                                                                        },
                                                                        "resource": {
                                                                            "type": "string"
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "resource"
                                                                    ],
                                                                    "type": "object",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "required": [
                                                                "path"
                                                            ],
                                                            "type": "object"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "secret": {
                                                "properties": {
                                                    "items": {
                                                        "items": {
                                                            "properties": {
                                                                "key": {
                                                                    "type": "string"
                                                                },
                                                                "mode": {
                                                                    "format": "int32",
                                                                    "type": "integer",
                                                                    "nullable": true
                                                                },
                                                                "path": {
                                                                    "type": "string"
                                                                }
                                                            },
                                                            "required": [
                                                                "key",
                                                                "path"
                                                            ],
                                                            "type": "object"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    },
                                                    "name": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "optional": {
                                                        "type": "boolean",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "serviceAccountToken": {
                                                "properties": {
                                                    "audience": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "expirationSeconds": {
                                                        "format": "int64",
                                                        "type": "integer",
                                                        "nullable": true
                                                    },
                                                    "path": {
                                                        "type": "string"
                                                    }
                                                },
                                                "required": [
                                                    "path"
                                                ],
                                                "type": "object",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object"
                                    },
                                    "type": "array",
                                    "nullable": true
                                },
                                "global": {
                                    "additionalProperties": {
                                        "type": "string"
                                    },
                                    "type": "object",
                                    "properties": {},
                                    "nullable": true
                                },
                                "image": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "jobs": {
                                    "properties": {
                                        "affinity": {
                                            "properties": {
                                                "nodeAffinity": {
                                                    "properties": {
                                                        "preferredDuringSchedulingIgnoredDuringExecution": {
                                                            "items": {
                                                                "properties": {
                                                                    "preference": {
                                                                        "properties": {
                                                                            "matchExpressions": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "matchFields": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object"
                                                                    },
                                                                    "weight": {
                                                                        "format": "int32",
                                                                        "type": "integer"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "preference",
                                                                    "weight"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        },
                                                        "requiredDuringSchedulingIgnoredDuringExecution": {
                                                            "properties": {
                                                                "nodeSelectorTerms": {
                                                                    "items": {
                                                                        "properties": {
                                                                            "matchExpressions": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "matchFields": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object"
                                                                    },
                                                                    "type": "array"
                                                                }
                                                            },
                                                            "required": [
                                                                "nodeSelectorTerms"
                                                            ],
                                                            "type": "object",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "podAffinity": {
                                                    "properties": {
                                                        "preferredDuringSchedulingIgnoredDuringExecution": {
                                                            "items": {
                                                                "properties": {
                                                                    "podAffinityTerm": {
                                                                        "properties": {
                                                                            "labelSelector": {
                                                                                "properties": {
                                                                                    "matchExpressions": {
                                                                                        "items": {
                                                                                            "properties": {
                                                                                                "key": {
                                                                                                    "type": "string"
                                                                                                },
                                                                                                "operator": {
                                                                                                    "type": "string"
                                                                                                },
                                                                                                "values": {
                                                                                                    "items": {
                                                                                                        "type": "string"
                                                                                                    },
                                                                                                    "type": "array",
                                                                                                    "nullable": true
                                                                                                }
                                                                                            },
                                                                                            "required": [
                                                                                                "key",
                                                                                                "operator"
                                                                                            ],
                                                                                            "type": "object"
                                                                                        },
                                                                                        "type": "array",
                                                                                        "nullable": true
                                                                                    },
                                                                                    "matchLabels": {
                                                                                        "additionalProperties": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "type": "object",
                                                                                        "properties": {},
                                                                                        "nullable": true
                                                                                    }
                                                                                },
                                                                                "type": "object",
                                                                                "nullable": true
                                                                            },
                                                                            "namespaces": {
                                                                                "items": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "topologyKey": {
                                                                                "type": "string"
                                                                            }
                                                                        },
                                                                        "required": [
                                                                            "topologyKey"
                                                                        ],
                                                                        "type": "object"
                                                                    },
                                                                    "weight": {
                                                                        "format": "int32",
                                                                        "type": "integer"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "podAffinityTerm",
                                                                    "weight"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        },
                                                        "requiredDuringSchedulingIgnoredDuringExecution": {
                                                            "items": {
                                                                "properties": {
                                                                    "labelSelector": {
                                                                        "properties": {
                                                                            "matchExpressions": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "matchLabels": {
                                                                                "additionalProperties": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "object",
                                                                                "properties": {},
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "namespaces": {
                                                                        "items": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "topologyKey": {
                                                                        "type": "string"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "topologyKey"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "podAntiAffinity": {
                                                    "properties": {
                                                        "preferredDuringSchedulingIgnoredDuringExecution": {
                                                            "items": {
                                                                "properties": {
                                                                    "podAffinityTerm": {
                                                                        "properties": {
                                                                            "labelSelector": {
                                                                                "properties": {
                                                                                    "matchExpressions": {
                                                                                        "items": {
                                                                                            "properties": {
                                                                                                "key": {
                                                                                                    "type": "string"
                                                                                                },
                                                                                                "operator": {
                                                                                                    "type": "string"
                                                                                                },
                                                                                                "values": {
                                                                                                    "items": {
                                                                                                        "type": "string"
                                                                                                    },
                                                                                                    "type": "array",
                                                                                                    "nullable": true
                                                                                                }
                                                                                            },
                                                                                            "required": [
                                                                                                "key",
                                                                                                "operator"
                                                                                            ],
                                                                                            "type": "object"
                                                                                        },
                                                                                        "type": "array",
                                                                                        "nullable": true
                                                                                    },
                                                                                    "matchLabels": {
                                                                                        "additionalProperties": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "type": "object",
                                                                                        "properties": {},
                                                                                        "nullable": true
                                                                                    }
                                                                                },
                                                                                "type": "object",
                                                                                "nullable": true
                                                                            },
                                                                            "namespaces": {
                                                                                "items": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "topologyKey": {
                                                                                "type": "string"
                                                                            }
                                                                        },
                                                                        "required": [
                                                                            "topologyKey"
                                                                        ],
                                                                        "type": "object"
                                                                    },
                                                                    "weight": {
                                                                        "format": "int32",
                                                                        "type": "integer"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "podAffinityTerm",
                                                                    "weight"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        },
                                                        "requiredDuringSchedulingIgnoredDuringExecution": {
                                                            "items": {
                                                                "properties": {
                                                                    "labelSelector": {
                                                                        "properties": {
                                                                            "matchExpressions": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "matchLabels": {
                                                                                "additionalProperties": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "object",
                                                                                "properties": {},
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "namespaces": {
                                                                        "items": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "topologyKey": {
                                                                        "type": "string"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "topologyKey"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "priorityClassName": {
                                            "type": "string",
                                            "nullable": true
                                        },
                                        "resources": {
                                            "properties": {
                                                "limits": {
                                                    "additionalProperties": {
                                                        "anyOf": [
                                                            {
                                                                "type": "integer"
                                                            },
                                                            {
                                                                "type": "string"
                                                            }
                                                        ],
                                                        "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                    },
                                                    "type": "object",
                                                    "properties": {},
                                                    "nullable": true
                                                },
                                                "requests": {
                                                    "additionalProperties": {
                                                        "anyOf": [
                                                            {
                                                                "type": "integer"
                                                            },
                                                            {
                                                                "type": "string"
                                                            }
                                                        ],
                                                        "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                    },
                                                    "type": "object",
                                                    "properties": {},
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "tolerations": {
                                            "items": {
                                                "properties": {
                                                    "effect": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "key": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "operator": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "tolerationSeconds": {
                                                        "format": "int64",
                                                        "type": "integer",
                                                        "nullable": true
                                                    },
                                                    "value": {
                                                        "type": "string",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "manual": {
                                    "properties": {
                                        "options": {
                                            "items": {
                                                "type": "string"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        },
                                        "repoName": {
                                            "type": "string",
                                            "pattern": "^repo[1-4]"
                                        }
                                    },
                                    "required": [
                                        "repoName"
                                    ],
                                    "type": "object",
                                    "nullable": true
                                },
                                "metadata": {
                                    "properties": {
                                        "annotations": {
                                            "additionalProperties": {
                                                "type": "string"
                                            },
                                            "type": "object",
                                            "properties": {},
                                            "nullable": true
                                        },
                                        "labels": {
                                            "additionalProperties": {
                                                "type": "string"
                                            },
                                            "type": "object",
                                            "properties": {},
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "repoHost": {
                                    "properties": {
                                        "affinity": {
                                            "properties": {
                                                "nodeAffinity": {
                                                    "properties": {
                                                        "preferredDuringSchedulingIgnoredDuringExecution": {
                                                            "items": {
                                                                "properties": {
                                                                    "preference": {
                                                                        "properties": {
                                                                            "matchExpressions": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "matchFields": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object"
                                                                    },
                                                                    "weight": {
                                                                        "format": "int32",
                                                                        "type": "integer"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "preference",
                                                                    "weight"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        },
                                                        "requiredDuringSchedulingIgnoredDuringExecution": {
                                                            "properties": {
                                                                "nodeSelectorTerms": {
                                                                    "items": {
                                                                        "properties": {
                                                                            "matchExpressions": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "matchFields": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object"
                                                                    },
                                                                    "type": "array"
                                                                }
                                                            },
                                                            "required": [
                                                                "nodeSelectorTerms"
                                                            ],
                                                            "type": "object",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "podAffinity": {
                                                    "properties": {
                                                        "preferredDuringSchedulingIgnoredDuringExecution": {
                                                            "items": {
                                                                "properties": {
                                                                    "podAffinityTerm": {
                                                                        "properties": {
                                                                            "labelSelector": {
                                                                                "properties": {
                                                                                    "matchExpressions": {
                                                                                        "items": {
                                                                                            "properties": {
                                                                                                "key": {
                                                                                                    "type": "string"
                                                                                                },
                                                                                                "operator": {
                                                                                                    "type": "string"
                                                                                                },
                                                                                                "values": {
                                                                                                    "items": {
                                                                                                        "type": "string"
                                                                                                    },
                                                                                                    "type": "array",
                                                                                                    "nullable": true
                                                                                                }
                                                                                            },
                                                                                            "required": [
                                                                                                "key",
                                                                                                "operator"
                                                                                            ],
                                                                                            "type": "object"
                                                                                        },
                                                                                        "type": "array",
                                                                                        "nullable": true
                                                                                    },
                                                                                    "matchLabels": {
                                                                                        "additionalProperties": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "type": "object",
                                                                                        "properties": {},
                                                                                        "nullable": true
                                                                                    }
                                                                                },
                                                                                "type": "object",
                                                                                "nullable": true
                                                                            },
                                                                            "namespaces": {
                                                                                "items": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "topologyKey": {
                                                                                "type": "string"
                                                                            }
                                                                        },
                                                                        "required": [
                                                                            "topologyKey"
                                                                        ],
                                                                        "type": "object"
                                                                    },
                                                                    "weight": {
                                                                        "format": "int32",
                                                                        "type": "integer"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "podAffinityTerm",
                                                                    "weight"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        },
                                                        "requiredDuringSchedulingIgnoredDuringExecution": {
                                                            "items": {
                                                                "properties": {
                                                                    "labelSelector": {
                                                                        "properties": {
                                                                            "matchExpressions": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "matchLabels": {
                                                                                "additionalProperties": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "object",
                                                                                "properties": {},
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "namespaces": {
                                                                        "items": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "topologyKey": {
                                                                        "type": "string"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "topologyKey"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "podAntiAffinity": {
                                                    "properties": {
                                                        "preferredDuringSchedulingIgnoredDuringExecution": {
                                                            "items": {
                                                                "properties": {
                                                                    "podAffinityTerm": {
                                                                        "properties": {
                                                                            "labelSelector": {
                                                                                "properties": {
                                                                                    "matchExpressions": {
                                                                                        "items": {
                                                                                            "properties": {
                                                                                                "key": {
                                                                                                    "type": "string"
                                                                                                },
                                                                                                "operator": {
                                                                                                    "type": "string"
                                                                                                },
                                                                                                "values": {
                                                                                                    "items": {
                                                                                                        "type": "string"
                                                                                                    },
                                                                                                    "type": "array",
                                                                                                    "nullable": true
                                                                                                }
                                                                                            },
                                                                                            "required": [
                                                                                                "key",
                                                                                                "operator"
                                                                                            ],
                                                                                            "type": "object"
                                                                                        },
                                                                                        "type": "array",
                                                                                        "nullable": true
                                                                                    },
                                                                                    "matchLabels": {
                                                                                        "additionalProperties": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "type": "object",
                                                                                        "properties": {},
                                                                                        "nullable": true
                                                                                    }
                                                                                },
                                                                                "type": "object",
                                                                                "nullable": true
                                                                            },
                                                                            "namespaces": {
                                                                                "items": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "topologyKey": {
                                                                                "type": "string"
                                                                            }
                                                                        },
                                                                        "required": [
                                                                            "topologyKey"
                                                                        ],
                                                                        "type": "object"
                                                                    },
                                                                    "weight": {
                                                                        "format": "int32",
                                                                        "type": "integer"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "podAffinityTerm",
                                                                    "weight"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        },
                                                        "requiredDuringSchedulingIgnoredDuringExecution": {
                                                            "items": {
                                                                "properties": {
                                                                    "labelSelector": {
                                                                        "properties": {
                                                                            "matchExpressions": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "matchLabels": {
                                                                                "additionalProperties": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "object",
                                                                                "properties": {},
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "namespaces": {
                                                                        "items": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "topologyKey": {
                                                                        "type": "string"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "topologyKey"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "priorityClassName": {
                                            "type": "string",
                                            "nullable": true
                                        },
                                        "resources": {
                                            "properties": {
                                                "limits": {
                                                    "additionalProperties": {
                                                        "anyOf": [
                                                            {
                                                                "type": "integer"
                                                            },
                                                            {
                                                                "type": "string"
                                                            }
                                                        ],
                                                        "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                    },
                                                    "type": "object",
                                                    "properties": {},
                                                    "nullable": true
                                                },
                                                "requests": {
                                                    "additionalProperties": {
                                                        "anyOf": [
                                                            {
                                                                "type": "integer"
                                                            },
                                                            {
                                                                "type": "string"
                                                            }
                                                        ],
                                                        "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                    },
                                                    "type": "object",
                                                    "properties": {},
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "sshConfigMap": {
                                            "properties": {
                                                "items": {
                                                    "items": {
                                                        "properties": {
                                                            "key": {
                                                                "type": "string"
                                                            },
                                                            "mode": {
                                                                "format": "int32",
                                                                "type": "integer",
                                                                "nullable": true
                                                            },
                                                            "path": {
                                                                "type": "string"
                                                            }
                                                        },
                                                        "required": [
                                                            "key",
                                                            "path"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                },
                                                "name": {
                                                    "type": "string",
                                                    "nullable": true
                                                },
                                                "optional": {
                                                    "type": "boolean",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "sshSecret": {
                                            "properties": {
                                                "items": {
                                                    "items": {
                                                        "properties": {
                                                            "key": {
                                                                "type": "string"
                                                            },
                                                            "mode": {
                                                                "format": "int32",
                                                                "type": "integer",
                                                                "nullable": true
                                                            },
                                                            "path": {
                                                                "type": "string"
                                                            }
                                                        },
                                                        "required": [
                                                            "key",
                                                            "path"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                },
                                                "name": {
                                                    "type": "string",
                                                    "nullable": true
                                                },
                                                "optional": {
                                                    "type": "boolean",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "tolerations": {
                                            "items": {
                                                "properties": {
                                                    "effect": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "key": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "operator": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "tolerationSeconds": {
                                                        "format": "int64",
                                                        "type": "integer",
                                                        "nullable": true
                                                    },
                                                    "value": {
                                                        "type": "string",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        },
                                        "topologySpreadConstraints": {
                                            "items": {
                                                "properties": {
                                                    "labelSelector": {
                                                        "properties": {
                                                            "matchExpressions": {
                                                                "items": {
                                                                    "properties": {
                                                                        "key": {
                                                                            "type": "string"
                                                                        },
                                                                        "operator": {
                                                                            "type": "string"
                                                                        },
                                                                        "values": {
                                                                            "items": {
                                                                                "type": "string"
                                                                            },
                                                                            "type": "array",
                                                                            "nullable": true
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "key",
                                                                        "operator"
                                                                    ],
                                                                    "type": "object"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            },
                                                            "matchLabels": {
                                                                "additionalProperties": {
                                                                    "type": "string"
                                                                },
                                                                "type": "object",
                                                                "properties": {},
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "maxSkew": {
                                                        "format": "int32",
                                                        "type": "integer"
                                                    },
                                                    "topologyKey": {
                                                        "type": "string"
                                                    },
                                                    "whenUnsatisfiable": {
                                                        "type": "string"
                                                    }
                                                },
                                                "required": [
                                                    "maxSkew",
                                                    "topologyKey",
                                                    "whenUnsatisfiable"
                                                ],
                                                "type": "object"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "repos": {
                                    "items": {
                                        "properties": {
                                            "azure": {
                                                "properties": {
                                                    "container": {
                                                        "type": "string"
                                                    }
                                                },
                                                "required": [
                                                    "container"
                                                ],
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "gcs": {
                                                "properties": {
                                                    "bucket": {
                                                        "type": "string"
                                                    }
                                                },
                                                "required": [
                                                    "bucket"
                                                ],
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "name": {
                                                "type": "string",
                                                "pattern": "^repo[1-4]"
                                            },
                                            "s3": {
                                                "properties": {
                                                    "bucket": {
                                                        "type": "string"
                                                    },
                                                    "endpoint": {
                                                        "type": "string"
                                                    },
                                                    "region": {
                                                        "type": "string"
                                                    }
                                                },
                                                "required": [
                                                    "bucket",
                                                    "endpoint",
                                                    "region"
                                                ],
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "schedules": {
                                                "properties": {
                                                    "differential": {
                                                        "minLength": 6,
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "full": {
                                                        "minLength": 6,
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "incremental": {
                                                        "minLength": 6,
                                                        "type": "string",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "volume": {
                                                "properties": {
                                                    "volumeClaimSpec": {
                                                        "properties": {
                                                            "accessModes": {
                                                                "items": {
                                                                    "type": "string"
                                                                },
                                                                "minItems": 1,
                                                                "type": "array"
                                                            },
                                                            "dataSource": {
                                                                "properties": {
                                                                    "apiGroup": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    },
                                                                    "kind": {
                                                                        "type": "string"
                                                                    },
                                                                    "name": {
                                                                        "type": "string"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "kind",
                                                                    "name"
                                                                ],
                                                                "type": "object",
                                                                "nullable": true
                                                            },
                                                            "resources": {
                                                                "properties": {
                                                                    "limits": {
                                                                        "additionalProperties": {
                                                                            "anyOf": [
                                                                                {
                                                                                    "type": "integer"
                                                                                },
                                                                                {
                                                                                    "type": "string"
                                                                                }
                                                                            ],
                                                                            "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                                        },
                                                                        "type": "object",
                                                                        "properties": {},
                                                                        "nullable": true
                                                                    },
                                                                    "requests": {
                                                                        "additionalProperties": {
                                                                            "anyOf": [
                                                                                {
                                                                                    "type": "integer"
                                                                                },
                                                                                {
                                                                                    "type": "string"
                                                                                }
                                                                            ],
                                                                            "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                                        },
                                                                        "required": [
                                                                            "storage"
                                                                        ],
                                                                        "type": "object",
                                                                        "properties": {}
                                                                    }
                                                                },
                                                                "required": [
                                                                    "requests"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "selector": {
                                                                "properties": {
                                                                    "matchExpressions": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "matchLabels": {
                                                                        "additionalProperties": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "object",
                                                                        "properties": {},
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object",
                                                                "nullable": true
                                                            },
                                                            "storageClassName": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "volumeMode": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "volumeName": {
                                                                "type": "string",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "required": [
                                                            "accessModes",
                                                            "resources"
                                                        ],
                                                        "type": "object"
                                                    }
                                                },
                                                "required": [
                                                    "volumeClaimSpec"
                                                ],
                                                "type": "object",
                                                "nullable": true
                                            }
                                        },
                                        "required": [
                                            "name"
                                        ],
                                        "type": "object"
                                    },
                                    "minItems": 1,
                                    "type": "array"
                                },
                                "restore": {
                                    "properties": {
                                        "affinity": {
                                            "properties": {
                                                "nodeAffinity": {
                                                    "properties": {
                                                        "preferredDuringSchedulingIgnoredDuringExecution": {
                                                            "items": {
                                                                "properties": {
                                                                    "preference": {
                                                                        "properties": {
                                                                            "matchExpressions": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "matchFields": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object"
                                                                    },
                                                                    "weight": {
                                                                        "format": "int32",
                                                                        "type": "integer"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "preference",
                                                                    "weight"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        },
                                                        "requiredDuringSchedulingIgnoredDuringExecution": {
                                                            "properties": {
                                                                "nodeSelectorTerms": {
                                                                    "items": {
                                                                        "properties": {
                                                                            "matchExpressions": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "matchFields": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object"
                                                                    },
                                                                    "type": "array"
                                                                }
                                                            },
                                                            "required": [
                                                                "nodeSelectorTerms"
                                                            ],
                                                            "type": "object",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "podAffinity": {
                                                    "properties": {
                                                        "preferredDuringSchedulingIgnoredDuringExecution": {
                                                            "items": {
                                                                "properties": {
                                                                    "podAffinityTerm": {
                                                                        "properties": {
                                                                            "labelSelector": {
                                                                                "properties": {
                                                                                    "matchExpressions": {
                                                                                        "items": {
                                                                                            "properties": {
                                                                                                "key": {
                                                                                                    "type": "string"
                                                                                                },
                                                                                                "operator": {
                                                                                                    "type": "string"
                                                                                                },
                                                                                                "values": {
                                                                                                    "items": {
                                                                                                        "type": "string"
                                                                                                    },
                                                                                                    "type": "array",
                                                                                                    "nullable": true
                                                                                                }
                                                                                            },
                                                                                            "required": [
                                                                                                "key",
                                                                                                "operator"
                                                                                            ],
                                                                                            "type": "object"
                                                                                        },
                                                                                        "type": "array",
                                                                                        "nullable": true
                                                                                    },
                                                                                    "matchLabels": {
                                                                                        "additionalProperties": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "type": "object",
                                                                                        "properties": {},
                                                                                        "nullable": true
                                                                                    }
                                                                                },
                                                                                "type": "object",
                                                                                "nullable": true
                                                                            },
                                                                            "namespaces": {
                                                                                "items": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "topologyKey": {
                                                                                "type": "string"
                                                                            }
                                                                        },
                                                                        "required": [
                                                                            "topologyKey"
                                                                        ],
                                                                        "type": "object"
                                                                    },
                                                                    "weight": {
                                                                        "format": "int32",
                                                                        "type": "integer"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "podAffinityTerm",
                                                                    "weight"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        },
                                                        "requiredDuringSchedulingIgnoredDuringExecution": {
                                                            "items": {
                                                                "properties": {
                                                                    "labelSelector": {
                                                                        "properties": {
                                                                            "matchExpressions": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "matchLabels": {
                                                                                "additionalProperties": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "object",
                                                                                "properties": {},
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "namespaces": {
                                                                        "items": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "topologyKey": {
                                                                        "type": "string"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "topologyKey"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "podAntiAffinity": {
                                                    "properties": {
                                                        "preferredDuringSchedulingIgnoredDuringExecution": {
                                                            "items": {
                                                                "properties": {
                                                                    "podAffinityTerm": {
                                                                        "properties": {
                                                                            "labelSelector": {
                                                                                "properties": {
                                                                                    "matchExpressions": {
                                                                                        "items": {
                                                                                            "properties": {
                                                                                                "key": {
                                                                                                    "type": "string"
                                                                                                },
                                                                                                "operator": {
                                                                                                    "type": "string"
                                                                                                },
                                                                                                "values": {
                                                                                                    "items": {
                                                                                                        "type": "string"
                                                                                                    },
                                                                                                    "type": "array",
                                                                                                    "nullable": true
                                                                                                }
                                                                                            },
                                                                                            "required": [
                                                                                                "key",
                                                                                                "operator"
                                                                                            ],
                                                                                            "type": "object"
                                                                                        },
                                                                                        "type": "array",
                                                                                        "nullable": true
                                                                                    },
                                                                                    "matchLabels": {
                                                                                        "additionalProperties": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "type": "object",
                                                                                        "properties": {},
                                                                                        "nullable": true
                                                                                    }
                                                                                },
                                                                                "type": "object",
                                                                                "nullable": true
                                                                            },
                                                                            "namespaces": {
                                                                                "items": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "topologyKey": {
                                                                                "type": "string"
                                                                            }
                                                                        },
                                                                        "required": [
                                                                            "topologyKey"
                                                                        ],
                                                                        "type": "object"
                                                                    },
                                                                    "weight": {
                                                                        "format": "int32",
                                                                        "type": "integer"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "podAffinityTerm",
                                                                    "weight"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        },
                                                        "requiredDuringSchedulingIgnoredDuringExecution": {
                                                            "items": {
                                                                "properties": {
                                                                    "labelSelector": {
                                                                        "properties": {
                                                                            "matchExpressions": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "matchLabels": {
                                                                                "additionalProperties": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "object",
                                                                                "properties": {},
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "namespaces": {
                                                                        "items": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "topologyKey": {
                                                                        "type": "string"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "topologyKey"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "clusterName": {
                                            "type": "string",
                                            "nullable": true
                                        },
                                        "clusterNamespace": {
                                            "type": "string",
                                            "nullable": true
                                        },
                                        "enabled": {
                                            "default": false,
                                            "type": "boolean"
                                        },
                                        "options": {
                                            "items": {
                                                "type": "string"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        },
                                        "priorityClassName": {
                                            "type": "string",
                                            "nullable": true
                                        },
                                        "repoName": {
                                            "type": "string",
                                            "pattern": "^repo[1-4]"
                                        },
                                        "resources": {
                                            "properties": {
                                                "limits": {
                                                    "additionalProperties": {
                                                        "anyOf": [
                                                            {
                                                                "type": "integer"
                                                            },
                                                            {
                                                                "type": "string"
                                                            }
                                                        ],
                                                        "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                    },
                                                    "type": "object",
                                                    "properties": {},
                                                    "nullable": true
                                                },
                                                "requests": {
                                                    "additionalProperties": {
                                                        "anyOf": [
                                                            {
                                                                "type": "integer"
                                                            },
                                                            {
                                                                "type": "string"
                                                            }
                                                        ],
                                                        "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                    },
                                                    "type": "object",
                                                    "properties": {},
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "tolerations": {
                                            "items": {
                                                "properties": {
                                                    "effect": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "key": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "operator": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "tolerationSeconds": {
                                                        "format": "int64",
                                                        "type": "integer",
                                                        "nullable": true
                                                    },
                                                    "value": {
                                                        "type": "string",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        }
                                    },
                                    "required": [
                                        "enabled",
                                        "repoName"
                                    ],
                                    "type": "object",
                                    "nullable": true
                                },
                                "sidecars": {
                                    "properties": {
                                        "pgbackrest": {
                                            "properties": {
                                                "resources": {
                                                    "properties": {
                                                        "limits": {
                                                            "additionalProperties": {
                                                                "anyOf": [
                                                                    {
                                                                        "type": "integer"
                                                                    },
                                                                    {
                                                                        "type": "string"
                                                                    }
                                                                ],
                                                                "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                            },
                                                            "type": "object",
                                                            "properties": {},
                                                            "nullable": true
                                                        },
                                                        "requests": {
                                                            "additionalProperties": {
                                                                "anyOf": [
                                                                    {
                                                                        "type": "integer"
                                                                    },
                                                                    {
                                                                        "type": "string"
                                                                    }
                                                                ],
                                                                "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                            },
                                                            "type": "object",
                                                            "properties": {},
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "pgbackrestConfig": {
                                            "properties": {
                                                "resources": {
                                                    "properties": {
                                                        "limits": {
                                                            "additionalProperties": {
                                                                "anyOf": [
                                                                    {
                                                                        "type": "integer"
                                                                    },
                                                                    {
                                                                        "type": "string"
                                                                    }
                                                                ],
                                                                "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                            },
                                                            "type": "object",
                                                            "properties": {},
                                                            "nullable": true
                                                        },
                                                        "requests": {
                                                            "additionalProperties": {
                                                                "anyOf": [
                                                                    {
                                                                        "type": "integer"
                                                                    },
                                                                    {
                                                                        "type": "string"
                                                                    }
                                                                ],
                                                                "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                            },
                                                            "type": "object",
                                                            "properties": {},
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                }
                            },
                            "required": [
                                "repos"
                            ],
                            "type": "object"
                        }
                    },
                    "required": [
                        "pgbackrest"
                    ],
                    "type": "object"
                },
                "config": {
                    "properties": {
                        "files": {
                            "items": {
                                "properties": {
                                    "configMap": {
                                        "properties": {
                                            "items": {
                                                "items": {
                                                    "properties": {
                                                        "key": {
                                                            "type": "string"
                                                        },
                                                        "mode": {
                                                            "format": "int32",
                                                            "type": "integer",
                                                            "nullable": true
                                                        },
                                                        "path": {
                                                            "type": "string"
                                                        }
                                                    },
                                                    "required": [
                                                        "key",
                                                        "path"
                                                    ],
                                                    "type": "object"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            },
                                            "name": {
                                                "type": "string",
                                                "nullable": true
                                            },
                                            "optional": {
                                                "type": "boolean",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    },
                                    "downwardAPI": {
                                        "properties": {
                                            "items": {
                                                "items": {
                                                    "properties": {
                                                        "fieldRef": {
                                                            "properties": {
                                                                "apiVersion": {
                                                                    "type": "string",
                                                                    "nullable": true
                                                                },
                                                                "fieldPath": {
                                                                    "type": "string"
                                                                }
                                                            },
                                                            "required": [
                                                                "fieldPath"
                                                            ],
                                                            "type": "object",
                                                            "nullable": true
                                                        },
                                                        "mode": {
                                                            "format": "int32",
                                                            "type": "integer",
                                                            "nullable": true
                                                        },
                                                        "path": {
                                                            "type": "string"
                                                        },
                                                        "resourceFieldRef": {
                                                            "properties": {
                                                                "containerName": {
                                                                    "type": "string",
                                                                    "nullable": true
                                                                },
                                                                "divisor": {
                                                                    "oneOf": [
                                                                        {
                                                                            "anyOf": [
                                                                                {
                                                                                    "type": "integer"
                                                                                },
                                                                                {
                                                                                    "type": "string"
                                                                                }
                                                                            ],
                                                                            "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                                        },
                                                                        {
                                                                            "type": "null"
                                                                        }
                                                                    ]
                                                                },
                                                                "resource": {
                                                                    "type": "string"
                                                                }
                                                            },
                                                            "required": [
                                                                "resource"
                                                            ],
                                                            "type": "object",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "required": [
                                                        "path"
                                                    ],
                                                    "type": "object"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    },
                                    "secret": {
                                        "properties": {
                                            "items": {
                                                "items": {
                                                    "properties": {
                                                        "key": {
                                                            "type": "string"
                                                        },
                                                        "mode": {
                                                            "format": "int32",
                                                            "type": "integer",
                                                            "nullable": true
                                                        },
                                                        "path": {
                                                            "type": "string"
                                                        }
                                                    },
                                                    "required": [
                                                        "key",
                                                        "path"
                                                    ],
                                                    "type": "object"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            },
                                            "name": {
                                                "type": "string",
                                                "nullable": true
                                            },
                                            "optional": {
                                                "type": "boolean",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    },
                                    "serviceAccountToken": {
                                        "properties": {
                                            "audience": {
                                                "type": "string",
                                                "nullable": true
                                            },
                                            "expirationSeconds": {
                                                "format": "int64",
                                                "type": "integer",
                                                "nullable": true
                                            },
                                            "path": {
                                                "type": "string"
                                            }
                                        },
                                        "required": [
                                            "path"
                                        ],
                                        "type": "object",
                                        "nullable": true
                                    }
                                },
                                "type": "object"
                            },
                            "type": "array",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "customReplicationTLSSecret": {
                    "properties": {
                        "items": {
                            "items": {
                                "properties": {
                                    "key": {
                                        "type": "string"
                                    },
                                    "mode": {
                                        "format": "int32",
                                        "type": "integer",
                                        "nullable": true
                                    },
                                    "path": {
                                        "type": "string"
                                    }
                                },
                                "required": [
                                    "key",
                                    "path"
                                ],
                                "type": "object"
                            },
                            "type": "array",
                            "nullable": true
                        },
                        "name": {
                            "type": "string",
                            "nullable": true
                        },
                        "optional": {
                            "type": "boolean",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "customTLSSecret": {
                    "properties": {
                        "items": {
                            "items": {
                                "properties": {
                                    "key": {
                                        "type": "string"
                                    },
                                    "mode": {
                                        "format": "int32",
                                        "type": "integer",
                                        "nullable": true
                                    },
                                    "path": {
                                        "type": "string"
                                    }
                                },
                                "required": [
                                    "key",
                                    "path"
                                ],
                                "type": "object"
                            },
                            "type": "array",
                            "nullable": true
                        },
                        "name": {
                            "type": "string",
                            "nullable": true
                        },
                        "optional": {
                            "type": "boolean",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "dataSource": {
                    "properties": {
                        "pgbackrest": {
                            "properties": {
                                "affinity": {
                                    "properties": {
                                        "nodeAffinity": {
                                            "properties": {
                                                "preferredDuringSchedulingIgnoredDuringExecution": {
                                                    "items": {
                                                        "properties": {
                                                            "preference": {
                                                                "properties": {
                                                                    "matchExpressions": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "matchFields": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object"
                                                            },
                                                            "weight": {
                                                                "format": "int32",
                                                                "type": "integer"
                                                            }
                                                        },
                                                        "required": [
                                                            "preference",
                                                            "weight"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                },
                                                "requiredDuringSchedulingIgnoredDuringExecution": {
                                                    "properties": {
                                                        "nodeSelectorTerms": {
                                                            "items": {
                                                                "properties": {
                                                                    "matchExpressions": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "matchFields": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object"
                                                            },
                                                            "type": "array"
                                                        }
                                                    },
                                                    "required": [
                                                        "nodeSelectorTerms"
                                                    ],
                                                    "type": "object",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "podAffinity": {
                                            "properties": {
                                                "preferredDuringSchedulingIgnoredDuringExecution": {
                                                    "items": {
                                                        "properties": {
                                                            "podAffinityTerm": {
                                                                "properties": {
                                                                    "labelSelector": {
                                                                        "properties": {
                                                                            "matchExpressions": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "matchLabels": {
                                                                                "additionalProperties": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "object",
                                                                                "properties": {},
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "namespaces": {
                                                                        "items": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "topologyKey": {
                                                                        "type": "string"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "topologyKey"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "weight": {
                                                                "format": "int32",
                                                                "type": "integer"
                                                            }
                                                        },
                                                        "required": [
                                                            "podAffinityTerm",
                                                            "weight"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                },
                                                "requiredDuringSchedulingIgnoredDuringExecution": {
                                                    "items": {
                                                        "properties": {
                                                            "labelSelector": {
                                                                "properties": {
                                                                    "matchExpressions": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "matchLabels": {
                                                                        "additionalProperties": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "object",
                                                                        "properties": {},
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object",
                                                                "nullable": true
                                                            },
                                                            "namespaces": {
                                                                "items": {
                                                                    "type": "string"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            },
                                                            "topologyKey": {
                                                                "type": "string"
                                                            }
                                                        },
                                                        "required": [
                                                            "topologyKey"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "podAntiAffinity": {
                                            "properties": {
                                                "preferredDuringSchedulingIgnoredDuringExecution": {
                                                    "items": {
                                                        "properties": {
                                                            "podAffinityTerm": {
                                                                "properties": {
                                                                    "labelSelector": {
                                                                        "properties": {
                                                                            "matchExpressions": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "matchLabels": {
                                                                                "additionalProperties": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "object",
                                                                                "properties": {},
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "namespaces": {
                                                                        "items": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "topologyKey": {
                                                                        "type": "string"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "topologyKey"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "weight": {
                                                                "format": "int32",
                                                                "type": "integer"
                                                            }
                                                        },
                                                        "required": [
                                                            "podAffinityTerm",
                                                            "weight"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                },
                                                "requiredDuringSchedulingIgnoredDuringExecution": {
                                                    "items": {
                                                        "properties": {
                                                            "labelSelector": {
                                                                "properties": {
                                                                    "matchExpressions": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "matchLabels": {
                                                                        "additionalProperties": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "object",
                                                                        "properties": {},
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object",
                                                                "nullable": true
                                                            },
                                                            "namespaces": {
                                                                "items": {
                                                                    "type": "string"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            },
                                                            "topologyKey": {
                                                                "type": "string"
                                                            }
                                                        },
                                                        "required": [
                                                            "topologyKey"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "configuration": {
                                    "items": {
                                        "properties": {
                                            "configMap": {
                                                "properties": {
                                                    "items": {
                                                        "items": {
                                                            "properties": {
                                                                "key": {
                                                                    "type": "string"
                                                                },
                                                                "mode": {
                                                                    "format": "int32",
                                                                    "type": "integer",
                                                                    "nullable": true
                                                                },
                                                                "path": {
                                                                    "type": "string"
                                                                }
                                                            },
                                                            "required": [
                                                                "key",
                                                                "path"
                                                            ],
                                                            "type": "object"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    },
                                                    "name": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "optional": {
                                                        "type": "boolean",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "downwardAPI": {
                                                "properties": {
                                                    "items": {
                                                        "items": {
                                                            "properties": {
                                                                "fieldRef": {
                                                                    "properties": {
                                                                        "apiVersion": {
                                                                            "type": "string",
                                                                            "nullable": true
                                                                        },
                                                                        "fieldPath": {
                                                                            "type": "string"
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "fieldPath"
                                                                    ],
                                                                    "type": "object",
                                                                    "nullable": true
                                                                },
                                                                "mode": {
                                                                    "format": "int32",
                                                                    "type": "integer",
                                                                    "nullable": true
                                                                },
                                                                "path": {
                                                                    "type": "string"
                                                                },
                                                                "resourceFieldRef": {
                                                                    "properties": {
                                                                        "containerName": {
                                                                            "type": "string",
                                                                            "nullable": true
                                                                        },
                                                                        "divisor": {
                                                                            "oneOf": [
                                                                                {
                                                                                    "anyOf": [
                                                                                        {
                                                                                            "type": "integer"
                                                                                        },
                                                                                        {
                                                                                            "type": "string"
                                                                                        }
                                                                                    ],
                                                                                    "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                                                },
                                                                                {
                                                                                    "type": "null"
                                                                                }
                                                                            ]
                                                                        },
                                                                        "resource": {
                                                                            "type": "string"
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "resource"
                                                                    ],
                                                                    "type": "object",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "required": [
                                                                "path"
                                                            ],
                                                            "type": "object"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "secret": {
                                                "properties": {
                                                    "items": {
                                                        "items": {
                                                            "properties": {
                                                                "key": {
                                                                    "type": "string"
                                                                },
                                                                "mode": {
                                                                    "format": "int32",
                                                                    "type": "integer",
                                                                    "nullable": true
                                                                },
                                                                "path": {
                                                                    "type": "string"
                                                                }
                                                            },
                                                            "required": [
                                                                "key",
                                                                "path"
                                                            ],
                                                            "type": "object"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    },
                                                    "name": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "optional": {
                                                        "type": "boolean",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "serviceAccountToken": {
                                                "properties": {
                                                    "audience": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "expirationSeconds": {
                                                        "format": "int64",
                                                        "type": "integer",
                                                        "nullable": true
                                                    },
                                                    "path": {
                                                        "type": "string"
                                                    }
                                                },
                                                "required": [
                                                    "path"
                                                ],
                                                "type": "object",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object"
                                    },
                                    "type": "array",
                                    "nullable": true
                                },
                                "global": {
                                    "additionalProperties": {
                                        "type": "string"
                                    },
                                    "type": "object",
                                    "properties": {},
                                    "nullable": true
                                },
                                "options": {
                                    "items": {
                                        "type": "string"
                                    },
                                    "type": "array",
                                    "nullable": true
                                },
                                "priorityClassName": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "repo": {
                                    "properties": {
                                        "azure": {
                                            "properties": {
                                                "container": {
                                                    "type": "string"
                                                }
                                            },
                                            "required": [
                                                "container"
                                            ],
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "gcs": {
                                            "properties": {
                                                "bucket": {
                                                    "type": "string"
                                                }
                                            },
                                            "required": [
                                                "bucket"
                                            ],
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "name": {
                                            "type": "string",
                                            "pattern": "^repo[1-4]"
                                        },
                                        "s3": {
                                            "properties": {
                                                "bucket": {
                                                    "type": "string"
                                                },
                                                "endpoint": {
                                                    "type": "string"
                                                },
                                                "region": {
                                                    "type": "string"
                                                }
                                            },
                                            "required": [
                                                "bucket",
                                                "endpoint",
                                                "region"
                                            ],
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "schedules": {
                                            "properties": {
                                                "differential": {
                                                    "minLength": 6,
                                                    "type": "string",
                                                    "nullable": true
                                                },
                                                "full": {
                                                    "minLength": 6,
                                                    "type": "string",
                                                    "nullable": true
                                                },
                                                "incremental": {
                                                    "minLength": 6,
                                                    "type": "string",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "volume": {
                                            "properties": {
                                                "volumeClaimSpec": {
                                                    "properties": {
                                                        "accessModes": {
                                                            "items": {
                                                                "type": "string"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        },
                                                        "dataSource": {
                                                            "properties": {
                                                                "apiGroup": {
                                                                    "type": "string",
                                                                    "nullable": true
                                                                },
                                                                "kind": {
                                                                    "type": "string"
                                                                },
                                                                "name": {
                                                                    "type": "string"
                                                                }
                                                            },
                                                            "required": [
                                                                "kind",
                                                                "name"
                                                            ],
                                                            "type": "object",
                                                            "nullable": true
                                                        },
                                                        "resources": {
                                                            "properties": {
                                                                "limits": {
                                                                    "additionalProperties": {
                                                                        "anyOf": [
                                                                            {
                                                                                "type": "integer"
                                                                            },
                                                                            {
                                                                                "type": "string"
                                                                            }
                                                                        ],
                                                                        "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                                    },
                                                                    "type": "object",
                                                                    "properties": {},
                                                                    "nullable": true
                                                                },
                                                                "requests": {
                                                                    "additionalProperties": {
                                                                        "anyOf": [
                                                                            {
                                                                                "type": "integer"
                                                                            },
                                                                            {
                                                                                "type": "string"
                                                                            }
                                                                        ],
                                                                        "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                                    },
                                                                    "type": "object",
                                                                    "properties": {},
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "type": "object",
                                                            "nullable": true
                                                        },
                                                        "selector": {
                                                            "properties": {
                                                                "matchExpressions": {
                                                                    "items": {
                                                                        "properties": {
                                                                            "key": {
                                                                                "type": "string"
                                                                            },
                                                                            "operator": {
                                                                                "type": "string"
                                                                            },
                                                                            "values": {
                                                                                "items": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "required": [
                                                                            "key",
                                                                            "operator"
                                                                        ],
                                                                        "type": "object"
                                                                    },
                                                                    "type": "array",
                                                                    "nullable": true
                                                                },
                                                                "matchLabels": {
                                                                    "additionalProperties": {
                                                                        "type": "string"
                                                                    },
                                                                    "type": "object",
                                                                    "properties": {},
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "type": "object",
                                                            "nullable": true
                                                        },
                                                        "storageClassName": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "volumeMode": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "volumeName": {
                                                            "type": "string",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object"
                                                }
                                            },
                                            "required": [
                                                "volumeClaimSpec"
                                            ],
                                            "type": "object",
                                            "nullable": true
                                        }
                                    },
                                    "required": [
                                        "name"
                                    ],
                                    "type": "object"
                                },
                                "resources": {
                                    "properties": {
                                        "limits": {
                                            "additionalProperties": {
                                                "anyOf": [
                                                    {
                                                        "type": "integer"
                                                    },
                                                    {
                                                        "type": "string"
                                                    }
                                                ],
                                                "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                            },
                                            "type": "object",
                                            "properties": {},
                                            "nullable": true
                                        },
                                        "requests": {
                                            "additionalProperties": {
                                                "anyOf": [
                                                    {
                                                        "type": "integer"
                                                    },
                                                    {
                                                        "type": "string"
                                                    }
                                                ],
                                                "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                            },
                                            "type": "object",
                                            "properties": {},
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "stanza": {
                                    "default": "db",
                                    "type": "string"
                                },
                                "tolerations": {
                                    "items": {
                                        "properties": {
                                            "effect": {
                                                "type": "string",
                                                "nullable": true
                                            },
                                            "key": {
                                                "type": "string",
                                                "nullable": true
                                            },
                                            "operator": {
                                                "type": "string",
                                                "nullable": true
                                            },
                                            "tolerationSeconds": {
                                                "format": "int64",
                                                "type": "integer",
                                                "nullable": true
                                            },
                                            "value": {
                                                "type": "string",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object"
                                    },
                                    "type": "array",
                                    "nullable": true
                                }
                            },
                            "required": [
                                "repo",
                                "stanza"
                            ],
                            "type": "object",
                            "nullable": true
                        },
                        "postgresCluster": {
                            "properties": {
                                "affinity": {
                                    "properties": {
                                        "nodeAffinity": {
                                            "properties": {
                                                "preferredDuringSchedulingIgnoredDuringExecution": {
                                                    "items": {
                                                        "properties": {
                                                            "preference": {
                                                                "properties": {
                                                                    "matchExpressions": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "matchFields": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object"
                                                            },
                                                            "weight": {
                                                                "format": "int32",
                                                                "type": "integer"
                                                            }
                                                        },
                                                        "required": [
                                                            "preference",
                                                            "weight"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                },
                                                "requiredDuringSchedulingIgnoredDuringExecution": {
                                                    "properties": {
                                                        "nodeSelectorTerms": {
                                                            "items": {
                                                                "properties": {
                                                                    "matchExpressions": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "matchFields": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object"
                                                            },
                                                            "type": "array"
                                                        }
                                                    },
                                                    "required": [
                                                        "nodeSelectorTerms"
                                                    ],
                                                    "type": "object",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "podAffinity": {
                                            "properties": {
                                                "preferredDuringSchedulingIgnoredDuringExecution": {
                                                    "items": {
                                                        "properties": {
                                                            "podAffinityTerm": {
                                                                "properties": {
                                                                    "labelSelector": {
                                                                        "properties": {
                                                                            "matchExpressions": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "matchLabels": {
                                                                                "additionalProperties": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "object",
                                                                                "properties": {},
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "namespaces": {
                                                                        "items": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "topologyKey": {
                                                                        "type": "string"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "topologyKey"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "weight": {
                                                                "format": "int32",
                                                                "type": "integer"
                                                            }
                                                        },
                                                        "required": [
                                                            "podAffinityTerm",
                                                            "weight"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                },
                                                "requiredDuringSchedulingIgnoredDuringExecution": {
                                                    "items": {
                                                        "properties": {
                                                            "labelSelector": {
                                                                "properties": {
                                                                    "matchExpressions": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "matchLabels": {
                                                                        "additionalProperties": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "object",
                                                                        "properties": {},
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object",
                                                                "nullable": true
                                                            },
                                                            "namespaces": {
                                                                "items": {
                                                                    "type": "string"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            },
                                                            "topologyKey": {
                                                                "type": "string"
                                                            }
                                                        },
                                                        "required": [
                                                            "topologyKey"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "podAntiAffinity": {
                                            "properties": {
                                                "preferredDuringSchedulingIgnoredDuringExecution": {
                                                    "items": {
                                                        "properties": {
                                                            "podAffinityTerm": {
                                                                "properties": {
                                                                    "labelSelector": {
                                                                        "properties": {
                                                                            "matchExpressions": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "matchLabels": {
                                                                                "additionalProperties": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "object",
                                                                                "properties": {},
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "namespaces": {
                                                                        "items": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "topologyKey": {
                                                                        "type": "string"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "topologyKey"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "weight": {
                                                                "format": "int32",
                                                                "type": "integer"
                                                            }
                                                        },
                                                        "required": [
                                                            "podAffinityTerm",
                                                            "weight"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                },
                                                "requiredDuringSchedulingIgnoredDuringExecution": {
                                                    "items": {
                                                        "properties": {
                                                            "labelSelector": {
                                                                "properties": {
                                                                    "matchExpressions": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "matchLabels": {
                                                                        "additionalProperties": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "object",
                                                                        "properties": {},
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object",
                                                                "nullable": true
                                                            },
                                                            "namespaces": {
                                                                "items": {
                                                                    "type": "string"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            },
                                                            "topologyKey": {
                                                                "type": "string"
                                                            }
                                                        },
                                                        "required": [
                                                            "topologyKey"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "clusterName": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "clusterNamespace": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "options": {
                                    "items": {
                                        "type": "string"
                                    },
                                    "type": "array",
                                    "nullable": true
                                },
                                "priorityClassName": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "repoName": {
                                    "type": "string",
                                    "pattern": "^repo[1-4]"
                                },
                                "resources": {
                                    "properties": {
                                        "limits": {
                                            "additionalProperties": {
                                                "anyOf": [
                                                    {
                                                        "type": "integer"
                                                    },
                                                    {
                                                        "type": "string"
                                                    }
                                                ],
                                                "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                            },
                                            "type": "object",
                                            "properties": {},
                                            "nullable": true
                                        },
                                        "requests": {
                                            "additionalProperties": {
                                                "anyOf": [
                                                    {
                                                        "type": "integer"
                                                    },
                                                    {
                                                        "type": "string"
                                                    }
                                                ],
                                                "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                            },
                                            "type": "object",
                                            "properties": {},
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "tolerations": {
                                    "items": {
                                        "properties": {
                                            "effect": {
                                                "type": "string",
                                                "nullable": true
                                            },
                                            "key": {
                                                "type": "string",
                                                "nullable": true
                                            },
                                            "operator": {
                                                "type": "string",
                                                "nullable": true
                                            },
                                            "tolerationSeconds": {
                                                "format": "int64",
                                                "type": "integer",
                                                "nullable": true
                                            },
                                            "value": {
                                                "type": "string",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object"
                                    },
                                    "type": "array",
                                    "nullable": true
                                }
                            },
                            "required": [
                                "repoName"
                            ],
                            "type": "object",
                            "nullable": true
                        },
                        "volumes": {
                            "properties": {
                                "pgBackRestVolume": {
                                    "properties": {
                                        "directory": {
                                            "type": "string",
                                            "nullable": true
                                        },
                                        "pvcName": {
                                            "type": "string"
                                        }
                                    },
                                    "required": [
                                        "pvcName"
                                    ],
                                    "type": "object",
                                    "nullable": true
                                },
                                "pgDataVolume": {
                                    "properties": {
                                        "directory": {
                                            "type": "string",
                                            "nullable": true
                                        },
                                        "pvcName": {
                                            "type": "string"
                                        }
                                    },
                                    "required": [
                                        "pvcName"
                                    ],
                                    "type": "object",
                                    "nullable": true
                                },
                                "pgWALVolume": {
                                    "properties": {
                                        "directory": {
                                            "type": "string",
                                            "nullable": true
                                        },
                                        "pvcName": {
                                            "type": "string"
                                        }
                                    },
                                    "required": [
                                        "pvcName"
                                    ],
                                    "type": "object",
                                    "nullable": true
                                }
                            },
                            "type": "object",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "databaseInitSQL": {
                    "properties": {
                        "key": {
                            "type": "string"
                        },
                        "name": {
                            "type": "string"
                        }
                    },
                    "required": [
                        "key",
                        "name"
                    ],
                    "type": "object",
                    "nullable": true
                },
                "disableDefaultPodScheduling": {
                    "type": "boolean",
                    "nullable": true
                },
                "image": {
                    "type": "string",
                    "nullable": true
                },
                "imagePullPolicy": {
                    "enum": [
                        "Always",
                        "Never",
                        "IfNotPresent"
                    ],
                    "type": "string",
                    "nullable": true
                },
                "imagePullSecrets": {
                    "items": {
                        "properties": {
                            "name": {
                                "type": "string",
                                "nullable": true
                            }
                        },
                        "type": "object"
                    },
                    "type": "array",
                    "nullable": true
                },
                "instances": {
                    "items": {
                        "properties": {
                            "affinity": {
                                "properties": {
                                    "nodeAffinity": {
                                        "properties": {
                                            "preferredDuringSchedulingIgnoredDuringExecution": {
                                                "items": {
                                                    "properties": {
                                                        "preference": {
                                                            "properties": {
                                                                "matchExpressions": {
                                                                    "items": {
                                                                        "properties": {
                                                                            "key": {
                                                                                "type": "string"
                                                                            },
                                                                            "operator": {
                                                                                "type": "string"
                                                                            },
                                                                            "values": {
                                                                                "items": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "required": [
                                                                            "key",
                                                                            "operator"
                                                                        ],
                                                                        "type": "object"
                                                                    },
                                                                    "type": "array",
                                                                    "nullable": true
                                                                },
                                                                "matchFields": {
                                                                    "items": {
                                                                        "properties": {
                                                                            "key": {
                                                                                "type": "string"
                                                                            },
                                                                            "operator": {
                                                                                "type": "string"
                                                                            },
                                                                            "values": {
                                                                                "items": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "required": [
                                                                            "key",
                                                                            "operator"
                                                                        ],
                                                                        "type": "object"
                                                                    },
                                                                    "type": "array",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "type": "object"
                                                        },
                                                        "weight": {
                                                            "format": "int32",
                                                            "type": "integer"
                                                        }
                                                    },
                                                    "required": [
                                                        "preference",
                                                        "weight"
                                                    ],
                                                    "type": "object"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            },
                                            "requiredDuringSchedulingIgnoredDuringExecution": {
                                                "properties": {
                                                    "nodeSelectorTerms": {
                                                        "items": {
                                                            "properties": {
                                                                "matchExpressions": {
                                                                    "items": {
                                                                        "properties": {
                                                                            "key": {
                                                                                "type": "string"
                                                                            },
                                                                            "operator": {
                                                                                "type": "string"
                                                                            },
                                                                            "values": {
                                                                                "items": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "required": [
                                                                            "key",
                                                                            "operator"
                                                                        ],
                                                                        "type": "object"
                                                                    },
                                                                    "type": "array",
                                                                    "nullable": true
                                                                },
                                                                "matchFields": {
                                                                    "items": {
                                                                        "properties": {
                                                                            "key": {
                                                                                "type": "string"
                                                                            },
                                                                            "operator": {
                                                                                "type": "string"
                                                                            },
                                                                            "values": {
                                                                                "items": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "required": [
                                                                            "key",
                                                                            "operator"
                                                                        ],
                                                                        "type": "object"
                                                                    },
                                                                    "type": "array",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "type": "object"
                                                        },
                                                        "type": "array"
                                                    }
                                                },
                                                "required": [
                                                    "nodeSelectorTerms"
                                                ],
                                                "type": "object",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    },
                                    "podAffinity": {
                                        "properties": {
                                            "preferredDuringSchedulingIgnoredDuringExecution": {
                                                "items": {
                                                    "properties": {
                                                        "podAffinityTerm": {
                                                            "properties": {
                                                                "labelSelector": {
                                                                    "properties": {
                                                                        "matchExpressions": {
                                                                            "items": {
                                                                                "properties": {
                                                                                    "key": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "operator": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "values": {
                                                                                        "items": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "type": "array",
                                                                                        "nullable": true
                                                                                    }
                                                                                },
                                                                                "required": [
                                                                                    "key",
                                                                                    "operator"
                                                                                ],
                                                                                "type": "object"
                                                                            },
                                                                            "type": "array",
                                                                            "nullable": true
                                                                        },
                                                                        "matchLabels": {
                                                                            "additionalProperties": {
                                                                                "type": "string"
                                                                            },
                                                                            "type": "object",
                                                                            "properties": {},
                                                                            "nullable": true
                                                                        }
                                                                    },
                                                                    "type": "object",
                                                                    "nullable": true
                                                                },
                                                                "namespaces": {
                                                                    "items": {
                                                                        "type": "string"
                                                                    },
                                                                    "type": "array",
                                                                    "nullable": true
                                                                },
                                                                "topologyKey": {
                                                                    "type": "string"
                                                                }
                                                            },
                                                            "required": [
                                                                "topologyKey"
                                                            ],
                                                            "type": "object"
                                                        },
                                                        "weight": {
                                                            "format": "int32",
                                                            "type": "integer"
                                                        }
                                                    },
                                                    "required": [
                                                        "podAffinityTerm",
                                                        "weight"
                                                    ],
                                                    "type": "object"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            },
                                            "requiredDuringSchedulingIgnoredDuringExecution": {
                                                "items": {
                                                    "properties": {
                                                        "labelSelector": {
                                                            "properties": {
                                                                "matchExpressions": {
                                                                    "items": {
                                                                        "properties": {
                                                                            "key": {
                                                                                "type": "string"
                                                                            },
                                                                            "operator": {
                                                                                "type": "string"
                                                                            },
                                                                            "values": {
                                                                                "items": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "required": [
                                                                            "key",
                                                                            "operator"
                                                                        ],
                                                                        "type": "object"
                                                                    },
                                                                    "type": "array",
                                                                    "nullable": true
                                                                },
                                                                "matchLabels": {
                                                                    "additionalProperties": {
                                                                        "type": "string"
                                                                    },
                                                                    "type": "object",
                                                                    "properties": {},
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "type": "object",
                                                            "nullable": true
                                                        },
                                                        "namespaces": {
                                                            "items": {
                                                                "type": "string"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        },
                                                        "topologyKey": {
                                                            "type": "string"
                                                        }
                                                    },
                                                    "required": [
                                                        "topologyKey"
                                                    ],
                                                    "type": "object"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    },
                                    "podAntiAffinity": {
                                        "properties": {
                                            "preferredDuringSchedulingIgnoredDuringExecution": {
                                                "items": {
                                                    "properties": {
                                                        "podAffinityTerm": {
                                                            "properties": {
                                                                "labelSelector": {
                                                                    "properties": {
                                                                        "matchExpressions": {
                                                                            "items": {
                                                                                "properties": {
                                                                                    "key": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "operator": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "values": {
                                                                                        "items": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "type": "array",
                                                                                        "nullable": true
                                                                                    }
                                                                                },
                                                                                "required": [
                                                                                    "key",
                                                                                    "operator"
                                                                                ],
                                                                                "type": "object"
                                                                            },
                                                                            "type": "array",
                                                                            "nullable": true
                                                                        },
                                                                        "matchLabels": {
                                                                            "additionalProperties": {
                                                                                "type": "string"
                                                                            },
                                                                            "type": "object",
                                                                            "properties": {},
                                                                            "nullable": true
                                                                        }
                                                                    },
                                                                    "type": "object",
                                                                    "nullable": true
                                                                },
                                                                "namespaces": {
                                                                    "items": {
                                                                        "type": "string"
                                                                    },
                                                                    "type": "array",
                                                                    "nullable": true
                                                                },
                                                                "topologyKey": {
                                                                    "type": "string"
                                                                }
                                                            },
                                                            "required": [
                                                                "topologyKey"
                                                            ],
                                                            "type": "object"
                                                        },
                                                        "weight": {
                                                            "format": "int32",
                                                            "type": "integer"
                                                        }
                                                    },
                                                    "required": [
                                                        "podAffinityTerm",
                                                        "weight"
                                                    ],
                                                    "type": "object"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            },
                                            "requiredDuringSchedulingIgnoredDuringExecution": {
                                                "items": {
                                                    "properties": {
                                                        "labelSelector": {
                                                            "properties": {
                                                                "matchExpressions": {
                                                                    "items": {
                                                                        "properties": {
                                                                            "key": {
                                                                                "type": "string"
                                                                            },
                                                                            "operator": {
                                                                                "type": "string"
                                                                            },
                                                                            "values": {
                                                                                "items": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "required": [
                                                                            "key",
                                                                            "operator"
                                                                        ],
                                                                        "type": "object"
                                                                    },
                                                                    "type": "array",
                                                                    "nullable": true
                                                                },
                                                                "matchLabels": {
                                                                    "additionalProperties": {
                                                                        "type": "string"
                                                                    },
                                                                    "type": "object",
                                                                    "properties": {},
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "type": "object",
                                                            "nullable": true
                                                        },
                                                        "namespaces": {
                                                            "items": {
                                                                "type": "string"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        },
                                                        "topologyKey": {
                                                            "type": "string"
                                                        }
                                                    },
                                                    "required": [
                                                        "topologyKey"
                                                    ],
                                                    "type": "object"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    }
                                },
                                "type": "object",
                                "nullable": true
                            },
                            "containers": {
                                "items": {
                                    "properties": {
                                        "args": {
                                            "items": {
                                                "type": "string"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        },
                                        "command": {
                                            "items": {
                                                "type": "string"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        },
                                        "env": {
                                            "items": {
                                                "properties": {
                                                    "name": {
                                                        "type": "string"
                                                    },
                                                    "value": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "valueFrom": {
                                                        "properties": {
                                                            "configMapKeyRef": {
                                                                "properties": {
                                                                    "key": {
                                                                        "type": "string"
                                                                    },
                                                                    "name": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    },
                                                                    "optional": {
                                                                        "type": "boolean",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "required": [
                                                                    "key"
                                                                ],
                                                                "type": "object",
                                                                "nullable": true
                                                            },
                                                            "fieldRef": {
                                                                "properties": {
                                                                    "apiVersion": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    },
                                                                    "fieldPath": {
                                                                        "type": "string"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "fieldPath"
                                                                ],
                                                                "type": "object",
                                                                "nullable": true
                                                            },
                                                            "resourceFieldRef": {
                                                                "properties": {
                                                                    "containerName": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    },
                                                                    "divisor": {
                                                                        "oneOf": [
                                                                            {
                                                                                "anyOf": [
                                                                                    {
                                                                                        "type": "integer"
                                                                                    },
                                                                                    {
                                                                                        "type": "string"
                                                                                    }
                                                                                ],
                                                                                "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                                            },
                                                                            {
                                                                                "type": "null"
                                                                            }
                                                                        ]
                                                                    },
                                                                    "resource": {
                                                                        "type": "string"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "resource"
                                                                ],
                                                                "type": "object",
                                                                "nullable": true
                                                            },
                                                            "secretKeyRef": {
                                                                "properties": {
                                                                    "key": {
                                                                        "type": "string"
                                                                    },
                                                                    "name": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    },
                                                                    "optional": {
                                                                        "type": "boolean",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "required": [
                                                                    "key"
                                                                ],
                                                                "type": "object",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    }
                                                },
                                                "required": [
                                                    "name"
                                                ],
                                                "type": "object"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        },
                                        "envFrom": {
                                            "items": {
                                                "properties": {
                                                    "configMapRef": {
                                                        "properties": {
                                                            "name": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "optional": {
                                                                "type": "boolean",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "prefix": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "secretRef": {
                                                        "properties": {
                                                            "name": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "optional": {
                                                                "type": "boolean",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        },
                                        "image": {
                                            "type": "string",
                                            "nullable": true
                                        },
                                        "imagePullPolicy": {
                                            "type": "string",
                                            "nullable": true
                                        },
                                        "lifecycle": {
                                            "properties": {
                                                "postStart": {
                                                    "properties": {
                                                        "exec": {
                                                            "properties": {
                                                                "command": {
                                                                    "items": {
                                                                        "type": "string"
                                                                    },
                                                                    "type": "array",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "type": "object",
                                                            "nullable": true
                                                        },
                                                        "httpGet": {
                                                            "properties": {
                                                                "host": {
                                                                    "type": "string",
                                                                    "nullable": true
                                                                },
                                                                "httpHeaders": {
                                                                    "items": {
                                                                        "properties": {
                                                                            "name": {
                                                                                "type": "string"
                                                                            },
                                                                            "value": {
                                                                                "type": "string"
                                                                            }
                                                                        },
                                                                        "required": [
                                                                            "name",
                                                                            "value"
                                                                        ],
                                                                        "type": "object"
                                                                    },
                                                                    "type": "array",
                                                                    "nullable": true
                                                                },
                                                                "path": {
                                                                    "type": "string",
                                                                    "nullable": true
                                                                },
                                                                "port": {
                                                                    "anyOf": [
                                                                        {
                                                                            "type": "integer"
                                                                        },
                                                                        {
                                                                            "type": "string"
                                                                        }
                                                                    ]
                                                                },
                                                                "scheme": {
                                                                    "type": "string",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "required": [
                                                                "port"
                                                            ],
                                                            "type": "object",
                                                            "nullable": true
                                                        },
                                                        "tcpSocket": {
                                                            "properties": {
                                                                "host": {
                                                                    "type": "string",
                                                                    "nullable": true
                                                                },
                                                                "port": {
                                                                    "anyOf": [
                                                                        {
                                                                            "type": "integer"
                                                                        },
                                                                        {
                                                                            "type": "string"
                                                                        }
                                                                    ]
                                                                }
                                                            },
                                                            "required": [
                                                                "port"
                                                            ],
                                                            "type": "object",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "preStop": {
                                                    "properties": {
                                                        "exec": {
                                                            "properties": {
                                                                "command": {
                                                                    "items": {
                                                                        "type": "string"
                                                                    },
                                                                    "type": "array",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "type": "object",
                                                            "nullable": true
                                                        },
                                                        "httpGet": {
                                                            "properties": {
                                                                "host": {
                                                                    "type": "string",
                                                                    "nullable": true
                                                                },
                                                                "httpHeaders": {
                                                                    "items": {
                                                                        "properties": {
                                                                            "name": {
                                                                                "type": "string"
                                                                            },
                                                                            "value": {
                                                                                "type": "string"
                                                                            }
                                                                        },
                                                                        "required": [
                                                                            "name",
                                                                            "value"
                                                                        ],
                                                                        "type": "object"
                                                                    },
                                                                    "type": "array",
                                                                    "nullable": true
                                                                },
                                                                "path": {
                                                                    "type": "string",
                                                                    "nullable": true
                                                                },
                                                                "port": {
                                                                    "anyOf": [
                                                                        {
                                                                            "type": "integer"
                                                                        },
                                                                        {
                                                                            "type": "string"
                                                                        }
                                                                    ]
                                                                },
                                                                "scheme": {
                                                                    "type": "string",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "required": [
                                                                "port"
                                                            ],
                                                            "type": "object",
                                                            "nullable": true
                                                        },
                                                        "tcpSocket": {
                                                            "properties": {
                                                                "host": {
                                                                    "type": "string",
                                                                    "nullable": true
                                                                },
                                                                "port": {
                                                                    "anyOf": [
                                                                        {
                                                                            "type": "integer"
                                                                        },
                                                                        {
                                                                            "type": "string"
                                                                        }
                                                                    ]
                                                                }
                                                            },
                                                            "required": [
                                                                "port"
                                                            ],
                                                            "type": "object",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "livenessProbe": {
                                            "properties": {
                                                "exec": {
                                                    "properties": {
                                                        "command": {
                                                            "items": {
                                                                "type": "string"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "failureThreshold": {
                                                    "format": "int32",
                                                    "type": "integer",
                                                    "nullable": true
                                                },
                                                "httpGet": {
                                                    "properties": {
                                                        "host": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "httpHeaders": {
                                                            "items": {
                                                                "properties": {
                                                                    "name": {
                                                                        "type": "string"
                                                                    },
                                                                    "value": {
                                                                        "type": "string"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "name",
                                                                    "value"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        },
                                                        "path": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "port": {
                                                            "anyOf": [
                                                                {
                                                                    "type": "integer"
                                                                },
                                                                {
                                                                    "type": "string"
                                                                }
                                                            ]
                                                        },
                                                        "scheme": {
                                                            "type": "string",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "required": [
                                                        "port"
                                                    ],
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "initialDelaySeconds": {
                                                    "format": "int32",
                                                    "type": "integer",
                                                    "nullable": true
                                                },
                                                "periodSeconds": {
                                                    "format": "int32",
                                                    "type": "integer",
                                                    "nullable": true
                                                },
                                                "successThreshold": {
                                                    "format": "int32",
                                                    "type": "integer",
                                                    "nullable": true
                                                },
                                                "tcpSocket": {
                                                    "properties": {
                                                        "host": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "port": {
                                                            "anyOf": [
                                                                {
                                                                    "type": "integer"
                                                                },
                                                                {
                                                                    "type": "string"
                                                                }
                                                            ]
                                                        }
                                                    },
                                                    "required": [
                                                        "port"
                                                    ],
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "timeoutSeconds": {
                                                    "format": "int32",
                                                    "type": "integer",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "name": {
                                            "type": "string"
                                        },
                                        "ports": {
                                            "items": {
                                                "properties": {
                                                    "containerPort": {
                                                        "format": "int32",
                                                        "type": "integer"
                                                    },
                                                    "hostIP": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "hostPort": {
                                                        "format": "int32",
                                                        "type": "integer",
                                                        "nullable": true
                                                    },
                                                    "name": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "protocol": {
                                                        "default": "TCP",
                                                        "type": "string",
                                                        "nullable": true
                                                    }
                                                },
                                                "required": [
                                                    "containerPort"
                                                ],
                                                "type": "object"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        },
                                        "readinessProbe": {
                                            "properties": {
                                                "exec": {
                                                    "properties": {
                                                        "command": {
                                                            "items": {
                                                                "type": "string"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "failureThreshold": {
                                                    "format": "int32",
                                                    "type": "integer",
                                                    "nullable": true
                                                },
                                                "httpGet": {
                                                    "properties": {
                                                        "host": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "httpHeaders": {
                                                            "items": {
                                                                "properties": {
                                                                    "name": {
                                                                        "type": "string"
                                                                    },
                                                                    "value": {
                                                                        "type": "string"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "name",
                                                                    "value"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        },
                                                        "path": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "port": {
                                                            "anyOf": [
                                                                {
                                                                    "type": "integer"
                                                                },
                                                                {
                                                                    "type": "string"
                                                                }
                                                            ]
                                                        },
                                                        "scheme": {
                                                            "type": "string",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "required": [
                                                        "port"
                                                    ],
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "initialDelaySeconds": {
                                                    "format": "int32",
                                                    "type": "integer",
                                                    "nullable": true
                                                },
                                                "periodSeconds": {
                                                    "format": "int32",
                                                    "type": "integer",
                                                    "nullable": true
                                                },
                                                "successThreshold": {
                                                    "format": "int32",
                                                    "type": "integer",
                                                    "nullable": true
                                                },
                                                "tcpSocket": {
                                                    "properties": {
                                                        "host": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "port": {
                                                            "anyOf": [
                                                                {
                                                                    "type": "integer"
                                                                },
                                                                {
                                                                    "type": "string"
                                                                }
                                                            ]
                                                        }
                                                    },
                                                    "required": [
                                                        "port"
                                                    ],
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "timeoutSeconds": {
                                                    "format": "int32",
                                                    "type": "integer",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "resources": {
                                            "properties": {
                                                "limits": {
                                                    "additionalProperties": {
                                                        "anyOf": [
                                                            {
                                                                "type": "integer"
                                                            },
                                                            {
                                                                "type": "string"
                                                            }
                                                        ],
                                                        "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                    },
                                                    "type": "object",
                                                    "properties": {},
                                                    "nullable": true
                                                },
                                                "requests": {
                                                    "additionalProperties": {
                                                        "anyOf": [
                                                            {
                                                                "type": "integer"
                                                            },
                                                            {
                                                                "type": "string"
                                                            }
                                                        ],
                                                        "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                    },
                                                    "type": "object",
                                                    "properties": {},
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "securityContext": {
                                            "properties": {
                                                "allowPrivilegeEscalation": {
                                                    "type": "boolean",
                                                    "nullable": true
                                                },
                                                "capabilities": {
                                                    "properties": {
                                                        "add": {
                                                            "items": {
                                                                "type": "string"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        },
                                                        "drop": {
                                                            "items": {
                                                                "type": "string"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "privileged": {
                                                    "type": "boolean",
                                                    "nullable": true
                                                },
                                                "procMount": {
                                                    "type": "string",
                                                    "nullable": true
                                                },
                                                "readOnlyRootFilesystem": {
                                                    "type": "boolean",
                                                    "nullable": true
                                                },
                                                "runAsGroup": {
                                                    "format": "int64",
                                                    "type": "integer",
                                                    "nullable": true
                                                },
                                                "runAsNonRoot": {
                                                    "type": "boolean",
                                                    "nullable": true
                                                },
                                                "runAsUser": {
                                                    "format": "int64",
                                                    "type": "integer",
                                                    "nullable": true
                                                },
                                                "seLinuxOptions": {
                                                    "properties": {
                                                        "level": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "role": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "type": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "user": {
                                                            "type": "string",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "seccompProfile": {
                                                    "properties": {
                                                        "localhostProfile": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "type": {
                                                            "type": "string"
                                                        }
                                                    },
                                                    "required": [
                                                        "type"
                                                    ],
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "windowsOptions": {
                                                    "properties": {
                                                        "gmsaCredentialSpec": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "gmsaCredentialSpecName": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "runAsUserName": {
                                                            "type": "string",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "startupProbe": {
                                            "properties": {
                                                "exec": {
                                                    "properties": {
                                                        "command": {
                                                            "items": {
                                                                "type": "string"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "failureThreshold": {
                                                    "format": "int32",
                                                    "type": "integer",
                                                    "nullable": true
                                                },
                                                "httpGet": {
                                                    "properties": {
                                                        "host": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "httpHeaders": {
                                                            "items": {
                                                                "properties": {
                                                                    "name": {
                                                                        "type": "string"
                                                                    },
                                                                    "value": {
                                                                        "type": "string"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "name",
                                                                    "value"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        },
                                                        "path": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "port": {
                                                            "anyOf": [
                                                                {
                                                                    "type": "integer"
                                                                },
                                                                {
                                                                    "type": "string"
                                                                }
                                                            ]
                                                        },
                                                        "scheme": {
                                                            "type": "string",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "required": [
                                                        "port"
                                                    ],
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "initialDelaySeconds": {
                                                    "format": "int32",
                                                    "type": "integer",
                                                    "nullable": true
                                                },
                                                "periodSeconds": {
                                                    "format": "int32",
                                                    "type": "integer",
                                                    "nullable": true
                                                },
                                                "successThreshold": {
                                                    "format": "int32",
                                                    "type": "integer",
                                                    "nullable": true
                                                },
                                                "tcpSocket": {
                                                    "properties": {
                                                        "host": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "port": {
                                                            "anyOf": [
                                                                {
                                                                    "type": "integer"
                                                                },
                                                                {
                                                                    "type": "string"
                                                                }
                                                            ]
                                                        }
                                                    },
                                                    "required": [
                                                        "port"
                                                    ],
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "timeoutSeconds": {
                                                    "format": "int32",
                                                    "type": "integer",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "stdin": {
                                            "type": "boolean",
                                            "nullable": true
                                        },
                                        "stdinOnce": {
                                            "type": "boolean",
                                            "nullable": true
                                        },
                                        "terminationMessagePath": {
                                            "type": "string",
                                            "nullable": true
                                        },
                                        "terminationMessagePolicy": {
                                            "type": "string",
                                            "nullable": true
                                        },
                                        "tty": {
                                            "type": "boolean",
                                            "nullable": true
                                        },
                                        "volumeDevices": {
                                            "items": {
                                                "properties": {
                                                    "devicePath": {
                                                        "type": "string"
                                                    },
                                                    "name": {
                                                        "type": "string"
                                                    }
                                                },
                                                "required": [
                                                    "devicePath",
                                                    "name"
                                                ],
                                                "type": "object"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        },
                                        "volumeMounts": {
                                            "items": {
                                                "properties": {
                                                    "mountPath": {
                                                        "type": "string"
                                                    },
                                                    "mountPropagation": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "name": {
                                                        "type": "string"
                                                    },
                                                    "readOnly": {
                                                        "type": "boolean",
                                                        "nullable": true
                                                    },
                                                    "subPath": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "subPathExpr": {
                                                        "type": "string",
                                                        "nullable": true
                                                    }
                                                },
                                                "required": [
                                                    "mountPath",
                                                    "name"
                                                ],
                                                "type": "object"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        },
                                        "workingDir": {
                                            "type": "string",
                                            "nullable": true
                                        }
                                    },
                                    "required": [
                                        "name"
                                    ],
                                    "type": "object"
                                },
                                "type": "array",
                                "nullable": true
                            },
                            "dataVolumeClaimSpec": {
                                "properties": {
                                    "accessModes": {
                                        "items": {
                                            "type": "string"
                                        },
                                        "minItems": 1,
                                        "type": "array"
                                    },
                                    "dataSource": {
                                        "properties": {
                                            "apiGroup": {
                                                "type": "string",
                                                "nullable": true
                                            },
                                            "kind": {
                                                "type": "string"
                                            },
                                            "name": {
                                                "type": "string"
                                            }
                                        },
                                        "required": [
                                            "kind",
                                            "name"
                                        ],
                                        "type": "object",
                                        "nullable": true
                                    },
                                    "resources": {
                                        "properties": {
                                            "limits": {
                                                "additionalProperties": {
                                                    "anyOf": [
                                                        {
                                                            "type": "integer"
                                                        },
                                                        {
                                                            "type": "string"
                                                        }
                                                    ],
                                                    "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                },
                                                "type": "object",
                                                "properties": {},
                                                "nullable": true
                                            },
                                            "requests": {
                                                "additionalProperties": {
                                                    "anyOf": [
                                                        {
                                                            "type": "integer"
                                                        },
                                                        {
                                                            "type": "string"
                                                        }
                                                    ],
                                                    "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                },
                                                "required": [
                                                    "storage"
                                                ],
                                                "type": "object",
                                                "properties": {}
                                            }
                                        },
                                        "required": [
                                            "requests"
                                        ],
                                        "type": "object"
                                    },
                                    "selector": {
                                        "properties": {
                                            "matchExpressions": {
                                                "items": {
                                                    "properties": {
                                                        "key": {
                                                            "type": "string"
                                                        },
                                                        "operator": {
                                                            "type": "string"
                                                        },
                                                        "values": {
                                                            "items": {
                                                                "type": "string"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "required": [
                                                        "key",
                                                        "operator"
                                                    ],
                                                    "type": "object"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            },
                                            "matchLabels": {
                                                "additionalProperties": {
                                                    "type": "string"
                                                },
                                                "type": "object",
                                                "properties": {},
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    },
                                    "storageClassName": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "volumeMode": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "volumeName": {
                                        "type": "string",
                                        "nullable": true
                                    }
                                },
                                "required": [
                                    "accessModes",
                                    "resources"
                                ],
                                "type": "object"
                            },
                            "metadata": {
                                "properties": {
                                    "annotations": {
                                        "additionalProperties": {
                                            "type": "string"
                                        },
                                        "type": "object",
                                        "properties": {},
                                        "nullable": true
                                    },
                                    "labels": {
                                        "additionalProperties": {
                                            "type": "string"
                                        },
                                        "type": "object",
                                        "properties": {},
                                        "nullable": true
                                    }
                                },
                                "type": "object",
                                "nullable": true
                            },
                            "minAvailable": {
                                "oneOf": [
                                    {
                                        "anyOf": [
                                            {
                                                "type": "integer"
                                            },
                                            {
                                                "type": "string"
                                            }
                                        ]
                                    },
                                    {
                                        "type": "null"
                                    }
                                ]
                            },
                            "name": {
                                "default": "",
                                "type": "string",
                                "pattern": "^([a-z0-9]([-a-z0-9]*[a-z0-9])?)?$",
                                "nullable": true
                            },
                            "priorityClassName": {
                                "type": "string",
                                "nullable": true
                            },
                            "replicas": {
                                "default": 1,
                                "format": "int32",
                                "type": "integer",
                                "minimum": 1,
                                "nullable": true
                            },
                            "resources": {
                                "properties": {
                                    "limits": {
                                        "additionalProperties": {
                                            "anyOf": [
                                                {
                                                    "type": "integer"
                                                },
                                                {
                                                    "type": "string"
                                                }
                                            ],
                                            "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                        },
                                        "type": "object",
                                        "properties": {},
                                        "nullable": true
                                    },
                                    "requests": {
                                        "additionalProperties": {
                                            "anyOf": [
                                                {
                                                    "type": "integer"
                                                },
                                                {
                                                    "type": "string"
                                                }
                                            ],
                                            "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                        },
                                        "type": "object",
                                        "properties": {},
                                        "nullable": true
                                    }
                                },
                                "type": "object",
                                "nullable": true
                            },
                            "sidecars": {
                                "properties": {
                                    "replicaCertCopy": {
                                        "properties": {
                                            "resources": {
                                                "properties": {
                                                    "limits": {
                                                        "additionalProperties": {
                                                            "anyOf": [
                                                                {
                                                                    "type": "integer"
                                                                },
                                                                {
                                                                    "type": "string"
                                                                }
                                                            ],
                                                            "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                        },
                                                        "type": "object",
                                                        "properties": {},
                                                        "nullable": true
                                                    },
                                                    "requests": {
                                                        "additionalProperties": {
                                                            "anyOf": [
                                                                {
                                                                    "type": "integer"
                                                                },
                                                                {
                                                                    "type": "string"
                                                                }
                                                            ],
                                                            "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                        },
                                                        "type": "object",
                                                        "properties": {},
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    }
                                },
                                "type": "object",
                                "nullable": true
                            },
                            "tolerations": {
                                "items": {
                                    "properties": {
                                        "effect": {
                                            "type": "string",
                                            "nullable": true
                                        },
                                        "key": {
                                            "type": "string",
                                            "nullable": true
                                        },
                                        "operator": {
                                            "type": "string",
                                            "nullable": true
                                        },
                                        "tolerationSeconds": {
                                            "format": "int64",
                                            "type": "integer",
                                            "nullable": true
                                        },
                                        "value": {
                                            "type": "string",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object"
                                },
                                "type": "array",
                                "nullable": true
                            },
                            "topologySpreadConstraints": {
                                "items": {
                                    "properties": {
                                        "labelSelector": {
                                            "properties": {
                                                "matchExpressions": {
                                                    "items": {
                                                        "properties": {
                                                            "key": {
                                                                "type": "string"
                                                            },
                                                            "operator": {
                                                                "type": "string"
                                                            },
                                                            "values": {
                                                                "items": {
                                                                    "type": "string"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "required": [
                                                            "key",
                                                            "operator"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                },
                                                "matchLabels": {
                                                    "additionalProperties": {
                                                        "type": "string"
                                                    },
                                                    "type": "object",
                                                    "properties": {},
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "maxSkew": {
                                            "format": "int32",
                                            "type": "integer"
                                        },
                                        "topologyKey": {
                                            "type": "string"
                                        },
                                        "whenUnsatisfiable": {
                                            "type": "string"
                                        }
                                    },
                                    "required": [
                                        "maxSkew",
                                        "topologyKey",
                                        "whenUnsatisfiable"
                                    ],
                                    "type": "object"
                                },
                                "type": "array",
                                "nullable": true
                            },
                            "walVolumeClaimSpec": {
                                "properties": {
                                    "accessModes": {
                                        "items": {
                                            "type": "string"
                                        },
                                        "minItems": 1,
                                        "type": "array"
                                    },
                                    "dataSource": {
                                        "properties": {
                                            "apiGroup": {
                                                "type": "string",
                                                "nullable": true
                                            },
                                            "kind": {
                                                "type": "string"
                                            },
                                            "name": {
                                                "type": "string"
                                            }
                                        },
                                        "required": [
                                            "kind",
                                            "name"
                                        ],
                                        "type": "object",
                                        "nullable": true
                                    },
                                    "resources": {
                                        "properties": {
                                            "limits": {
                                                "additionalProperties": {
                                                    "anyOf": [
                                                        {
                                                            "type": "integer"
                                                        },
                                                        {
                                                            "type": "string"
                                                        }
                                                    ],
                                                    "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                },
                                                "type": "object",
                                                "properties": {},
                                                "nullable": true
                                            },
                                            "requests": {
                                                "additionalProperties": {
                                                    "anyOf": [
                                                        {
                                                            "type": "integer"
                                                        },
                                                        {
                                                            "type": "string"
                                                        }
                                                    ],
                                                    "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                },
                                                "required": [
                                                    "storage"
                                                ],
                                                "type": "object",
                                                "properties": {}
                                            }
                                        },
                                        "required": [
                                            "requests"
                                        ],
                                        "type": "object"
                                    },
                                    "selector": {
                                        "properties": {
                                            "matchExpressions": {
                                                "items": {
                                                    "properties": {
                                                        "key": {
                                                            "type": "string"
                                                        },
                                                        "operator": {
                                                            "type": "string"
                                                        },
                                                        "values": {
                                                            "items": {
                                                                "type": "string"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "required": [
                                                        "key",
                                                        "operator"
                                                    ],
                                                    "type": "object"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            },
                                            "matchLabels": {
                                                "additionalProperties": {
                                                    "type": "string"
                                                },
                                                "type": "object",
                                                "properties": {},
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    },
                                    "storageClassName": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "volumeMode": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "volumeName": {
                                        "type": "string",
                                        "nullable": true
                                    }
                                },
                                "required": [
                                    "accessModes",
                                    "resources"
                                ],
                                "type": "object",
                                "nullable": true
                            }
                        },
                        "required": [
                            "dataVolumeClaimSpec"
                        ],
                        "type": "object"
                    },
                    "minItems": 1,
                    "type": "array"
                },
                "metadata": {
                    "properties": {
                        "annotations": {
                            "additionalProperties": {
                                "type": "string"
                            },
                            "type": "object",
                            "properties": {},
                            "nullable": true
                        },
                        "labels": {
                            "additionalProperties": {
                                "type": "string"
                            },
                            "type": "object",
                            "properties": {},
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "monitoring": {
                    "properties": {
                        "pgmonitor": {
                            "properties": {
                                "exporter": {
                                    "properties": {
                                        "configuration": {
                                            "items": {
                                                "properties": {
                                                    "configMap": {
                                                        "properties": {
                                                            "items": {
                                                                "items": {
                                                                    "properties": {
                                                                        "key": {
                                                                            "type": "string"
                                                                        },
                                                                        "mode": {
                                                                            "format": "int32",
                                                                            "type": "integer",
                                                                            "nullable": true
                                                                        },
                                                                        "path": {
                                                                            "type": "string"
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "key",
                                                                        "path"
                                                                    ],
                                                                    "type": "object"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            },
                                                            "name": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "optional": {
                                                                "type": "boolean",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "downwardAPI": {
                                                        "properties": {
                                                            "items": {
                                                                "items": {
                                                                    "properties": {
                                                                        "fieldRef": {
                                                                            "properties": {
                                                                                "apiVersion": {
                                                                                    "type": "string",
                                                                                    "nullable": true
                                                                                },
                                                                                "fieldPath": {
                                                                                    "type": "string"
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "fieldPath"
                                                                            ],
                                                                            "type": "object",
                                                                            "nullable": true
                                                                        },
                                                                        "mode": {
                                                                            "format": "int32",
                                                                            "type": "integer",
                                                                            "nullable": true
                                                                        },
                                                                        "path": {
                                                                            "type": "string"
                                                                        },
                                                                        "resourceFieldRef": {
                                                                            "properties": {
                                                                                "containerName": {
                                                                                    "type": "string",
                                                                                    "nullable": true
                                                                                },
                                                                                "divisor": {
                                                                                    "oneOf": [
                                                                                        {
                                                                                            "anyOf": [
                                                                                                {
                                                                                                    "type": "integer"
                                                                                                },
                                                                                                {
                                                                                                    "type": "string"
                                                                                                }
                                                                                            ],
                                                                                            "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                                                        },
                                                                                        {
                                                                                            "type": "null"
                                                                                        }
                                                                                    ]
                                                                                },
                                                                                "resource": {
                                                                                    "type": "string"
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "resource"
                                                                            ],
                                                                            "type": "object",
                                                                            "nullable": true
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "path"
                                                                    ],
                                                                    "type": "object"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "secret": {
                                                        "properties": {
                                                            "items": {
                                                                "items": {
                                                                    "properties": {
                                                                        "key": {
                                                                            "type": "string"
                                                                        },
                                                                        "mode": {
                                                                            "format": "int32",
                                                                            "type": "integer",
                                                                            "nullable": true
                                                                        },
                                                                        "path": {
                                                                            "type": "string"
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "key",
                                                                        "path"
                                                                    ],
                                                                    "type": "object"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            },
                                                            "name": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "optional": {
                                                                "type": "boolean",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "serviceAccountToken": {
                                                        "properties": {
                                                            "audience": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "expirationSeconds": {
                                                                "format": "int64",
                                                                "type": "integer",
                                                                "nullable": true
                                                            },
                                                            "path": {
                                                                "type": "string"
                                                            }
                                                        },
                                                        "required": [
                                                            "path"
                                                        ],
                                                        "type": "object",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        },
                                        "image": {
                                            "type": "string",
                                            "nullable": true
                                        },
                                        "resources": {
                                            "properties": {
                                                "limits": {
                                                    "additionalProperties": {
                                                        "anyOf": [
                                                            {
                                                                "type": "integer"
                                                            },
                                                            {
                                                                "type": "string"
                                                            }
                                                        ],
                                                        "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                    },
                                                    "type": "object",
                                                    "properties": {},
                                                    "nullable": true
                                                },
                                                "requests": {
                                                    "additionalProperties": {
                                                        "anyOf": [
                                                            {
                                                                "type": "integer"
                                                            },
                                                            {
                                                                "type": "string"
                                                            }
                                                        ],
                                                        "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                    },
                                                    "type": "object",
                                                    "properties": {},
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                }
                            },
                            "type": "object",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "openshift": {
                    "type": "boolean",
                    "nullable": true
                },
                "patroni": {
                    "properties": {
                        "dynamicConfiguration": {
                            "type": "object",
                            "properties": {},
                            "nullable": true
                        },
                        "leaderLeaseDurationSeconds": {
                            "default": 30,
                            "format": "int32",
                            "type": "integer",
                            "minimum": 3,
                            "nullable": true
                        },
                        "port": {
                            "default": 8008,
                            "format": "int32",
                            "type": "integer",
                            "minimum": 1024,
                            "nullable": true
                        },
                        "switchover": {
                            "properties": {
                                "enabled": {
                                    "type": "boolean"
                                },
                                "targetInstance": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "type": {
                                    "default": "Switchover",
                                    "enum": [
                                        "Switchover",
                                        "Failover"
                                    ],
                                    "type": "string",
                                    "nullable": true
                                }
                            },
                            "required": [
                                "enabled"
                            ],
                            "type": "object",
                            "nullable": true
                        },
                        "syncPeriodSeconds": {
                            "default": 10,
                            "format": "int32",
                            "type": "integer",
                            "minimum": 1,
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "paused": {
                    "type": "boolean",
                    "nullable": true
                },
                "port": {
                    "default": 5432,
                    "format": "int32",
                    "type": "integer",
                    "minimum": 1024,
                    "nullable": true
                },
                "postGISVersion": {
                    "type": "string",
                    "nullable": true
                },
                "postgresVersion": {
                    "type": "integer",
                    "minimum": 10,
                    "maximum": 14
                },
                "proxy": {
                    "properties": {
                        "pgBouncer": {
                            "properties": {
                                "affinity": {
                                    "properties": {
                                        "nodeAffinity": {
                                            "properties": {
                                                "preferredDuringSchedulingIgnoredDuringExecution": {
                                                    "items": {
                                                        "properties": {
                                                            "preference": {
                                                                "properties": {
                                                                    "matchExpressions": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "matchFields": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object"
                                                            },
                                                            "weight": {
                                                                "format": "int32",
                                                                "type": "integer"
                                                            }
                                                        },
                                                        "required": [
                                                            "preference",
                                                            "weight"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                },
                                                "requiredDuringSchedulingIgnoredDuringExecution": {
                                                    "properties": {
                                                        "nodeSelectorTerms": {
                                                            "items": {
                                                                "properties": {
                                                                    "matchExpressions": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "matchFields": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object"
                                                            },
                                                            "type": "array"
                                                        }
                                                    },
                                                    "required": [
                                                        "nodeSelectorTerms"
                                                    ],
                                                    "type": "object",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "podAffinity": {
                                            "properties": {
                                                "preferredDuringSchedulingIgnoredDuringExecution": {
                                                    "items": {
                                                        "properties": {
                                                            "podAffinityTerm": {
                                                                "properties": {
                                                                    "labelSelector": {
                                                                        "properties": {
                                                                            "matchExpressions": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "matchLabels": {
                                                                                "additionalProperties": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "object",
                                                                                "properties": {},
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "namespaces": {
                                                                        "items": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "topologyKey": {
                                                                        "type": "string"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "topologyKey"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "weight": {
                                                                "format": "int32",
                                                                "type": "integer"
                                                            }
                                                        },
                                                        "required": [
                                                            "podAffinityTerm",
                                                            "weight"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                },
                                                "requiredDuringSchedulingIgnoredDuringExecution": {
                                                    "items": {
                                                        "properties": {
                                                            "labelSelector": {
                                                                "properties": {
                                                                    "matchExpressions": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "matchLabels": {
                                                                        "additionalProperties": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "object",
                                                                        "properties": {},
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object",
                                                                "nullable": true
                                                            },
                                                            "namespaces": {
                                                                "items": {
                                                                    "type": "string"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            },
                                                            "topologyKey": {
                                                                "type": "string"
                                                            }
                                                        },
                                                        "required": [
                                                            "topologyKey"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "podAntiAffinity": {
                                            "properties": {
                                                "preferredDuringSchedulingIgnoredDuringExecution": {
                                                    "items": {
                                                        "properties": {
                                                            "podAffinityTerm": {
                                                                "properties": {
                                                                    "labelSelector": {
                                                                        "properties": {
                                                                            "matchExpressions": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "matchLabels": {
                                                                                "additionalProperties": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "object",
                                                                                "properties": {},
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "namespaces": {
                                                                        "items": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "topologyKey": {
                                                                        "type": "string"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "topologyKey"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "weight": {
                                                                "format": "int32",
                                                                "type": "integer"
                                                            }
                                                        },
                                                        "required": [
                                                            "podAffinityTerm",
                                                            "weight"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                },
                                                "requiredDuringSchedulingIgnoredDuringExecution": {
                                                    "items": {
                                                        "properties": {
                                                            "labelSelector": {
                                                                "properties": {
                                                                    "matchExpressions": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "matchLabels": {
                                                                        "additionalProperties": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "object",
                                                                        "properties": {},
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object",
                                                                "nullable": true
                                                            },
                                                            "namespaces": {
                                                                "items": {
                                                                    "type": "string"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            },
                                                            "topologyKey": {
                                                                "type": "string"
                                                            }
                                                        },
                                                        "required": [
                                                            "topologyKey"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "config": {
                                    "properties": {
                                        "databases": {
                                            "additionalProperties": {
                                                "type": "string"
                                            },
                                            "type": "object",
                                            "properties": {},
                                            "nullable": true
                                        },
                                        "files": {
                                            "items": {
                                                "properties": {
                                                    "configMap": {
                                                        "properties": {
                                                            "items": {
                                                                "items": {
                                                                    "properties": {
                                                                        "key": {
                                                                            "type": "string"
                                                                        },
                                                                        "mode": {
                                                                            "format": "int32",
                                                                            "type": "integer",
                                                                            "nullable": true
                                                                        },
                                                                        "path": {
                                                                            "type": "string"
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "key",
                                                                        "path"
                                                                    ],
                                                                    "type": "object"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            },
                                                            "name": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "optional": {
                                                                "type": "boolean",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "downwardAPI": {
                                                        "properties": {
                                                            "items": {
                                                                "items": {
                                                                    "properties": {
                                                                        "fieldRef": {
                                                                            "properties": {
                                                                                "apiVersion": {
                                                                                    "type": "string",
                                                                                    "nullable": true
                                                                                },
                                                                                "fieldPath": {
                                                                                    "type": "string"
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "fieldPath"
                                                                            ],
                                                                            "type": "object",
                                                                            "nullable": true
                                                                        },
                                                                        "mode": {
                                                                            "format": "int32",
                                                                            "type": "integer",
                                                                            "nullable": true
                                                                        },
                                                                        "path": {
                                                                            "type": "string"
                                                                        },
                                                                        "resourceFieldRef": {
                                                                            "properties": {
                                                                                "containerName": {
                                                                                    "type": "string",
                                                                                    "nullable": true
                                                                                },
                                                                                "divisor": {
                                                                                    "oneOf": [
                                                                                        {
                                                                                            "anyOf": [
                                                                                                {
                                                                                                    "type": "integer"
                                                                                                },
                                                                                                {
                                                                                                    "type": "string"
                                                                                                }
                                                                                            ],
                                                                                            "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                                                        },
                                                                                        {
                                                                                            "type": "null"
                                                                                        }
                                                                                    ]
                                                                                },
                                                                                "resource": {
                                                                                    "type": "string"
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "resource"
                                                                            ],
                                                                            "type": "object",
                                                                            "nullable": true
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "path"
                                                                    ],
                                                                    "type": "object"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "secret": {
                                                        "properties": {
                                                            "items": {
                                                                "items": {
                                                                    "properties": {
                                                                        "key": {
                                                                            "type": "string"
                                                                        },
                                                                        "mode": {
                                                                            "format": "int32",
                                                                            "type": "integer",
                                                                            "nullable": true
                                                                        },
                                                                        "path": {
                                                                            "type": "string"
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "key",
                                                                        "path"
                                                                    ],
                                                                    "type": "object"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            },
                                                            "name": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "optional": {
                                                                "type": "boolean",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "serviceAccountToken": {
                                                        "properties": {
                                                            "audience": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "expirationSeconds": {
                                                                "format": "int64",
                                                                "type": "integer",
                                                                "nullable": true
                                                            },
                                                            "path": {
                                                                "type": "string"
                                                            }
                                                        },
                                                        "required": [
                                                            "path"
                                                        ],
                                                        "type": "object",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        },
                                        "global": {
                                            "additionalProperties": {
                                                "type": "string"
                                            },
                                            "type": "object",
                                            "properties": {},
                                            "nullable": true
                                        },
                                        "users": {
                                            "additionalProperties": {
                                                "type": "string"
                                            },
                                            "type": "object",
                                            "properties": {},
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "containers": {
                                    "items": {
                                        "properties": {
                                            "args": {
                                                "items": {
                                                    "type": "string"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            },
                                            "command": {
                                                "items": {
                                                    "type": "string"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            },
                                            "env": {
                                                "items": {
                                                    "properties": {
                                                        "name": {
                                                            "type": "string"
                                                        },
                                                        "value": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "valueFrom": {
                                                            "properties": {
                                                                "configMapKeyRef": {
                                                                    "properties": {
                                                                        "key": {
                                                                            "type": "string"
                                                                        },
                                                                        "name": {
                                                                            "type": "string",
                                                                            "nullable": true
                                                                        },
                                                                        "optional": {
                                                                            "type": "boolean",
                                                                            "nullable": true
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "key"
                                                                    ],
                                                                    "type": "object",
                                                                    "nullable": true
                                                                },
                                                                "fieldRef": {
                                                                    "properties": {
                                                                        "apiVersion": {
                                                                            "type": "string",
                                                                            "nullable": true
                                                                        },
                                                                        "fieldPath": {
                                                                            "type": "string"
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "fieldPath"
                                                                    ],
                                                                    "type": "object",
                                                                    "nullable": true
                                                                },
                                                                "resourceFieldRef": {
                                                                    "properties": {
                                                                        "containerName": {
                                                                            "type": "string",
                                                                            "nullable": true
                                                                        },
                                                                        "divisor": {
                                                                            "oneOf": [
                                                                                {
                                                                                    "anyOf": [
                                                                                        {
                                                                                            "type": "integer"
                                                                                        },
                                                                                        {
                                                                                            "type": "string"
                                                                                        }
                                                                                    ],
                                                                                    "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                                                },
                                                                                {
                                                                                    "type": "null"
                                                                                }
                                                                            ]
                                                                        },
                                                                        "resource": {
                                                                            "type": "string"
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "resource"
                                                                    ],
                                                                    "type": "object",
                                                                    "nullable": true
                                                                },
                                                                "secretKeyRef": {
                                                                    "properties": {
                                                                        "key": {
                                                                            "type": "string"
                                                                        },
                                                                        "name": {
                                                                            "type": "string",
                                                                            "nullable": true
                                                                        },
                                                                        "optional": {
                                                                            "type": "boolean",
                                                                            "nullable": true
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "key"
                                                                    ],
                                                                    "type": "object",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "type": "object",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "required": [
                                                        "name"
                                                    ],
                                                    "type": "object"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            },
                                            "envFrom": {
                                                "items": {
                                                    "properties": {
                                                        "configMapRef": {
                                                            "properties": {
                                                                "name": {
                                                                    "type": "string",
                                                                    "nullable": true
                                                                },
                                                                "optional": {
                                                                    "type": "boolean",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "type": "object",
                                                            "nullable": true
                                                        },
                                                        "prefix": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "secretRef": {
                                                            "properties": {
                                                                "name": {
                                                                    "type": "string",
                                                                    "nullable": true
                                                                },
                                                                "optional": {
                                                                    "type": "boolean",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "type": "object",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            },
                                            "image": {
                                                "type": "string",
                                                "nullable": true
                                            },
                                            "imagePullPolicy": {
                                                "type": "string",
                                                "nullable": true
                                            },
                                            "lifecycle": {
                                                "properties": {
                                                    "postStart": {
                                                        "properties": {
                                                            "exec": {
                                                                "properties": {
                                                                    "command": {
                                                                        "items": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object",
                                                                "nullable": true
                                                            },
                                                            "httpGet": {
                                                                "properties": {
                                                                    "host": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    },
                                                                    "httpHeaders": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "name": {
                                                                                    "type": "string"
                                                                                },
                                                                                "value": {
                                                                                    "type": "string"
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "name",
                                                                                "value"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "path": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    },
                                                                    "port": {
                                                                        "anyOf": [
                                                                            {
                                                                                "type": "integer"
                                                                            },
                                                                            {
                                                                                "type": "string"
                                                                            }
                                                                        ]
                                                                    },
                                                                    "scheme": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "required": [
                                                                    "port"
                                                                ],
                                                                "type": "object",
                                                                "nullable": true
                                                            },
                                                            "tcpSocket": {
                                                                "properties": {
                                                                    "host": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    },
                                                                    "port": {
                                                                        "anyOf": [
                                                                            {
                                                                                "type": "integer"
                                                                            },
                                                                            {
                                                                                "type": "string"
                                                                            }
                                                                        ]
                                                                    }
                                                                },
                                                                "required": [
                                                                    "port"
                                                                ],
                                                                "type": "object",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "preStop": {
                                                        "properties": {
                                                            "exec": {
                                                                "properties": {
                                                                    "command": {
                                                                        "items": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object",
                                                                "nullable": true
                                                            },
                                                            "httpGet": {
                                                                "properties": {
                                                                    "host": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    },
                                                                    "httpHeaders": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "name": {
                                                                                    "type": "string"
                                                                                },
                                                                                "value": {
                                                                                    "type": "string"
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "name",
                                                                                "value"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "path": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    },
                                                                    "port": {
                                                                        "anyOf": [
                                                                            {
                                                                                "type": "integer"
                                                                            },
                                                                            {
                                                                                "type": "string"
                                                                            }
                                                                        ]
                                                                    },
                                                                    "scheme": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "required": [
                                                                    "port"
                                                                ],
                                                                "type": "object",
                                                                "nullable": true
                                                            },
                                                            "tcpSocket": {
                                                                "properties": {
                                                                    "host": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    },
                                                                    "port": {
                                                                        "anyOf": [
                                                                            {
                                                                                "type": "integer"
                                                                            },
                                                                            {
                                                                                "type": "string"
                                                                            }
                                                                        ]
                                                                    }
                                                                },
                                                                "required": [
                                                                    "port"
                                                                ],
                                                                "type": "object",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "livenessProbe": {
                                                "properties": {
                                                    "exec": {
                                                        "properties": {
                                                            "command": {
                                                                "items": {
                                                                    "type": "string"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "failureThreshold": {
                                                        "format": "int32",
                                                        "type": "integer",
                                                        "nullable": true
                                                    },
                                                    "httpGet": {
                                                        "properties": {
                                                            "host": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "httpHeaders": {
                                                                "items": {
                                                                    "properties": {
                                                                        "name": {
                                                                            "type": "string"
                                                                        },
                                                                        "value": {
                                                                            "type": "string"
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "name",
                                                                        "value"
                                                                    ],
                                                                    "type": "object"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            },
                                                            "path": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "port": {
                                                                "anyOf": [
                                                                    {
                                                                        "type": "integer"
                                                                    },
                                                                    {
                                                                        "type": "string"
                                                                    }
                                                                ]
                                                            },
                                                            "scheme": {
                                                                "type": "string",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "required": [
                                                            "port"
                                                        ],
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "initialDelaySeconds": {
                                                        "format": "int32",
                                                        "type": "integer",
                                                        "nullable": true
                                                    },
                                                    "periodSeconds": {
                                                        "format": "int32",
                                                        "type": "integer",
                                                        "nullable": true
                                                    },
                                                    "successThreshold": {
                                                        "format": "int32",
                                                        "type": "integer",
                                                        "nullable": true
                                                    },
                                                    "tcpSocket": {
                                                        "properties": {
                                                            "host": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "port": {
                                                                "anyOf": [
                                                                    {
                                                                        "type": "integer"
                                                                    },
                                                                    {
                                                                        "type": "string"
                                                                    }
                                                                ]
                                                            }
                                                        },
                                                        "required": [
                                                            "port"
                                                        ],
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "timeoutSeconds": {
                                                        "format": "int32",
                                                        "type": "integer",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "name": {
                                                "type": "string"
                                            },
                                            "ports": {
                                                "items": {
                                                    "properties": {
                                                        "containerPort": {
                                                            "format": "int32",
                                                            "type": "integer"
                                                        },
                                                        "hostIP": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "hostPort": {
                                                            "format": "int32",
                                                            "type": "integer",
                                                            "nullable": true
                                                        },
                                                        "name": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "protocol": {
                                                            "default": "TCP",
                                                            "type": "string",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "required": [
                                                        "containerPort"
                                                    ],
                                                    "type": "object"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            },
                                            "readinessProbe": {
                                                "properties": {
                                                    "exec": {
                                                        "properties": {
                                                            "command": {
                                                                "items": {
                                                                    "type": "string"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "failureThreshold": {
                                                        "format": "int32",
                                                        "type": "integer",
                                                        "nullable": true
                                                    },
                                                    "httpGet": {
                                                        "properties": {
                                                            "host": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "httpHeaders": {
                                                                "items": {
                                                                    "properties": {
                                                                        "name": {
                                                                            "type": "string"
                                                                        },
                                                                        "value": {
                                                                            "type": "string"
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "name",
                                                                        "value"
                                                                    ],
                                                                    "type": "object"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            },
                                                            "path": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "port": {
                                                                "anyOf": [
                                                                    {
                                                                        "type": "integer"
                                                                    },
                                                                    {
                                                                        "type": "string"
                                                                    }
                                                                ]
                                                            },
                                                            "scheme": {
                                                                "type": "string",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "required": [
                                                            "port"
                                                        ],
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "initialDelaySeconds": {
                                                        "format": "int32",
                                                        "type": "integer",
                                                        "nullable": true
                                                    },
                                                    "periodSeconds": {
                                                        "format": "int32",
                                                        "type": "integer",
                                                        "nullable": true
                                                    },
                                                    "successThreshold": {
                                                        "format": "int32",
                                                        "type": "integer",
                                                        "nullable": true
                                                    },
                                                    "tcpSocket": {
                                                        "properties": {
                                                            "host": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "port": {
                                                                "anyOf": [
                                                                    {
                                                                        "type": "integer"
                                                                    },
                                                                    {
                                                                        "type": "string"
                                                                    }
                                                                ]
                                                            }
                                                        },
                                                        "required": [
                                                            "port"
                                                        ],
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "timeoutSeconds": {
                                                        "format": "int32",
                                                        "type": "integer",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "resources": {
                                                "properties": {
                                                    "limits": {
                                                        "additionalProperties": {
                                                            "anyOf": [
                                                                {
                                                                    "type": "integer"
                                                                },
                                                                {
                                                                    "type": "string"
                                                                }
                                                            ],
                                                            "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                        },
                                                        "type": "object",
                                                        "properties": {},
                                                        "nullable": true
                                                    },
                                                    "requests": {
                                                        "additionalProperties": {
                                                            "anyOf": [
                                                                {
                                                                    "type": "integer"
                                                                },
                                                                {
                                                                    "type": "string"
                                                                }
                                                            ],
                                                            "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                        },
                                                        "type": "object",
                                                        "properties": {},
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "securityContext": {
                                                "properties": {
                                                    "allowPrivilegeEscalation": {
                                                        "type": "boolean",
                                                        "nullable": true
                                                    },
                                                    "capabilities": {
                                                        "properties": {
                                                            "add": {
                                                                "items": {
                                                                    "type": "string"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            },
                                                            "drop": {
                                                                "items": {
                                                                    "type": "string"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "privileged": {
                                                        "type": "boolean",
                                                        "nullable": true
                                                    },
                                                    "procMount": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "readOnlyRootFilesystem": {
                                                        "type": "boolean",
                                                        "nullable": true
                                                    },
                                                    "runAsGroup": {
                                                        "format": "int64",
                                                        "type": "integer",
                                                        "nullable": true
                                                    },
                                                    "runAsNonRoot": {
                                                        "type": "boolean",
                                                        "nullable": true
                                                    },
                                                    "runAsUser": {
                                                        "format": "int64",
                                                        "type": "integer",
                                                        "nullable": true
                                                    },
                                                    "seLinuxOptions": {
                                                        "properties": {
                                                            "level": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "role": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "type": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "user": {
                                                                "type": "string",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "seccompProfile": {
                                                        "properties": {
                                                            "localhostProfile": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "type": {
                                                                "type": "string"
                                                            }
                                                        },
                                                        "required": [
                                                            "type"
                                                        ],
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "windowsOptions": {
                                                        "properties": {
                                                            "gmsaCredentialSpec": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "gmsaCredentialSpecName": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "runAsUserName": {
                                                                "type": "string",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "startupProbe": {
                                                "properties": {
                                                    "exec": {
                                                        "properties": {
                                                            "command": {
                                                                "items": {
                                                                    "type": "string"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "failureThreshold": {
                                                        "format": "int32",
                                                        "type": "integer",
                                                        "nullable": true
                                                    },
                                                    "httpGet": {
                                                        "properties": {
                                                            "host": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "httpHeaders": {
                                                                "items": {
                                                                    "properties": {
                                                                        "name": {
                                                                            "type": "string"
                                                                        },
                                                                        "value": {
                                                                            "type": "string"
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "name",
                                                                        "value"
                                                                    ],
                                                                    "type": "object"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            },
                                                            "path": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "port": {
                                                                "anyOf": [
                                                                    {
                                                                        "type": "integer"
                                                                    },
                                                                    {
                                                                        "type": "string"
                                                                    }
                                                                ]
                                                            },
                                                            "scheme": {
                                                                "type": "string",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "required": [
                                                            "port"
                                                        ],
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "initialDelaySeconds": {
                                                        "format": "int32",
                                                        "type": "integer",
                                                        "nullable": true
                                                    },
                                                    "periodSeconds": {
                                                        "format": "int32",
                                                        "type": "integer",
                                                        "nullable": true
                                                    },
                                                    "successThreshold": {
                                                        "format": "int32",
                                                        "type": "integer",
                                                        "nullable": true
                                                    },
                                                    "tcpSocket": {
                                                        "properties": {
                                                            "host": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "port": {
                                                                "anyOf": [
                                                                    {
                                                                        "type": "integer"
                                                                    },
                                                                    {
                                                                        "type": "string"
                                                                    }
                                                                ]
                                                            }
                                                        },
                                                        "required": [
                                                            "port"
                                                        ],
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "timeoutSeconds": {
                                                        "format": "int32",
                                                        "type": "integer",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "stdin": {
                                                "type": "boolean",
                                                "nullable": true
                                            },
                                            "stdinOnce": {
                                                "type": "boolean",
                                                "nullable": true
                                            },
                                            "terminationMessagePath": {
                                                "type": "string",
                                                "nullable": true
                                            },
                                            "terminationMessagePolicy": {
                                                "type": "string",
                                                "nullable": true
                                            },
                                            "tty": {
                                                "type": "boolean",
                                                "nullable": true
                                            },
                                            "volumeDevices": {
                                                "items": {
                                                    "properties": {
                                                        "devicePath": {
                                                            "type": "string"
                                                        },
                                                        "name": {
                                                            "type": "string"
                                                        }
                                                    },
                                                    "required": [
                                                        "devicePath",
                                                        "name"
                                                    ],
                                                    "type": "object"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            },
                                            "volumeMounts": {
                                                "items": {
                                                    "properties": {
                                                        "mountPath": {
                                                            "type": "string"
                                                        },
                                                        "mountPropagation": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "name": {
                                                            "type": "string"
                                                        },
                                                        "readOnly": {
                                                            "type": "boolean",
                                                            "nullable": true
                                                        },
                                                        "subPath": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "subPathExpr": {
                                                            "type": "string",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "required": [
                                                        "mountPath",
                                                        "name"
                                                    ],
                                                    "type": "object"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            },
                                            "workingDir": {
                                                "type": "string",
                                                "nullable": true
                                            }
                                        },
                                        "required": [
                                            "name"
                                        ],
                                        "type": "object"
                                    },
                                    "type": "array",
                                    "nullable": true
                                },
                                "customTLSSecret": {
                                    "properties": {
                                        "items": {
                                            "items": {
                                                "properties": {
                                                    "key": {
                                                        "type": "string"
                                                    },
                                                    "mode": {
                                                        "format": "int32",
                                                        "type": "integer",
                                                        "nullable": true
                                                    },
                                                    "path": {
                                                        "type": "string"
                                                    }
                                                },
                                                "required": [
                                                    "key",
                                                    "path"
                                                ],
                                                "type": "object"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        },
                                        "name": {
                                            "type": "string",
                                            "nullable": true
                                        },
                                        "optional": {
                                            "type": "boolean",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "image": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "metadata": {
                                    "properties": {
                                        "annotations": {
                                            "additionalProperties": {
                                                "type": "string"
                                            },
                                            "type": "object",
                                            "properties": {},
                                            "nullable": true
                                        },
                                        "labels": {
                                            "additionalProperties": {
                                                "type": "string"
                                            },
                                            "type": "object",
                                            "properties": {},
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "minAvailable": {
                                    "oneOf": [
                                        {
                                            "anyOf": [
                                                {
                                                    "type": "integer"
                                                },
                                                {
                                                    "type": "string"
                                                }
                                            ]
                                        },
                                        {
                                            "type": "null"
                                        }
                                    ]
                                },
                                "port": {
                                    "default": 5432,
                                    "format": "int32",
                                    "type": "integer",
                                    "minimum": 1024,
                                    "nullable": true
                                },
                                "priorityClassName": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "replicas": {
                                    "default": 1,
                                    "format": "int32",
                                    "type": "integer",
                                    "minimum": 0,
                                    "nullable": true
                                },
                                "resources": {
                                    "properties": {
                                        "limits": {
                                            "additionalProperties": {
                                                "anyOf": [
                                                    {
                                                        "type": "integer"
                                                    },
                                                    {
                                                        "type": "string"
                                                    }
                                                ],
                                                "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                            },
                                            "type": "object",
                                            "properties": {},
                                            "nullable": true
                                        },
                                        "requests": {
                                            "additionalProperties": {
                                                "anyOf": [
                                                    {
                                                        "type": "integer"
                                                    },
                                                    {
                                                        "type": "string"
                                                    }
                                                ],
                                                "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                            },
                                            "type": "object",
                                            "properties": {},
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "service": {
                                    "properties": {
                                        "metadata": {
                                            "properties": {
                                                "annotations": {
                                                    "additionalProperties": {
                                                        "type": "string"
                                                    },
                                                    "type": "object",
                                                    "properties": {},
                                                    "nullable": true
                                                },
                                                "labels": {
                                                    "additionalProperties": {
                                                        "type": "string"
                                                    },
                                                    "type": "object",
                                                    "properties": {},
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "nodePort": {
                                            "format": "int32",
                                            "type": "integer",
                                            "nullable": true
                                        },
                                        "type": {
                                            "default": "ClusterIP",
                                            "enum": [
                                                "ClusterIP",
                                                "NodePort",
                                                "LoadBalancer"
                                            ],
                                            "type": "string",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "sidecars": {
                                    "properties": {
                                        "pgbouncerConfig": {
                                            "properties": {
                                                "resources": {
                                                    "properties": {
                                                        "limits": {
                                                            "additionalProperties": {
                                                                "anyOf": [
                                                                    {
                                                                        "type": "integer"
                                                                    },
                                                                    {
                                                                        "type": "string"
                                                                    }
                                                                ],
                                                                "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                            },
                                                            "type": "object",
                                                            "properties": {},
                                                            "nullable": true
                                                        },
                                                        "requests": {
                                                            "additionalProperties": {
                                                                "anyOf": [
                                                                    {
                                                                        "type": "integer"
                                                                    },
                                                                    {
                                                                        "type": "string"
                                                                    }
                                                                ],
                                                                "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                            },
                                                            "type": "object",
                                                            "properties": {},
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "tolerations": {
                                    "items": {
                                        "properties": {
                                            "effect": {
                                                "type": "string",
                                                "nullable": true
                                            },
                                            "key": {
                                                "type": "string",
                                                "nullable": true
                                            },
                                            "operator": {
                                                "type": "string",
                                                "nullable": true
                                            },
                                            "tolerationSeconds": {
                                                "format": "int64",
                                                "type": "integer",
                                                "nullable": true
                                            },
                                            "value": {
                                                "type": "string",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object"
                                    },
                                    "type": "array",
                                    "nullable": true
                                },
                                "topologySpreadConstraints": {
                                    "items": {
                                        "properties": {
                                            "labelSelector": {
                                                "properties": {
                                                    "matchExpressions": {
                                                        "items": {
                                                            "properties": {
                                                                "key": {
                                                                    "type": "string"
                                                                },
                                                                "operator": {
                                                                    "type": "string"
                                                                },
                                                                "values": {
                                                                    "items": {
                                                                        "type": "string"
                                                                    },
                                                                    "type": "array",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "required": [
                                                                "key",
                                                                "operator"
                                                            ],
                                                            "type": "object"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    },
                                                    "matchLabels": {
                                                        "additionalProperties": {
                                                            "type": "string"
                                                        },
                                                        "type": "object",
                                                        "properties": {},
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "maxSkew": {
                                                "format": "int32",
                                                "type": "integer"
                                            },
                                            "topologyKey": {
                                                "type": "string"
                                            },
                                            "whenUnsatisfiable": {
                                                "type": "string"
                                            }
                                        },
                                        "required": [
                                            "maxSkew",
                                            "topologyKey",
                                            "whenUnsatisfiable"
                                        ],
                                        "type": "object"
                                    },
                                    "type": "array",
                                    "nullable": true
                                }
                            },
                            "type": "object"
                        }
                    },
                    "required": [
                        "pgBouncer"
                    ],
                    "type": "object",
                    "nullable": true
                },
                "service": {
                    "properties": {
                        "metadata": {
                            "properties": {
                                "annotations": {
                                    "additionalProperties": {
                                        "type": "string"
                                    },
                                    "type": "object",
                                    "properties": {},
                                    "nullable": true
                                },
                                "labels": {
                                    "additionalProperties": {
                                        "type": "string"
                                    },
                                    "type": "object",
                                    "properties": {},
                                    "nullable": true
                                }
                            },
                            "type": "object",
                            "nullable": true
                        },
                        "nodePort": {
                            "format": "int32",
                            "type": "integer",
                            "nullable": true
                        },
                        "type": {
                            "default": "ClusterIP",
                            "enum": [
                                "ClusterIP",
                                "NodePort",
                                "LoadBalancer"
                            ],
                            "type": "string",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "shutdown": {
                    "type": "boolean",
                    "nullable": true
                },
                "standby": {
                    "properties": {
                        "enabled": {
                            "default": true,
                            "type": "boolean",
                            "nullable": true
                        },
                        "host": {
                            "type": "string",
                            "nullable": true
                        },
                        "port": {
                            "format": "int32",
                            "type": "integer",
                            "minimum": 1024,
                            "nullable": true
                        },
                        "repoName": {
                            "type": "string",
                            "pattern": "^repo[1-4]",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "supplementalGroups": {
                    "items": {
                        "format": "int64",
                        "type": "integer",
                        "minimum": 1,
                        "maximum": 2147483647
                    },
                    "type": "array",
                    "nullable": true
                },
                "userInterface": {
                    "properties": {
                        "pgAdmin": {
                            "properties": {
                                "affinity": {
                                    "properties": {
                                        "nodeAffinity": {
                                            "properties": {
                                                "preferredDuringSchedulingIgnoredDuringExecution": {
                                                    "items": {
                                                        "properties": {
                                                            "preference": {
                                                                "properties": {
                                                                    "matchExpressions": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "matchFields": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object"
                                                            },
                                                            "weight": {
                                                                "format": "int32",
                                                                "type": "integer"
                                                            }
                                                        },
                                                        "required": [
                                                            "preference",
                                                            "weight"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                },
                                                "requiredDuringSchedulingIgnoredDuringExecution": {
                                                    "properties": {
                                                        "nodeSelectorTerms": {
                                                            "items": {
                                                                "properties": {
                                                                    "matchExpressions": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "matchFields": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object"
                                                            },
                                                            "type": "array"
                                                        }
                                                    },
                                                    "required": [
                                                        "nodeSelectorTerms"
                                                    ],
                                                    "type": "object",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "podAffinity": {
                                            "properties": {
                                                "preferredDuringSchedulingIgnoredDuringExecution": {
                                                    "items": {
                                                        "properties": {
                                                            "podAffinityTerm": {
                                                                "properties": {
                                                                    "labelSelector": {
                                                                        "properties": {
                                                                            "matchExpressions": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "matchLabels": {
                                                                                "additionalProperties": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "object",
                                                                                "properties": {},
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "namespaces": {
                                                                        "items": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "topologyKey": {
                                                                        "type": "string"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "topologyKey"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "weight": {
                                                                "format": "int32",
                                                                "type": "integer"
                                                            }
                                                        },
                                                        "required": [
                                                            "podAffinityTerm",
                                                            "weight"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                },
                                                "requiredDuringSchedulingIgnoredDuringExecution": {
                                                    "items": {
                                                        "properties": {
                                                            "labelSelector": {
                                                                "properties": {
                                                                    "matchExpressions": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "matchLabels": {
                                                                        "additionalProperties": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "object",
                                                                        "properties": {},
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object",
                                                                "nullable": true
                                                            },
                                                            "namespaces": {
                                                                "items": {
                                                                    "type": "string"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            },
                                                            "topologyKey": {
                                                                "type": "string"
                                                            }
                                                        },
                                                        "required": [
                                                            "topologyKey"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "podAntiAffinity": {
                                            "properties": {
                                                "preferredDuringSchedulingIgnoredDuringExecution": {
                                                    "items": {
                                                        "properties": {
                                                            "podAffinityTerm": {
                                                                "properties": {
                                                                    "labelSelector": {
                                                                        "properties": {
                                                                            "matchExpressions": {
                                                                                "items": {
                                                                                    "properties": {
                                                                                        "key": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "operator": {
                                                                                            "type": "string"
                                                                                        },
                                                                                        "values": {
                                                                                            "items": {
                                                                                                "type": "string"
                                                                                            },
                                                                                            "type": "array",
                                                                                            "nullable": true
                                                                                        }
                                                                                    },
                                                                                    "required": [
                                                                                        "key",
                                                                                        "operator"
                                                                                    ],
                                                                                    "type": "object"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            },
                                                                            "matchLabels": {
                                                                                "additionalProperties": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "object",
                                                                                "properties": {},
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "namespaces": {
                                                                        "items": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "topologyKey": {
                                                                        "type": "string"
                                                                    }
                                                                },
                                                                "required": [
                                                                    "topologyKey"
                                                                ],
                                                                "type": "object"
                                                            },
                                                            "weight": {
                                                                "format": "int32",
                                                                "type": "integer"
                                                            }
                                                        },
                                                        "required": [
                                                            "podAffinityTerm",
                                                            "weight"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                },
                                                "requiredDuringSchedulingIgnoredDuringExecution": {
                                                    "items": {
                                                        "properties": {
                                                            "labelSelector": {
                                                                "properties": {
                                                                    "matchExpressions": {
                                                                        "items": {
                                                                            "properties": {
                                                                                "key": {
                                                                                    "type": "string"
                                                                                },
                                                                                "operator": {
                                                                                    "type": "string"
                                                                                },
                                                                                "values": {
                                                                                    "items": {
                                                                                        "type": "string"
                                                                                    },
                                                                                    "type": "array",
                                                                                    "nullable": true
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "key",
                                                                                "operator"
                                                                            ],
                                                                            "type": "object"
                                                                        },
                                                                        "type": "array",
                                                                        "nullable": true
                                                                    },
                                                                    "matchLabels": {
                                                                        "additionalProperties": {
                                                                            "type": "string"
                                                                        },
                                                                        "type": "object",
                                                                        "properties": {},
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object",
                                                                "nullable": true
                                                            },
                                                            "namespaces": {
                                                                "items": {
                                                                    "type": "string"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            },
                                                            "topologyKey": {
                                                                "type": "string"
                                                            }
                                                        },
                                                        "required": [
                                                            "topologyKey"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "config": {
                                    "properties": {
                                        "files": {
                                            "items": {
                                                "properties": {
                                                    "configMap": {
                                                        "properties": {
                                                            "items": {
                                                                "items": {
                                                                    "properties": {
                                                                        "key": {
                                                                            "type": "string"
                                                                        },
                                                                        "mode": {
                                                                            "format": "int32",
                                                                            "type": "integer",
                                                                            "nullable": true
                                                                        },
                                                                        "path": {
                                                                            "type": "string"
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "key",
                                                                        "path"
                                                                    ],
                                                                    "type": "object"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            },
                                                            "name": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "optional": {
                                                                "type": "boolean",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "downwardAPI": {
                                                        "properties": {
                                                            "items": {
                                                                "items": {
                                                                    "properties": {
                                                                        "fieldRef": {
                                                                            "properties": {
                                                                                "apiVersion": {
                                                                                    "type": "string",
                                                                                    "nullable": true
                                                                                },
                                                                                "fieldPath": {
                                                                                    "type": "string"
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "fieldPath"
                                                                            ],
                                                                            "type": "object",
                                                                            "nullable": true
                                                                        },
                                                                        "mode": {
                                                                            "format": "int32",
                                                                            "type": "integer",
                                                                            "nullable": true
                                                                        },
                                                                        "path": {
                                                                            "type": "string"
                                                                        },
                                                                        "resourceFieldRef": {
                                                                            "properties": {
                                                                                "containerName": {
                                                                                    "type": "string",
                                                                                    "nullable": true
                                                                                },
                                                                                "divisor": {
                                                                                    "oneOf": [
                                                                                        {
                                                                                            "anyOf": [
                                                                                                {
                                                                                                    "type": "integer"
                                                                                                },
                                                                                                {
                                                                                                    "type": "string"
                                                                                                }
                                                                                            ],
                                                                                            "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                                                        },
                                                                                        {
                                                                                            "type": "null"
                                                                                        }
                                                                                    ]
                                                                                },
                                                                                "resource": {
                                                                                    "type": "string"
                                                                                }
                                                                            },
                                                                            "required": [
                                                                                "resource"
                                                                            ],
                                                                            "type": "object",
                                                                            "nullable": true
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "path"
                                                                    ],
                                                                    "type": "object"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "secret": {
                                                        "properties": {
                                                            "items": {
                                                                "items": {
                                                                    "properties": {
                                                                        "key": {
                                                                            "type": "string"
                                                                        },
                                                                        "mode": {
                                                                            "format": "int32",
                                                                            "type": "integer",
                                                                            "nullable": true
                                                                        },
                                                                        "path": {
                                                                            "type": "string"
                                                                        }
                                                                    },
                                                                    "required": [
                                                                        "key",
                                                                        "path"
                                                                    ],
                                                                    "type": "object"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            },
                                                            "name": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "optional": {
                                                                "type": "boolean",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    },
                                                    "serviceAccountToken": {
                                                        "properties": {
                                                            "audience": {
                                                                "type": "string",
                                                                "nullable": true
                                                            },
                                                            "expirationSeconds": {
                                                                "format": "int64",
                                                                "type": "integer",
                                                                "nullable": true
                                                            },
                                                            "path": {
                                                                "type": "string"
                                                            }
                                                        },
                                                        "required": [
                                                            "path"
                                                        ],
                                                        "type": "object",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        },
                                        "ldapBindPassword": {
                                            "properties": {
                                                "key": {
                                                    "type": "string"
                                                },
                                                "name": {
                                                    "type": "string",
                                                    "nullable": true
                                                },
                                                "optional": {
                                                    "type": "boolean",
                                                    "nullable": true
                                                }
                                            },
                                            "required": [
                                                "key"
                                            ],
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "settings": {
                                            "type": "object",
                                            "properties": {},
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "dataVolumeClaimSpec": {
                                    "properties": {
                                        "accessModes": {
                                            "items": {
                                                "type": "string"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        },
                                        "dataSource": {
                                            "properties": {
                                                "apiGroup": {
                                                    "type": "string",
                                                    "nullable": true
                                                },
                                                "kind": {
                                                    "type": "string"
                                                },
                                                "name": {
                                                    "type": "string"
                                                }
                                            },
                                            "required": [
                                                "kind",
                                                "name"
                                            ],
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "resources": {
                                            "properties": {
                                                "limits": {
                                                    "additionalProperties": {
                                                        "anyOf": [
                                                            {
                                                                "type": "integer"
                                                            },
                                                            {
                                                                "type": "string"
                                                            }
                                                        ],
                                                        "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                    },
                                                    "type": "object",
                                                    "properties": {},
                                                    "nullable": true
                                                },
                                                "requests": {
                                                    "additionalProperties": {
                                                        "anyOf": [
                                                            {
                                                                "type": "integer"
                                                            },
                                                            {
                                                                "type": "string"
                                                            }
                                                        ],
                                                        "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                                    },
                                                    "type": "object",
                                                    "properties": {},
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "selector": {
                                            "properties": {
                                                "matchExpressions": {
                                                    "items": {
                                                        "properties": {
                                                            "key": {
                                                                "type": "string"
                                                            },
                                                            "operator": {
                                                                "type": "string"
                                                            },
                                                            "values": {
                                                                "items": {
                                                                    "type": "string"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "required": [
                                                            "key",
                                                            "operator"
                                                        ],
                                                        "type": "object"
                                                    },
                                                    "type": "array",
                                                    "nullable": true
                                                },
                                                "matchLabels": {
                                                    "additionalProperties": {
                                                        "type": "string"
                                                    },
                                                    "type": "object",
                                                    "properties": {},
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "storageClassName": {
                                            "type": "string",
                                            "nullable": true
                                        },
                                        "volumeMode": {
                                            "type": "string",
                                            "nullable": true
                                        },
                                        "volumeName": {
                                            "type": "string",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object"
                                },
                                "image": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "metadata": {
                                    "properties": {
                                        "annotations": {
                                            "additionalProperties": {
                                                "type": "string"
                                            },
                                            "type": "object",
                                            "properties": {},
                                            "nullable": true
                                        },
                                        "labels": {
                                            "additionalProperties": {
                                                "type": "string"
                                            },
                                            "type": "object",
                                            "properties": {},
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "priorityClassName": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "replicas": {
                                    "default": 1,
                                    "format": "int32",
                                    "type": "integer",
                                    "minimum": 0,
                                    "maximum": 1,
                                    "nullable": true
                                },
                                "resources": {
                                    "properties": {
                                        "limits": {
                                            "additionalProperties": {
                                                "anyOf": [
                                                    {
                                                        "type": "integer"
                                                    },
                                                    {
                                                        "type": "string"
                                                    }
                                                ],
                                                "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                            },
                                            "type": "object",
                                            "properties": {},
                                            "nullable": true
                                        },
                                        "requests": {
                                            "additionalProperties": {
                                                "anyOf": [
                                                    {
                                                        "type": "integer"
                                                    },
                                                    {
                                                        "type": "string"
                                                    }
                                                ],
                                                "pattern": "^(\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))(([KMGTPE]i)|[numkMGTPE]|([eE](\\+|-)?(([0-9]+(\\.[0-9]*)?)|(\\.[0-9]+))))?$"
                                            },
                                            "type": "object",
                                            "properties": {},
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "service": {
                                    "properties": {
                                        "metadata": {
                                            "properties": {
                                                "annotations": {
                                                    "additionalProperties": {
                                                        "type": "string"
                                                    },
                                                    "type": "object",
                                                    "properties": {},
                                                    "nullable": true
                                                },
                                                "labels": {
                                                    "additionalProperties": {
                                                        "type": "string"
                                                    },
                                                    "type": "object",
                                                    "properties": {},
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object",
                                            "nullable": true
                                        },
                                        "nodePort": {
                                            "format": "int32",
                                            "type": "integer",
                                            "nullable": true
                                        },
                                        "type": {
                                            "default": "ClusterIP",
                                            "enum": [
                                                "ClusterIP",
                                                "NodePort",
                                                "LoadBalancer"
                                            ],
                                            "type": "string",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                },
                                "tolerations": {
                                    "items": {
                                        "properties": {
                                            "effect": {
                                                "type": "string",
                                                "nullable": true
                                            },
                                            "key": {
                                                "type": "string",
                                                "nullable": true
                                            },
                                            "operator": {
                                                "type": "string",
                                                "nullable": true
                                            },
                                            "tolerationSeconds": {
                                                "format": "int64",
                                                "type": "integer",
                                                "nullable": true
                                            },
                                            "value": {
                                                "type": "string",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object"
                                    },
                                    "type": "array",
                                    "nullable": true
                                },
                                "topologySpreadConstraints": {
                                    "items": {
                                        "properties": {
                                            "labelSelector": {
                                                "properties": {
                                                    "matchExpressions": {
                                                        "items": {
                                                            "properties": {
                                                                "key": {
                                                                    "type": "string"
                                                                },
                                                                "operator": {
                                                                    "type": "string"
                                                                },
                                                                "values": {
                                                                    "items": {
                                                                        "type": "string"
                                                                    },
                                                                    "type": "array",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "required": [
                                                                "key",
                                                                "operator"
                                                            ],
                                                            "type": "object"
                                                        },
                                                        "type": "array",
                                                        "nullable": true
                                                    },
                                                    "matchLabels": {
                                                        "additionalProperties": {
                                                            "type": "string"
                                                        },
                                                        "type": "object",
                                                        "properties": {},
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "maxSkew": {
                                                "format": "int32",
                                                "type": "integer"
                                            },
                                            "topologyKey": {
                                                "type": "string"
                                            },
                                            "whenUnsatisfiable": {
                                                "type": "string"
                                            }
                                        },
                                        "required": [
                                            "maxSkew",
                                            "topologyKey",
                                            "whenUnsatisfiable"
                                        ],
                                        "type": "object"
                                    },
                                    "type": "array",
                                    "nullable": true
                                }
                            },
                            "required": [
                                "dataVolumeClaimSpec"
                            ],
                            "type": "object"
                        }
                    },
                    "required": [
                        "pgAdmin"
                    ],
                    "type": "object",
                    "nullable": true
                },
                "users": {
                    "items": {
                        "properties": {
                            "databases": {
                                "items": {
                                    "maxLength": 63,
                                    "minLength": 1,
                                    "type": "string"
                                },
                                "type": "array",
                                "nullable": true
                            },
                            "name": {
                                "maxLength": 63,
                                "minLength": 1,
                                "type": "string",
                                "pattern": "^[a-z0-9]([-a-z0-9]*[a-z0-9])?$"
                            },
                            "options": {
                                "type": "string",
                                "pattern": "^[^;]*$",
                                "nullable": true
                            },
                            "password": {
                                "properties": {
                                    "type": {
                                        "default": "ASCII",
                                        "enum": [
                                            "ASCII",
                                            "AlphaNumeric"
                                        ],
                                        "type": "string"
                                    }
                                },
                                "required": [
                                    "type"
                                ],
                                "type": "object",
                                "nullable": true
                            }
                        },
                        "required": [
                            "name"
                        ],
                        "type": "object"
                    },
                    "type": "array",
                    "nullable": true
                }
            },
            "required": [
                "backups",
                "instances",
                "postgresVersion"
            ],
            "type": "object",
            "nullable": true
        },
        "status": {
            "properties": {
                "conditions": {
                    "items": {
                        "properties": {
                            "lastTransitionTime": {
                                "format": "date-time",
                                "type": "string"
                            },
                            "message": {
                                "maxLength": 32768,
                                "type": "string"
                            },
                            "observedGeneration": {
                                "format": "int64",
                                "type": "integer",
                                "minimum": 0,
                                "nullable": true
                            },
                            "reason": {
                                "maxLength": 1024,
                                "minLength": 1,
                                "type": "string",
                                "pattern": "^[A-Za-z]([A-Za-z0-9_,:]*[A-Za-z0-9_])?$"
                            },
                            "status": {
                                "enum": [
                                    "True",
                                    "False",
                                    "Unknown"
                                ],
                                "type": "string"
                            },
                            "type": {
                                "maxLength": 316,
                                "type": "string",
                                "pattern": "^([a-z0-9]([-a-z0-9]*[a-z0-9])?(\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*\\/)?(([A-Za-z0-9][-A-Za-z0-9_.]*)?[A-Za-z0-9])$"
                            }
                        },
                        "required": [
                            "lastTransitionTime",
                            "message",
                            "reason",
                            "status",
                            "type"
                        ],
                        "type": "object"
                    },
                    "type": "array",
                    "nullable": true
                },
                "databaseInitSQL": {
                    "type": "string",
                    "nullable": true
                },
                "databaseRevision": {
                    "type": "string",
                    "nullable": true
                },
                "instances": {
                    "items": {
                        "properties": {
                            "name": {
                                "type": "string"
                            },
                            "readyReplicas": {
                                "format": "int32",
                                "type": "integer",
                                "nullable": true
                            },
                            "replicas": {
                                "format": "int32",
                                "type": "integer",
                                "nullable": true
                            },
                            "updatedReplicas": {
                                "format": "int32",
                                "type": "integer",
                                "nullable": true
                            }
                        },
                        "required": [
                            "name"
                        ],
                        "type": "object"
                    },
                    "type": "array",
                    "nullable": true
                },
                "monitoring": {
                    "properties": {
                        "exporterConfiguration": {
                            "type": "string",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "observedGeneration": {
                    "format": "int64",
                    "type": "integer",
                    "minimum": 0,
                    "nullable": true
                },
                "patroni": {
                    "properties": {
                        "switchover": {
                            "type": "string",
                            "nullable": true
                        },
                        "switchoverTimeline": {
                            "format": "int64",
                            "type": "integer",
                            "nullable": true
                        },
                        "systemIdentifier": {
                            "type": "string",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "pgbackrest": {
                    "properties": {
                        "manualBackup": {
                            "properties": {
                                "active": {
                                    "format": "int32",
                                    "type": "integer",
                                    "nullable": true
                                },
                                "completionTime": {
                                    "format": "date-time",
                                    "type": "string",
                                    "nullable": true
                                },
                                "failed": {
                                    "format": "int32",
                                    "type": "integer",
                                    "nullable": true
                                },
                                "finished": {
                                    "type": "boolean"
                                },
                                "id": {
                                    "type": "string"
                                },
                                "startTime": {
                                    "format": "date-time",
                                    "type": "string",
                                    "nullable": true
                                },
                                "succeeded": {
                                    "format": "int32",
                                    "type": "integer",
                                    "nullable": true
                                }
                            },
                            "required": [
                                "finished",
                                "id"
                            ],
                            "type": "object",
                            "nullable": true
                        },
                        "repoHost": {
                            "properties": {
                                "apiVersion": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "kind": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "ready": {
                                    "type": "boolean",
                                    "nullable": true
                                }
                            },
                            "type": "object",
                            "nullable": true
                        },
                        "repos": {
                            "items": {
                                "properties": {
                                    "bound": {
                                        "type": "boolean",
                                        "nullable": true
                                    },
                                    "name": {
                                        "type": "string"
                                    },
                                    "replicaCreateBackupComplete": {
                                        "type": "boolean",
                                        "nullable": true
                                    },
                                    "repoOptionsHash": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "stanzaCreated": {
                                        "type": "boolean",
                                        "nullable": true
                                    },
                                    "volume": {
                                        "type": "string",
                                        "nullable": true
                                    }
                                },
                                "required": [
                                    "name"
                                ],
                                "type": "object"
                            },
                            "type": "array",
                            "nullable": true
                        },
                        "restore": {
                            "properties": {
                                "active": {
                                    "format": "int32",
                                    "type": "integer",
                                    "nullable": true
                                },
                                "completionTime": {
                                    "format": "date-time",
                                    "type": "string",
                                    "nullable": true
                                },
                                "failed": {
                                    "format": "int32",
                                    "type": "integer",
                                    "nullable": true
                                },
                                "finished": {
                                    "type": "boolean"
                                },
                                "id": {
                                    "type": "string"
                                },
                                "startTime": {
                                    "format": "date-time",
                                    "type": "string",
                                    "nullable": true
                                },
                                "succeeded": {
                                    "format": "int32",
                                    "type": "integer",
                                    "nullable": true
                                }
                            },
                            "required": [
                                "finished",
                                "id"
                            ],
                            "type": "object",
                            "nullable": true
                        },
                        "scheduledBackups": {
                            "items": {
                                "properties": {
                                    "active": {
                                        "format": "int32",
                                        "type": "integer",
                                        "nullable": true
                                    },
                                    "completionTime": {
                                        "format": "date-time",
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "cronJobName": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "failed": {
                                        "format": "int32",
                                        "type": "integer",
                                        "nullable": true
                                    },
                                    "repo": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "startTime": {
                                        "format": "date-time",
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "succeeded": {
                                        "format": "int32",
                                        "type": "integer",
                                        "nullable": true
                                    },
                                    "type": {
                                        "type": "string",
                                        "nullable": true
                                    }
                                },
                                "type": "object"
                            },
                            "type": "array",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "postgresVersion": {
                    "type": "integer",
                    "nullable": true
                },
                "proxy": {
                    "properties": {
                        "pgBouncer": {
                            "properties": {
                                "postgresRevision": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "readyReplicas": {
                                    "format": "int32",
                                    "type": "integer",
                                    "nullable": true
                                },
                                "replicas": {
                                    "format": "int32",
                                    "type": "integer",
                                    "nullable": true
                                }
                            },
                            "type": "object",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "startupInstance": {
                    "type": "string",
                    "nullable": true
                },
                "startupInstanceSet": {
                    "type": "string",
                    "nullable": true
                },
                "userInterface": {
                    "properties": {
                        "pgAdmin": {
                            "properties": {
                                "usersRevision": {
                                    "type": "string",
                                    "nullable": true
                                }
                            },
                            "type": "object",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "usersRevision": {
                    "type": "string",
                    "nullable": true
                }
            },
            "type": "object",
            "nullable": true
        }
    },
    "required": [
        "apiVersion",
        "kind"
    ]
};
/**
 * PostgresCluster is the Schema for the postgresclusters API
 */
class PostgresCluster extends base_1.Model {
    constructor(data) {
        super({
            apiVersion: PostgresCluster.apiVersion,
            kind: PostgresCluster.kind,
            ...data
        });
    }
}
exports.PostgresCluster = PostgresCluster;
PostgresCluster.apiVersion = "postgres-operator.crunchydata.com/v1beta1";
PostgresCluster.kind = "PostgresCluster";
PostgresCluster.is = (0, base_1.createTypeMetaGuard)(PostgresCluster);
(0, base_1.setSchema)(PostgresCluster, schemaId, () => {
    (0, IoK8sApimachineryPkgApisMetaV1ObjectMeta_1.addSchema)();
    (0, validate_1.register)(schemaId, schema);
});
